<?php
/**
 * GREYHOUND PHP API
 *
 * Copyright (c) 2011-2021 GREYHOUND Software GmbH & Co. KG
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of the GREYHOUND PHP API and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including without
 * limitation the rights to use, copy, modify, merge, publish, distribute,
 * sublicense, and/or sell copies of the Software, and to permit persons to
 * whom the Software is furnished to do so, subject to the following
 * conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
 * IN THE SOFTWARE.
 */


/**
 * RPC-Unit rpc_campaignslib.
 *
 * @package GhRpc
 * @subpackage rpc_campaignslib
 * @category PHP-RPC-Units
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2021 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class rpc_campaignslib extends GhRpcLibrary
{
  // RpcCampaignHasRecurrence Konstanten:

  /**
   * chrYes Konstante (gehört zum Enum: RpcCampaignHasRecurrence).
   */
  const chrYes = 0;
  /**
   * chrNo Konstante (gehört zum Enum: RpcCampaignHasRecurrence).
   */
  const chrNo = 1;

  // RpcCampaignRecurrenceType Konstanten:

  /**
   * crtDaily Konstante (gehört zum Enum: RpcCampaignRecurrenceType).
   */
  const crtDaily = 0;
  /**
   * crtWeekly Konstante (gehört zum Enum: RpcCampaignRecurrenceType).
   */
  const crtWeekly = 1;
  /**
   * crtMonthly Konstante (gehört zum Enum: RpcCampaignRecurrenceType).
   */
  const crtMonthly = 2;
  /**
   * crtYearly Konstante (gehört zum Enum: RpcCampaignRecurrenceType).
   */
  const crtYearly = 3;

  // RpcCampaignOccurDay Konstanten:

  /**
   * codMonday Konstante (gehört zum Enum: RpcCampaignOccurDay).
   */
  const codMonday = 0;
  /**
   * codTuesday Konstante (gehört zum Enum: RpcCampaignOccurDay).
   */
  const codTuesday = 1;
  /**
   * codWednesday Konstante (gehört zum Enum: RpcCampaignOccurDay).
   */
  const codWednesday = 2;
  /**
   * codThursday Konstante (gehört zum Enum: RpcCampaignOccurDay).
   */
  const codThursday = 3;
  /**
   * codFriday Konstante (gehört zum Enum: RpcCampaignOccurDay).
   */
  const codFriday = 4;
  /**
   * codSaturday Konstante (gehört zum Enum: RpcCampaignOccurDay).
   */
  const codSaturday = 5;
  /**
   * codSunday Konstante (gehört zum Enum: RpcCampaignOccurDay).
   */
  const codSunday = 6;

  // RpcCampaignDayType Konstanten:

  /**
   * cdtDay Konstante (gehört zum Enum: RpcCampaignDayType).
   */
  const cdtDay = 0;
  /**
   * cdtEveryday Konstante (gehört zum Enum: RpcCampaignDayType).
   */
  const cdtEveryday = 1;
  /**
   * cdtWeekday Konstante (gehört zum Enum: RpcCampaignDayType).
   */
  const cdtWeekday = 2;
  /**
   * cdtWeekendday Konstante (gehört zum Enum: RpcCampaignDayType).
   */
  const cdtWeekendday = 3;
  /**
   * cdtSunday Konstante (gehört zum Enum: RpcCampaignDayType).
   */
  const cdtSunday = 4;
  /**
   * cdtMonday Konstante (gehört zum Enum: RpcCampaignDayType).
   */
  const cdtMonday = 5;
  /**
   * cdtTuesday Konstante (gehört zum Enum: RpcCampaignDayType).
   */
  const cdtTuesday = 6;
  /**
   * cdtWednesday Konstante (gehört zum Enum: RpcCampaignDayType).
   */
  const cdtWednesday = 7;
  /**
   * cdtThursday Konstante (gehört zum Enum: RpcCampaignDayType).
   */
  const cdtThursday = 8;
  /**
   * cdtFriday Konstante (gehört zum Enum: RpcCampaignDayType).
   */
  const cdtFriday = 9;
  /**
   * cdtSaturday Konstante (gehört zum Enum: RpcCampaignDayType).
   */
  const cdtSaturday = 10;

  // RpcCampaignItemState Konstanten:

  /**
   * cisUnsent Konstante (gehört zum Enum: RpcCampaignItemState).
   */
  const cisUnsent = 0;
  /**
   * cisSent Konstante (gehört zum Enum: RpcCampaignItemState).
   */
  const cisSent = 1;
  /**
   * cisFailure Konstante (gehört zum Enum: RpcCampaignItemState).
   */
  const cisFailure = 2;

  // RpcCampaignState Konstanten:

  /**
   * csUnsent Konstante (gehört zum Enum: RpcCampaignState).
   */
  const csUnsent = 0;
  /**
   * csSending Konstante (gehört zum Enum: RpcCampaignState).
   */
  const csSending = 1;
  /**
   * csSent Konstante (gehört zum Enum: RpcCampaignState).
   */
  const csSent = 2;
  /**
   * csFailure Konstante (gehört zum Enum: RpcCampaignState).
   */
  const csFailure = 3;

  // RpcLockState Konstanten:

  /**
   * IsUnlocked Konstante (gehört zum Enum: RpcLockState).
   */
  const IsUnlocked = 0;
  /**
   * IsModified Konstante (gehört zum Enum: RpcLockState).
   */
  const IsModified = 1;
  /**
   * IsLocked Konstante (gehört zum Enum: RpcLockState).
   */
  const IsLocked = 2;

  /**
   * Hilfskonstante, die ein Set darstellt, in dem alle Enums gesetzt sind.
   * @var int
   */
  const SET_ALL = -1;


  /**
   * Erzeugt eine Instanz des RPC-Dienstes RpcCampaigns.
   *
   * @param GhRpcClient $client Client Instanz
   *
   * @return GhRpcCampaignslibRpcCampaigns
   */
  public static function newRpcCampaigns(GhRpcClient $client)
  {
    return new GhRpcCampaignslibRpcCampaigns($client);
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcCampaignRecurrence.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcCampaignslibRpcCampaignRecurrence
   */
  public static function newRpcCampaignRecurrence($fillProperties = false)
  {
    $object = new GhRpcCampaignslibRpcCampaignRecurrence();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcCampaignItem.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcCampaignslibRpcCampaignItem
   */
  public static function newRpcCampaignItem($fillProperties = false)
  {
    $object = new GhRpcCampaignslibRpcCampaignItem();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcDetailedCampaign.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcCampaignslibRpcDetailedCampaign
   */
  public static function newRpcDetailedCampaign($fillProperties = false)
  {
    $object = new GhRpcCampaignslibRpcDetailedCampaign();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcCampaign.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcCampaignslibRpcCampaign
   */
  public static function newRpcCampaign($fillProperties = false)
  {
    $object = new GhRpcCampaignslibRpcCampaign();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcLockData.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcCampaignslibRpcLockData
   */
  public static function newRpcLockData($fillProperties = false)
  {
    $object = new GhRpcCampaignslibRpcLockData();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }
}


/**
 * RPC-Struct RpcCampaignItemList.
 *
 * @package GhRpc
 * @subpackage rpc_campaignslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2021 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcCampaignslibRpcLockData extends GhRpcStruct
{
  /**
   * LockState
   * @var int
   */
  public $LockState;

  /**
   * UserRef
   * @var int
   */
  public $UserRef;

  /**
   * UserName
   * @var string
   */
  public $UserName;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'LockState' => 'int',
    'UserRef' => 'int',
    'UserName' => 'string',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcCampaignItemList.
 *
 * @package GhRpc
 * @subpackage rpc_campaignslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2021 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcCampaignslibRpcCampaign extends GhRpcStruct
{
  /**
   * ID
   * @var int
   */
  public $ID;

  /**
   * State
   * @var int
   */
  public $State;

  /**
   * Name
   * @var string
   */
  public $Name;

  /**
   * CountCreated
   * @var int
   */
  public $CountCreated;

  /**
   * CountSent
   * @var int
   */
  public $CountSent;

  /**
   * CountTotal
   * @var int
   */
  public $CountTotal;

  /**
   * Recipients
   * @var string
   */
  public $Recipients;

  /**
   * Sent
   * @var GhRpcDateTime
   */
  public $Sent;

  /**
   * LockData
   * @var GhRpcCampaignslibRpcLockData
   */
  public $LockData;

  /**
   * Created
   * @var GhRpcDateTime
   */
  public $Created;

  /**
   * Modified
   * @var GhRpcDateTime
   */
  public $Modified;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'ID' => 'int',
    'State' => 'int',
    'Name' => 'string',
    'CountCreated' => 'int',
    'CountSent' => 'int',
    'CountTotal' => 'int',
    'Recipients' => 'string',
    'Sent' => 'GhRpcDateTime',
    'LockData' => 'GhRpcCampaignslibRpcLockData',
    'Created' => 'GhRpcDateTime',
    'Modified' => 'GhRpcDateTime',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcCampaignItemList.
 *
 * @package GhRpc
 * @subpackage rpc_campaignslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2021 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcCampaignslibRpcDetailedCampaign extends GhRpcStruct
{
  /**
   * ID
   * @var int
   */
  public $ID;

  /**
   * State
   * @var int
   */
  public $State;

  /**
   * Name
   * @var string
   */
  public $Name;

  /**
   * FilterRef
   * @var int
   */
  public $FilterRef;

  /**
   * ItemRef
   * @var int
   */
  public $ItemRef;

  /**
   * CountCreated
   * @var int
   */
  public $CountCreated;

  /**
   * CountSent
   * @var int
   */
  public $CountSent;

  /**
   * CountTotal
   * @var int
   */
  public $CountTotal;

  /**
   * Recipients
   * @var string
   */
  public $Recipients;

  /**
   * TryRecipients
   * @var int
   */
  public $TryRecipients;

  /**
   * Sent
   * @var GhRpcDateTime
   */
  public $Sent;

  /**
   * HasRecurrence
   * @var int
   */
  public $HasRecurrence;

  /**
   * Recurrence
   * @var GhRpcCampaignslibRpcCampaignRecurrence
   */
  public $Recurrence;

  /**
   * LockData
   * @var GhRpcCampaignslibRpcLockData
   */
  public $LockData;

  /**
   * Created
   * @var GhRpcDateTime
   */
  public $Created;

  /**
   * Modified
   * @var GhRpcDateTime
   */
  public $Modified;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'ID' => 'int',
    'State' => 'int',
    'Name' => 'string',
    'FilterRef' => 'int',
    'ItemRef' => 'int',
    'CountCreated' => 'int',
    'CountSent' => 'int',
    'CountTotal' => 'int',
    'Recipients' => 'string',
    'TryRecipients' => 'int',
    'Sent' => 'GhRpcDateTime',
    'HasRecurrence' => 'int',
    'Recurrence' => 'GhRpcCampaignslibRpcCampaignRecurrence',
    'LockData' => 'GhRpcCampaignslibRpcLockData',
    'Created' => 'GhRpcDateTime',
    'Modified' => 'GhRpcDateTime',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcCampaignItemList.
 *
 * @package GhRpc
 * @subpackage rpc_campaignslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2021 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcCampaignslibRpcCampaignItem extends GhRpcStruct
{
  /**
   * ItemRef
   * @var int
   */
  public $ItemRef;

  /**
   * RecipientRef
   * @var int
   */
  public $RecipientRef;

  /**
   * State
   * @var int
   */
  public $State;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'ItemRef' => 'int',
    'RecipientRef' => 'int',
    'State' => 'int',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcCampaignItemList.
 *
 * @package GhRpc
 * @subpackage rpc_campaignslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2021 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcCampaignslibRpcCampaignRecurrence extends GhRpcStruct
{
  /**
   * ID
   * @var int
   */
  public $ID;

  /**
   * Count
   * @var int
   */
  public $Count;

  /**
   * DayNumber
   * @var int
   */
  public $DayNumber;

  /**
   * DayType
   * @var int
   */
  public $DayType;

  /**
   * OccurDays
   * @var int
   */
  public $OccurDays;

  /**
   * Recurrence
   * @var int
   */
  public $Recurrence;

  /**
   * Periodicity
   * @var int
   */
  public $Periodicity;

  /**
   * StartDate
   * @var GhRpcDateTime
   */
  public $StartDate;

  /**
   * EndDate
   * @var GhRpcDateTime
   */
  public $EndDate;

  /**
   * NextOccurrence
   * @var GhRpcDateTime
   */
  public $NextOccurrence;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'ID' => 'int',
    'Count' => 'int',
    'DayNumber' => 'int',
    'DayType' => 'int',
    'OccurDays' => 'int',
    'Recurrence' => 'int',
    'Periodicity' => 'int',
    'StartDate' => 'GhRpcDateTime',
    'EndDate' => 'GhRpcDateTime',
    'NextOccurrence' => 'GhRpcDateTime',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Dienst RpcCampaigns
 *
 * @package GhRpc
 * @subpackage rpc_campaignslib
 * @category PHP-RPC-Dienste
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2021 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcCampaignslibRpcCampaigns extends GhRpcService
{
  /**
   * RPC-Methoden mit Parametern und Ergebnistypen.
   * @var array
   */
  protected static $_rpcMethods = array(
    'GetLockData' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => 'GhRpcCampaignslibRpcLockData',
    ),
    'Unlock' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => '',
    ),
    'Lock' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => '',
    ),
    'GetItemList' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => 'array:GhRpcCampaignslibRpcCampaignItem',
    ),
    'Send' => array(
      'params' => array(
        'ID' => 'int',
        'TryRecipients' => 'int',
      ),
      'return' => '',
    ),
    'Delete' => array(
      'params' => array(
        'ID' => 'int',
        'DeleteItems' => 'boolean',
      ),
      'return' => '',
    ),
    'Put' => array(
      'params' => array(
        'Campaign' => 'GhRpcCampaignslibRpcDetailedCampaign',
      ),
      'return' => '',
    ),
    'New_' => array(
      'params' => array(
        'Campaign' => 'GhRpcCampaignslibRpcDetailedCampaign',
      ),
      'return' => 'int',
    ),
    'GetList' => array(
      'params' => array(
      ),
      'return' => 'array:GhRpcCampaignslibRpcCampaign',
    ),
    'Get' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => 'GhRpcCampaignslibRpcDetailedCampaign',
    ),
  );


  /**
   * Ruft die RPC-Funktion RpcCampaigns.Get auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   *
   * @return GhRpcCampaignslibRpcDetailedCampaign
   */
  public function Get($ID = 0)
  {
    return $this->_sendRpcRequest('RpcCampaigns.Get', array($ID), self::$_rpcMethods['Get']);
  }

  /**
   * Ruft die RPC-Funktion RpcCampaigns.GetList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @return array
   */
  public function GetList()
  {
    return $this->_sendRpcRequest('RpcCampaigns.GetList', array(), self::$_rpcMethods['GetList']);
  }

  /**
   * Ruft die RPC-Funktion RpcCampaigns.New auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param GhRpcCampaignslibRpcDetailedCampaign $Campaign
   *
   * @return int
   */
  public function New_(GhRpcCampaignslibRpcDetailedCampaign $Campaign = null)
  {
    return $this->_sendRpcRequest('RpcCampaigns.New', array($Campaign), self::$_rpcMethods['New_']);
  }

  /**
   * Ruft die RPC-Funktion RpcCampaigns.Put auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param GhRpcCampaignslibRpcDetailedCampaign $Campaign
   */
  public function Put(GhRpcCampaignslibRpcDetailedCampaign $Campaign = null)
  {
    return $this->_sendRpcRequest('RpcCampaigns.Put', array($Campaign), self::$_rpcMethods['Put']);
  }

  /**
   * Ruft die RPC-Funktion RpcCampaigns.Delete auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param boolean $DeleteItems
   */
  public function Delete($ID = 0, $DeleteItems = false)
  {
    return $this->_sendRpcRequest('RpcCampaigns.Delete', array($ID, $DeleteItems), self::$_rpcMethods['Delete']);
  }

  /**
   * Ruft die RPC-Funktion RpcCampaigns.Send auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param int $TryRecipients
   */
  public function Send($ID = 0, $TryRecipients = 0)
  {
    return $this->_sendRpcRequest('RpcCampaigns.Send', array($ID, $TryRecipients), self::$_rpcMethods['Send']);
  }

  /**
   * Ruft die RPC-Funktion RpcCampaigns.GetItemList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   *
   * @return array
   */
  public function GetItemList($ID = 0)
  {
    return $this->_sendRpcRequest('RpcCampaigns.GetItemList', array($ID), self::$_rpcMethods['GetItemList']);
  }

  /**
   * Ruft die RPC-Funktion RpcCampaigns.Lock auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   */
  public function Lock($ID = 0)
  {
    return $this->_sendRpcRequest('RpcCampaigns.Lock', array($ID), self::$_rpcMethods['Lock']);
  }

  /**
   * Ruft die RPC-Funktion RpcCampaigns.Unlock auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   */
  public function Unlock($ID = 0)
  {
    return $this->_sendRpcRequest('RpcCampaigns.Unlock', array($ID), self::$_rpcMethods['Unlock']);
  }

  /**
   * Ruft die RPC-Funktion RpcCampaigns.GetLockData auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   *
   * @return GhRpcCampaignslibRpcLockData
   */
  public function GetLockData($ID = 0)
  {
    return $this->_sendRpcRequest('RpcCampaigns.GetLockData', array($ID), self::$_rpcMethods['GetLockData']);
  }
}
