<?php
/**
 * GREYHOUND PHP API
 *
 * Copyright (c) 2011-2021 GREYHOUND Software GmbH & Co. KG
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of the GREYHOUND PHP API and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including without
 * limitation the rights to use, copy, modify, merge, publish, distribute,
 * sublicense, and/or sell copies of the Software, and to permit persons to
 * whom the Software is furnished to do so, subject to the following
 * conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
 * IN THE SOFTWARE.
 */


/**
 * RPC-Unit rpc_davsynclib.
 *
 * @package GhRpc
 * @subpackage rpc_davsynclib
 * @category PHP-RPC-Units
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2021 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class rpc_davsynclib extends GhRpcLibrary
{
  // RpcDavSyncSyncPhoto Konstanten:

  /**
   * dsspYes Konstante (gehört zum Enum: RpcDavSyncSyncPhoto).
   */
  const dsspYes = 0;
  /**
   * dsspNo Konstante (gehört zum Enum: RpcDavSyncSyncPhoto).
   */
  const dsspNo = 1;

  // RpcDavSyncUseProxy Konstanten:

  /**
   * dsupYes Konstante (gehört zum Enum: RpcDavSyncUseProxy).
   */
  const dsupYes = 0;
  /**
   * dsupNo Konstante (gehört zum Enum: RpcDavSyncUseProxy).
   */
  const dsupNo = 1;

  // RpcDavSyncSyncUserFields Konstanten:

  /**
   * dssufYes Konstante (gehört zum Enum: RpcDavSyncSyncUserFields).
   */
  const dssufYes = 0;
  /**
   * dssufNo Konstante (gehört zum Enum: RpcDavSyncSyncUserFields).
   */
  const dssufNo = 1;

  // RpcDavSyncUpSync Konstanten:

  /**
   * dsusYes Konstante (gehört zum Enum: RpcDavSyncUpSync).
   */
  const dsusYes = 0;
  /**
   * dsusNo Konstante (gehört zum Enum: RpcDavSyncUpSync).
   */
  const dsusNo = 1;

  // RpcDavSyncDownSync Konstanten:

  /**
   * dsdsYes Konstante (gehört zum Enum: RpcDavSyncDownSync).
   */
  const dsdsYes = 0;
  /**
   * dsdsNo Konstante (gehört zum Enum: RpcDavSyncDownSync).
   */
  const dsdsNo = 1;

  // RpcWorkSpace Konstanten:

  /**
   * wsSystem Konstante (gehört zum Enum: RpcWorkSpace).
   */
  const wsSystem = 0;
  /**
   * wsPersonal Konstante (gehört zum Enum: RpcWorkSpace).
   */
  const wsPersonal = 1;
  /**
   * wsForbidden Konstante (gehört zum Enum: RpcWorkSpace).
   */
  const wsForbidden = 2;

  // RpcDavSyncKind Konstanten:

  /**
   * dskContacts Konstante (gehört zum Enum: RpcDavSyncKind).
   */
  const dskContacts = 0;
  /**
   * dskCalendar Konstante (gehört zum Enum: RpcDavSyncKind).
   */
  const dskCalendar = 1;

  // RpcDavSyncState Konstanten:

  /**
   * dssInactive Konstante (gehört zum Enum: RpcDavSyncState).
   */
  const dssInactive = 0;
  /**
   * dssActive Konstante (gehört zum Enum: RpcDavSyncState).
   */
  const dssActive = 1;

  // RpcLockState Konstanten:

  /**
   * dlsUnlocked Konstante (gehört zum Enum: RpcLockState).
   */
  const dlsUnlocked = 0;
  /**
   * dlsModified Konstante (gehört zum Enum: RpcLockState).
   */
  const dlsModified = 1;
  /**
   * dlsLocked Konstante (gehört zum Enum: RpcLockState).
   */
  const dlsLocked = 2;

  /**
   * Hilfskonstante, die ein Set darstellt, in dem alle Enums gesetzt sind.
   * @var int
   */
  const SET_ALL = -1;


  /**
   * Erzeugt eine Instanz des RPC-Dienstes RpcDavSync.
   *
   * @param GhRpcClient $client Client Instanz
   *
   * @return GhRpcDavsynclibRpcDavSync
   */
  public static function newRpcDavSync(GhRpcClient $client)
  {
    return new GhRpcDavsynclibRpcDavSync($client);
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcDavSyncConnection.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcDavsynclibRpcDavSyncConnection
   */
  public static function newRpcDavSyncConnection($fillProperties = false)
  {
    $object = new GhRpcDavsynclibRpcDavSyncConnection();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcDavSyncAccount.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcDavsynclibRpcDavSyncAccount
   */
  public static function newRpcDavSyncAccount($fillProperties = false)
  {
    $object = new GhRpcDavsynclibRpcDavSyncAccount();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcLockData.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcDavsynclibRpcLockData
   */
  public static function newRpcLockData($fillProperties = false)
  {
    $object = new GhRpcDavsynclibRpcLockData();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }
}


/**
 * RPC-Struct RpcDavSyncAccountList.
 *
 * @package GhRpc
 * @subpackage rpc_davsynclib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2021 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcDavsynclibRpcLockData extends GhRpcStruct
{
  /**
   * LockState
   * @var int
   */
  public $LockState;

  /**
   * UserRef
   * @var int
   */
  public $UserRef;

  /**
   * UserName
   * @var string
   */
  public $UserName;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'LockState' => 'int',
    'UserRef' => 'int',
    'UserName' => 'string',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcDavSyncAccountList.
 *
 * @package GhRpc
 * @subpackage rpc_davsynclib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2021 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcDavsynclibRpcDavSyncAccount extends GhRpcStruct
{
  /**
   * ID
   * @var int
   */
  public $ID;

  /**
   * WorkSpace
   * @var int
   */
  public $WorkSpace;

  /**
   * State
   * @var int
   */
  public $State;

  /**
   * Kind
   * @var int
   */
  public $Kind;

  /**
   * Name
   * @var string
   */
  public $Name;

  /**
   * GroupName
   * @var string
   */
  public $GroupName;

  /**
   * DownSync
   * @var int
   */
  public $DownSync;

  /**
   * FilterRef
   * @var int
   */
  public $FilterRef;

  /**
   * ColorRef
   * @var int
   */
  public $ColorRef;

  /**
   * SyncUserFields
   * @var int
   */
  public $SyncUserFields;

  /**
   * SyncPhoto
   * @var int
   */
  public $SyncPhoto;

  /**
   * UpSync
   * @var int
   */
  public $UpSync;

  /**
   * UseProxy
   * @var int
   */
  public $UseProxy;

  /**
   * ProxyHost
   * @var string
   */
  public $ProxyHost;

  /**
   * ProxyPort
   * @var int
   */
  public $ProxyPort;

  /**
   * Host
   * @var string
   */
  public $Host;

  /**
   * Timeout
   * @var int
   */
  public $Timeout;

  /**
   * Username
   * @var string
   */
  public $Username;

  /**
   * Password
   * @var string
   */
  public $Password;

  /**
   * ResetSync
   * @var boolean
   */
  public $ResetSync;

  /**
   * LockData
   * @var GhRpcDavsynclibRpcLockData
   */
  public $LockData;

  /**
   * Created
   * @var GhRpcDateTime
   */
  public $Created;

  /**
   * Modified
   * @var GhRpcDateTime
   */
  public $Modified;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'ID' => 'int',
    'WorkSpace' => 'int',
    'State' => 'int',
    'Kind' => 'int',
    'Name' => 'string',
    'GroupName' => 'string',
    'DownSync' => 'int',
    'FilterRef' => 'int',
    'ColorRef' => 'int',
    'SyncUserFields' => 'int',
    'SyncPhoto' => 'int',
    'UpSync' => 'int',
    'UseProxy' => 'int',
    'ProxyHost' => 'string',
    'ProxyPort' => 'int',
    'Host' => 'string',
    'Timeout' => 'int',
    'Username' => 'string',
    'Password' => 'string',
    'ResetSync' => 'boolean',
    'LockData' => 'GhRpcDavsynclibRpcLockData',
    'Created' => 'GhRpcDateTime',
    'Modified' => 'GhRpcDateTime',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcDavSyncAccountList.
 *
 * @package GhRpc
 * @subpackage rpc_davsynclib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2021 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcDavsynclibRpcDavSyncConnection extends GhRpcStruct
{
  /**
   * Kind
   * @var int
   */
  public $Kind;

  /**
   * UseProxy
   * @var int
   */
  public $UseProxy;

  /**
   * ProxyHost
   * @var string
   */
  public $ProxyHost;

  /**
   * ProxyPort
   * @var int
   */
  public $ProxyPort;

  /**
   * Host
   * @var string
   */
  public $Host;

  /**
   * Timeout
   * @var int
   */
  public $Timeout;

  /**
   * Username
   * @var string
   */
  public $Username;

  /**
   * Password
   * @var string
   */
  public $Password;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'Kind' => 'int',
    'UseProxy' => 'int',
    'ProxyHost' => 'string',
    'ProxyPort' => 'int',
    'Host' => 'string',
    'Timeout' => 'int',
    'Username' => 'string',
    'Password' => 'string',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Dienst RpcDavSync
 *
 * @package GhRpc
 * @subpackage rpc_davsynclib
 * @category PHP-RPC-Dienste
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2021 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcDavsynclibRpcDavSync extends GhRpcService
{
  /**
   * RPC-Methoden mit Parametern und Ergebnistypen.
   * @var array
   */
  protected static $_rpcMethods = array(
    'GetLockData' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => 'GhRpcDavsynclibRpcLockData',
    ),
    'Unlock' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => '',
    ),
    'Lock' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => '',
    ),
    'CheckConnection' => array(
      'params' => array(
        'Connection' => 'GhRpcDavsynclibRpcDavSyncConnection',
      ),
      'return' => 'array:string',
    ),
    'Delete' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => '',
    ),
    'Put' => array(
      'params' => array(
        'Account' => 'GhRpcDavsynclibRpcDavSyncAccount',
      ),
      'return' => '',
    ),
    'New_' => array(
      'params' => array(
        'Account' => 'GhRpcDavsynclibRpcDavSyncAccount',
      ),
      'return' => 'int',
    ),
    'GetCompleteList' => array(
      'params' => array(
      ),
      'return' => 'array:GhRpcDavsynclibRpcDavSyncAccount',
    ),
    'GetList' => array(
      'params' => array(
      ),
      'return' => 'array:GhRpcDavsynclibRpcDavSyncAccount',
    ),
    'Get' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => 'GhRpcDavsynclibRpcDavSyncAccount',
    ),
  );


  /**
   * Ruft die RPC-Funktion RpcDavSync.Get auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   *
   * @return GhRpcDavsynclibRpcDavSyncAccount
   */
  public function Get($ID = 0)
  {
    return $this->_sendRpcRequest('RpcDavSync.Get', array($ID), self::$_rpcMethods['Get']);
  }

  /**
   * Ruft die RPC-Funktion RpcDavSync.GetList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @return array
   */
  public function GetList()
  {
    return $this->_sendRpcRequest('RpcDavSync.GetList', array(), self::$_rpcMethods['GetList']);
  }

  /**
   * Ruft die RPC-Funktion RpcDavSync.GetCompleteList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @return array
   */
  public function GetCompleteList()
  {
    return $this->_sendRpcRequest('RpcDavSync.GetCompleteList', array(), self::$_rpcMethods['GetCompleteList']);
  }

  /**
   * Ruft die RPC-Funktion RpcDavSync.New auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param GhRpcDavsynclibRpcDavSyncAccount $Account
   *
   * @return int
   */
  public function New_(GhRpcDavsynclibRpcDavSyncAccount $Account = null)
  {
    return $this->_sendRpcRequest('RpcDavSync.New', array($Account), self::$_rpcMethods['New_']);
  }

  /**
   * Ruft die RPC-Funktion RpcDavSync.Put auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param GhRpcDavsynclibRpcDavSyncAccount $Account
   */
  public function Put(GhRpcDavsynclibRpcDavSyncAccount $Account = null)
  {
    return $this->_sendRpcRequest('RpcDavSync.Put', array($Account), self::$_rpcMethods['Put']);
  }

  /**
   * Ruft die RPC-Funktion RpcDavSync.Delete auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   */
  public function Delete($ID = 0)
  {
    return $this->_sendRpcRequest('RpcDavSync.Delete', array($ID), self::$_rpcMethods['Delete']);
  }

  /**
   * Ruft die RPC-Funktion RpcDavSync.CheckConnection auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param GhRpcDavsynclibRpcDavSyncConnection $Connection
   *
   * @return array
   */
  public function CheckConnection(GhRpcDavsynclibRpcDavSyncConnection $Connection = null)
  {
    return $this->_sendRpcRequest('RpcDavSync.CheckConnection', array($Connection), self::$_rpcMethods['CheckConnection']);
  }

  /**
   * Ruft die RPC-Funktion RpcDavSync.Lock auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   */
  public function Lock($ID = 0)
  {
    return $this->_sendRpcRequest('RpcDavSync.Lock', array($ID), self::$_rpcMethods['Lock']);
  }

  /**
   * Ruft die RPC-Funktion RpcDavSync.Unlock auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   */
  public function Unlock($ID = 0)
  {
    return $this->_sendRpcRequest('RpcDavSync.Unlock', array($ID), self::$_rpcMethods['Unlock']);
  }

  /**
   * Ruft die RPC-Funktion RpcDavSync.GetLockData auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   *
   * @return GhRpcDavsynclibRpcLockData
   */
  public function GetLockData($ID = 0)
  {
    return $this->_sendRpcRequest('RpcDavSync.GetLockData', array($ID), self::$_rpcMethods['GetLockData']);
  }
}
