<?php
/**
 * GREYHOUND PHP API
 *
 * Copyright (c) 2011-2021 GREYHOUND Software GmbH & Co. KG
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of the GREYHOUND PHP API and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including without
 * limitation the rights to use, copy, modify, merge, publish, distribute,
 * sublicense, and/or sell copies of the Software, and to permit persons to
 * whom the Software is furnished to do so, subject to the following
 * conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
 * IN THE SOFTWARE.
 */


/**
 * RPC-Unit rpc_googlesynclib.
 *
 * @package GhRpc
 * @subpackage rpc_googlesynclib
 * @category PHP-RPC-Units
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2021 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class rpc_googlesynclib extends GhRpcLibrary
{
  // RpcGoogleSyncSyncPhoto Konstanten:

  /**
   * gsspYes Konstante (gehört zum Enum: RpcGoogleSyncSyncPhoto).
   */
  const gsspYes = 0;
  /**
   * gsspNo Konstante (gehört zum Enum: RpcGoogleSyncSyncPhoto).
   */
  const gsspNo = 1;

  // RpcGoogleSyncUseProxy Konstanten:

  /**
   * gsupYes Konstante (gehört zum Enum: RpcGoogleSyncUseProxy).
   */
  const gsupYes = 0;
  /**
   * gsupNo Konstante (gehört zum Enum: RpcGoogleSyncUseProxy).
   */
  const gsupNo = 1;

  // RpcGoogleSyncSyncUserFields Konstanten:

  /**
   * gssufYes Konstante (gehört zum Enum: RpcGoogleSyncSyncUserFields).
   */
  const gssufYes = 0;
  /**
   * gssufNo Konstante (gehört zum Enum: RpcGoogleSyncSyncUserFields).
   */
  const gssufNo = 1;

  // RpcGoogleSyncUpSync Konstanten:

  /**
   * gsusYes Konstante (gehört zum Enum: RpcGoogleSyncUpSync).
   */
  const gsusYes = 0;
  /**
   * gsusNo Konstante (gehört zum Enum: RpcGoogleSyncUpSync).
   */
  const gsusNo = 1;

  // RpcGoogleSyncDownSync Konstanten:

  /**
   * gsdsYes Konstante (gehört zum Enum: RpcGoogleSyncDownSync).
   */
  const gsdsYes = 0;
  /**
   * gsdsNo Konstante (gehört zum Enum: RpcGoogleSyncDownSync).
   */
  const gsdsNo = 1;

  // RpcWorkSpace Konstanten:

  /**
   * wsSystem Konstante (gehört zum Enum: RpcWorkSpace).
   */
  const wsSystem = 0;
  /**
   * wsPersonal Konstante (gehört zum Enum: RpcWorkSpace).
   */
  const wsPersonal = 1;
  /**
   * wsForbidden Konstante (gehört zum Enum: RpcWorkSpace).
   */
  const wsForbidden = 2;

  // RpcGoogleSyncKind Konstanten:

  /**
   * gskContacts Konstante (gehört zum Enum: RpcGoogleSyncKind).
   */
  const gskContacts = 0;
  /**
   * gskCalendar Konstante (gehört zum Enum: RpcGoogleSyncKind).
   */
  const gskCalendar = 1;

  // RpcGoogleSyncState Konstanten:

  /**
   * gssInactive Konstante (gehört zum Enum: RpcGoogleSyncState).
   */
  const gssInactive = 0;
  /**
   * gssActive Konstante (gehört zum Enum: RpcGoogleSyncState).
   */
  const gssActive = 1;

  // RpcLockState Konstanten:

  /**
   * IsUnlocked Konstante (gehört zum Enum: RpcLockState).
   */
  const IsUnlocked = 0;
  /**
   * IsModified Konstante (gehört zum Enum: RpcLockState).
   */
  const IsModified = 1;
  /**
   * IsLocked Konstante (gehört zum Enum: RpcLockState).
   */
  const IsLocked = 2;

  /**
   * Hilfskonstante, die ein Set darstellt, in dem alle Enums gesetzt sind.
   * @var int
   */
  const SET_ALL = -1;


  /**
   * Erzeugt eine Instanz des RPC-Dienstes RpcGoogleSync.
   *
   * @param GhRpcClient $client Client Instanz
   *
   * @return GhRpcGooglesynclibRpcGoogleSync
   */
  public static function newRpcGoogleSync(GhRpcClient $client)
  {
    return new GhRpcGooglesynclibRpcGoogleSync($client);
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcGoogleSyncConnection.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcGooglesynclibRpcGoogleSyncConnection
   */
  public static function newRpcGoogleSyncConnection($fillProperties = false)
  {
    $object = new GhRpcGooglesynclibRpcGoogleSyncConnection();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcGoogleSyncAccount.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcGooglesynclibRpcGoogleSyncAccount
   */
  public static function newRpcGoogleSyncAccount($fillProperties = false)
  {
    $object = new GhRpcGooglesynclibRpcGoogleSyncAccount();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcLockData.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcGooglesynclibRpcLockData
   */
  public static function newRpcLockData($fillProperties = false)
  {
    $object = new GhRpcGooglesynclibRpcLockData();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }
}


/**
 * RPC-Struct RpcGoogleSyncAccountList.
 *
 * @package GhRpc
 * @subpackage rpc_googlesynclib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2021 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcGooglesynclibRpcLockData extends GhRpcStruct
{
  /**
   * LockState
   * @var int
   */
  public $LockState;

  /**
   * UserRef
   * @var int
   */
  public $UserRef;

  /**
   * UserName
   * @var string
   */
  public $UserName;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'LockState' => 'int',
    'UserRef' => 'int',
    'UserName' => 'string',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcGoogleSyncAccountList.
 *
 * @package GhRpc
 * @subpackage rpc_googlesynclib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2021 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcGooglesynclibRpcGoogleSyncAccount extends GhRpcStruct
{
  /**
   * ID
   * @var int
   */
  public $ID;

  /**
   * WorkSpace
   * @var int
   */
  public $WorkSpace;

  /**
   * State
   * @var int
   */
  public $State;

  /**
   * Kind
   * @var int
   */
  public $Kind;

  /**
   * Name
   * @var string
   */
  public $Name;

  /**
   * DownSync
   * @var int
   */
  public $DownSync;

  /**
   * FilterRef
   * @var int
   */
  public $FilterRef;

  /**
   * SyncUserFields
   * @var int
   */
  public $SyncUserFields;

  /**
   * SyncPhoto
   * @var int
   */
  public $SyncPhoto;

  /**
   * UpSync
   * @var int
   */
  public $UpSync;

  /**
   * UseProxy
   * @var int
   */
  public $UseProxy;

  /**
   * ProxyHost
   * @var string
   */
  public $ProxyHost;

  /**
   * ProxyPort
   * @var int
   */
  public $ProxyPort;

  /**
   * Timeout
   * @var int
   */
  public $Timeout;

  /**
   * Token
   * @var string
   */
  public $Token;

  /**
   * SyncToken
   * @var string
   */
  public $SyncToken;

  /**
   * ResetSync
   * @var boolean
   */
  public $ResetSync;

  /**
   * LockData
   * @var GhRpcGooglesynclibRpcLockData
   */
  public $LockData;

  /**
   * Created
   * @var GhRpcDateTime
   */
  public $Created;

  /**
   * Modified
   * @var GhRpcDateTime
   */
  public $Modified;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'ID' => 'int',
    'WorkSpace' => 'int',
    'State' => 'int',
    'Kind' => 'int',
    'Name' => 'string',
    'DownSync' => 'int',
    'FilterRef' => 'int',
    'SyncUserFields' => 'int',
    'SyncPhoto' => 'int',
    'UpSync' => 'int',
    'UseProxy' => 'int',
    'ProxyHost' => 'string',
    'ProxyPort' => 'int',
    'Timeout' => 'int',
    'Token' => 'string',
    'SyncToken' => 'string',
    'ResetSync' => 'boolean',
    'LockData' => 'GhRpcGooglesynclibRpcLockData',
    'Created' => 'GhRpcDateTime',
    'Modified' => 'GhRpcDateTime',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcGoogleSyncAccountList.
 *
 * @package GhRpc
 * @subpackage rpc_googlesynclib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2021 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcGooglesynclibRpcGoogleSyncConnection extends GhRpcStruct
{
  /**
   * Kind
   * @var int
   */
  public $Kind;

  /**
   * UseProxy
   * @var int
   */
  public $UseProxy;

  /**
   * ProxyHost
   * @var string
   */
  public $ProxyHost;

  /**
   * ProxyPort
   * @var int
   */
  public $ProxyPort;

  /**
   * Timeout
   * @var int
   */
  public $Timeout;

  /**
   * Token
   * @var string
   */
  public $Token;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'Kind' => 'int',
    'UseProxy' => 'int',
    'ProxyHost' => 'string',
    'ProxyPort' => 'int',
    'Timeout' => 'int',
    'Token' => 'string',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Dienst RpcGoogleSync
 *
 * @package GhRpc
 * @subpackage rpc_googlesynclib
 * @category PHP-RPC-Dienste
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2021 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcGooglesynclibRpcGoogleSync extends GhRpcService
{
  /**
   * RPC-Methoden mit Parametern und Ergebnistypen.
   * @var array
   */
  protected static $_rpcMethods = array(
    'GetLockData' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => 'GhRpcGooglesynclibRpcLockData',
    ),
    'Unlock' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => '',
    ),
    'Lock' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => '',
    ),
    'CheckConnection' => array(
      'params' => array(
        'Connection' => 'GhRpcGooglesynclibRpcGoogleSyncConnection',
      ),
      'return' => '',
    ),
    'Delete' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => '',
    ),
    'Put' => array(
      'params' => array(
        'Account' => 'GhRpcGooglesynclibRpcGoogleSyncAccount',
      ),
      'return' => '',
    ),
    'New_' => array(
      'params' => array(
        'Account' => 'GhRpcGooglesynclibRpcGoogleSyncAccount',
      ),
      'return' => 'int',
    ),
    'GetCompleteList' => array(
      'params' => array(
      ),
      'return' => 'array:GhRpcGooglesynclibRpcGoogleSyncAccount',
    ),
    'GetList' => array(
      'params' => array(
      ),
      'return' => 'array:GhRpcGooglesynclibRpcGoogleSyncAccount',
    ),
    'Get' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => 'GhRpcGooglesynclibRpcGoogleSyncAccount',
    ),
  );


  /**
   * Ruft die RPC-Funktion RpcGoogleSync.Get auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   *
   * @return GhRpcGooglesynclibRpcGoogleSyncAccount
   */
  public function Get($ID = 0)
  {
    return $this->_sendRpcRequest('RpcGoogleSync.Get', array($ID), self::$_rpcMethods['Get']);
  }

  /**
   * Ruft die RPC-Funktion RpcGoogleSync.GetList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @return array
   */
  public function GetList()
  {
    return $this->_sendRpcRequest('RpcGoogleSync.GetList', array(), self::$_rpcMethods['GetList']);
  }

  /**
   * Ruft die RPC-Funktion RpcGoogleSync.GetCompleteList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @return array
   */
  public function GetCompleteList()
  {
    return $this->_sendRpcRequest('RpcGoogleSync.GetCompleteList', array(), self::$_rpcMethods['GetCompleteList']);
  }

  /**
   * Ruft die RPC-Funktion RpcGoogleSync.New auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param GhRpcGooglesynclibRpcGoogleSyncAccount $Account
   *
   * @return int
   */
  public function New_(GhRpcGooglesynclibRpcGoogleSyncAccount $Account = null)
  {
    return $this->_sendRpcRequest('RpcGoogleSync.New', array($Account), self::$_rpcMethods['New_']);
  }

  /**
   * Ruft die RPC-Funktion RpcGoogleSync.Put auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param GhRpcGooglesynclibRpcGoogleSyncAccount $Account
   */
  public function Put(GhRpcGooglesynclibRpcGoogleSyncAccount $Account = null)
  {
    return $this->_sendRpcRequest('RpcGoogleSync.Put', array($Account), self::$_rpcMethods['Put']);
  }

  /**
   * Ruft die RPC-Funktion RpcGoogleSync.Delete auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   */
  public function Delete($ID = 0)
  {
    return $this->_sendRpcRequest('RpcGoogleSync.Delete', array($ID), self::$_rpcMethods['Delete']);
  }

  /**
   * Ruft die RPC-Funktion RpcGoogleSync.CheckConnection auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param GhRpcGooglesynclibRpcGoogleSyncConnection $Connection
   */
  public function CheckConnection(GhRpcGooglesynclibRpcGoogleSyncConnection $Connection = null)
  {
    return $this->_sendRpcRequest('RpcGoogleSync.CheckConnection', array($Connection), self::$_rpcMethods['CheckConnection']);
  }

  /**
   * Ruft die RPC-Funktion RpcGoogleSync.Lock auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   */
  public function Lock($ID = 0)
  {
    return $this->_sendRpcRequest('RpcGoogleSync.Lock', array($ID), self::$_rpcMethods['Lock']);
  }

  /**
   * Ruft die RPC-Funktion RpcGoogleSync.Unlock auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   */
  public function Unlock($ID = 0)
  {
    return $this->_sendRpcRequest('RpcGoogleSync.Unlock', array($ID), self::$_rpcMethods['Unlock']);
  }

  /**
   * Ruft die RPC-Funktion RpcGoogleSync.GetLockData auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   *
   * @return GhRpcGooglesynclibRpcLockData
   */
  public function GetLockData($ID = 0)
  {
    return $this->_sendRpcRequest('RpcGoogleSync.GetLockData', array($ID), self::$_rpcMethods['GetLockData']);
  }
}
