<?php
/**
 * GREYHOUND PHP API
 *
 * Copyright (c) 2011-2022 GREYHOUND Software GmbH & Co. KG
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of the GREYHOUND PHP API and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including without
 * limitation the rights to use, copy, modify, merge, publish, distribute,
 * sublicense, and/or sell copies of the Software, and to permit persons to
 * whom the Software is furnished to do so, subject to the following
 * conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
 * IN THE SOFTWARE.
 */


/**
 * RPC-Unit rpc_schemaslib.
 *
 * @package GhRpc
 * @subpackage rpc_schemaslib
 * @category PHP-RPC-Units
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class rpc_schemaslib extends GhRpcLibrary
{
  // RpcDateOperator Konstanten:

  /**
   * doLessEqual Konstante (gehört zum Enum: RpcDateOperator).
   */
  const doLessEqual = 0;
  /**
   * doLess Konstante (gehört zum Enum: RpcDateOperator).
   */
  const doLess = 1;
  /**
   * doEqual Konstante (gehört zum Enum: RpcDateOperator).
   */
  const doEqual = 2;
  /**
   * doGreater Konstante (gehört zum Enum: RpcDateOperator).
   */
  const doGreater = 3;
  /**
   * doGreaterEqual Konstante (gehört zum Enum: RpcDateOperator).
   */
  const doGreaterEqual = 4;

  // RpcDateField Konstanten:

  /**
   * dfStartDate Konstante (gehört zum Enum: RpcDateField).
   */
  const dfStartDate = 0;
  /**
   * dfEndDate Konstante (gehört zum Enum: RpcDateField).
   */
  const dfEndDate = 1;
  /**
   * dfCreated Konstante (gehört zum Enum: RpcDateField).
   */
  const dfCreated = 2;
  /**
   * dfModified Konstante (gehört zum Enum: RpcDateField).
   */
  const dfModified = 3;
  /**
   * dtNone Konstante (gehört zum Enum: RpcDateField).
   */
  const dtNone = 4;

  // RpcChartSort Konstanten:

  /**
   * csNone Konstante (gehört zum Enum: RpcChartSort).
   */
  const csNone = 0;
  /**
   * csAscending Konstante (gehört zum Enum: RpcChartSort).
   */
  const csAscending = 1;
  /**
   * csDescending Konstante (gehört zum Enum: RpcChartSort).
   */
  const csDescending = 2;

  // RpcSpecial Konstanten:

  /**
   * sTotalCount Konstante (gehört zum Enum: RpcSpecial).
   */
  const sTotalCount = 0;
  /**
   * sIncoming Konstante (gehört zum Enum: RpcSpecial).
   */
  const sIncoming = 1;
  /**
   * sOutgoing Konstante (gehört zum Enum: RpcSpecial).
   */
  const sOutgoing = 2;
  /**
   * sInServiceLevel Konstante (gehört zum Enum: RpcSpecial).
   */
  const sInServiceLevel = 3;
  /**
   * sOutServiceLevel Konstante (gehört zum Enum: RpcSpecial).
   */
  const sOutServiceLevel = 4;
  /**
   * sProcessTime Konstante (gehört zum Enum: RpcSpecial).
   */
  const sProcessTime = 5;

  // RpcFlag Konstanten:

  /**
   * fRead Konstante (gehört zum Enum: RpcFlag).
   */
  const fRead = 0;
  /**
   * fDeleted Konstante (gehört zum Enum: RpcFlag).
   */
  const fDeleted = 1;
  /**
   * fEscalated Konstante (gehört zum Enum: RpcFlag).
   */
  const fEscalated = 2;
  /**
   * fSpam Konstante (gehört zum Enum: RpcFlag).
   */
  const fSpam = 3;
  /**
   * fFailure Konstante (gehört zum Enum: RpcFlag).
   */
  const fFailure = 4;
  /**
   * fWaiting Konstante (gehört zum Enum: RpcFlag).
   */
  const fWaiting = 5;
  /**
   * fUnsent Konstante (gehört zum Enum: RpcFlag).
   */
  const fUnsent = 6;
  /**
   * fAttachment Konstante (gehört zum Enum: RpcFlag).
   */
  const fAttachment = 7;
  /**
   * fWholeDay Konstante (gehört zum Enum: RpcFlag).
   */
  const fWholeDay = 8;
  /**
   * fRecurrence Konstante (gehört zum Enum: RpcFlag).
   */
  const fRecurrence = 9;
  /**
   * fUnclassifiable Konstante (gehört zum Enum: RpcFlag).
   */
  const fUnclassifiable = 10;
  /**
   * fProtocol Konstante (gehört zum Enum: RpcFlag).
   */
  const fProtocol = 11;
  /**
   * fRemarks Konstante (gehört zum Enum: RpcFlag).
   */
  const fRemarks = 12;
  /**
   * fUseHtml Konstante (gehört zum Enum: RpcFlag).
   */
  const fUseHtml = 13;
  /**
   * fEml Konstante (gehört zum Enum: RpcFlag).
   */
  const fEml = 14;
  /**
   * fDeliveryNotification Konstante (gehört zum Enum: RpcFlag).
   */
  const fDeliveryNotification = 15;
  /**
   * fCampaign Konstante (gehört zum Enum: RpcFlag).
   */
  const fCampaign = 16;

  // RpcKind Konstanten:

  /**
   * kEmail Konstante (gehört zum Enum: RpcKind).
   */
  const kEmail = 0;
  /**
   * kFax Konstante (gehört zum Enum: RpcKind).
   */
  const kFax = 1;
  /**
   * kLetter Konstante (gehört zum Enum: RpcKind).
   */
  const kLetter = 2;
  /**
   * kMessage Konstante (gehört zum Enum: RpcKind).
   */
  const kMessage = 3;
  /**
   * kCall Konstante (gehört zum Enum: RpcKind).
   */
  const kCall = 4;
  /**
   * kAppointment Konstante (gehört zum Enum: RpcKind).
   */
  const kAppointment = 5;
  /**
   * kTask Konstante (gehört zum Enum: RpcKind).
   */
  const kTask = 6;
  /**
   * kNote Konstante (gehört zum Enum: RpcKind).
   */
  const kNote = 7;
  /**
   * kContact Konstante (gehört zum Enum: RpcKind).
   */
  const kContact = 8;
  /**
   * kFile Konstante (gehört zum Enum: RpcKind).
   */
  const kFile = 9;

  // RpcChartKind Konstanten:

  /**
   * ckNone Konstante (gehört zum Enum: RpcChartKind).
   */
  const ckNone = 0;
  /**
   * ckPie Konstante (gehört zum Enum: RpcChartKind).
   */
  const ckPie = 1;
  /**
   * ckPie3D Konstante (gehört zum Enum: RpcChartKind).
   */
  const ckPie3D = 2;
  /**
   * ckVBar Konstante (gehört zum Enum: RpcChartKind).
   */
  const ckVBar = 3;
  /**
   * ckHBar Konstante (gehört zum Enum: RpcChartKind).
   */
  const ckHBar = 4;
  /**
   * ckLine Konstante (gehört zum Enum: RpcChartKind).
   */
  const ckLine = 5;

  // RpcPeriodField Konstanten:

  /**
   * pfCreated Konstante (gehört zum Enum: RpcPeriodField).
   */
  const pfCreated = 0;
  /**
   * pfModified Konstante (gehört zum Enum: RpcPeriodField).
   */
  const pfModified = 1;
  /**
   * pfStartDate Konstante (gehört zum Enum: RpcPeriodField).
   */
  const pfStartDate = 2;
  /**
   * pfEndDate Konstante (gehört zum Enum: RpcPeriodField).
   */
  const pfEndDate = 3;

  // RpcGroupBy Konstanten:

  /**
   * gbPeriod Konstante (gehört zum Enum: RpcGroupBy).
   */
  const gbPeriod = 0;
  /**
   * gbGroup Konstante (gehört zum Enum: RpcGroupBy).
   */
  const gbGroup = 1;
  /**
   * gbUser Konstante (gehört zum Enum: RpcGroupBy).
   */
  const gbUser = 2;
  /**
   * gbTopic Konstante (gehört zum Enum: RpcGroupBy).
   */
  const gbTopic = 3;
  /**
   * gbColor Konstante (gehört zum Enum: RpcGroupBy).
   */
  const gbColor = 4;
  /**
   * gbKind Konstante (gehört zum Enum: RpcGroupBy).
   */
  const gbKind = 5;
  /**
   * gbState Konstante (gehört zum Enum: RpcGroupBy).
   */
  const gbState = 6;

  // RpcState Konstanten:

  /**
   * sOpen Konstante (gehört zum Enum: RpcState).
   */
  const sOpen = 0;
  /**
   * sNew Konstante (gehört zum Enum: RpcState).
   */
  const sNew = 1;
  /**
   * sQuestion Konstante (gehört zum Enum: RpcState).
   */
  const sQuestion = 2;
  /**
   * sAnswer Konstante (gehört zum Enum: RpcState).
   */
  const sAnswer = 3;
  /**
   * sDone Konstante (gehört zum Enum: RpcState).
   */
  const sDone = 4;
  /**
   * sForward Konstante (gehört zum Enum: RpcState).
   */
  const sForward = 5;
  /**
   * sDraft Konstante (gehört zum Enum: RpcState).
   */
  const sDraft = 6;
  /**
   * sRejected Konstante (gehört zum Enum: RpcState).
   */
  const sRejected = 7;

  // RpcLayout Konstanten:

  /**
   * lHourly Konstante (gehört zum Enum: RpcLayout).
   */
  const lHourly = 0;
  /**
   * lDaily Konstante (gehört zum Enum: RpcLayout).
   */
  const lDaily = 1;
  /**
   * lDayOfWeek Konstante (gehört zum Enum: RpcLayout).
   */
  const lDayOfWeek = 2;
  /**
   * lDayOfMonth Konstante (gehört zum Enum: RpcLayout).
   */
  const lDayOfMonth = 3;
  /**
   * lDayOfYear Konstante (gehört zum Enum: RpcLayout).
   */
  const lDayOfYear = 4;
  /**
   * lWeekly Konstante (gehört zum Enum: RpcLayout).
   */
  const lWeekly = 5;
  /**
   * lWeekOfYear Konstante (gehört zum Enum: RpcLayout).
   */
  const lWeekOfYear = 6;
  /**
   * lMonthly Konstante (gehört zum Enum: RpcLayout).
   */
  const lMonthly = 7;
  /**
   * lMonthOfYear Konstante (gehört zum Enum: RpcLayout).
   */
  const lMonthOfYear = 8;
  /**
   * lYearly Konstante (gehört zum Enum: RpcLayout).
   */
  const lYearly = 9;

  // RpcLockState Konstanten:

  /**
   * lsUnlocked Konstante (gehört zum Enum: RpcLockState).
   */
  const lsUnlocked = 0;
  /**
   * lsModified Konstante (gehört zum Enum: RpcLockState).
   */
  const lsModified = 1;
  /**
   * lsLocked Konstante (gehört zum Enum: RpcLockState).
   */
  const lsLocked = 2;

  /**
   * Hilfskonstante, die ein Set darstellt, in dem alle Enums gesetzt sind.
   * @var int
   */
  const SET_ALL = -1;


  /**
   * Erzeugt eine Instanz des RPC-Dienstes RpcSchemas.
   *
   * @param GhRpcClient $client Client Instanz
   *
   * @return GhRpcSchemaslibRpcSchemas
   */
  public static function newRpcSchemas(GhRpcClient $client)
  {
    return new GhRpcSchemaslibRpcSchemas($client);
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcGenerateOptions.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcSchemaslibRpcGenerateOptions
   */
  public static function newRpcGenerateOptions($fillProperties = false)
  {
    $object = new GhRpcSchemaslibRpcGenerateOptions();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcRow.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcSchemaslibRpcRow
   */
  public static function newRpcRow($fillProperties = false)
  {
    $object = new GhRpcSchemaslibRpcRow();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcReportSchema.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcSchemaslibRpcReportSchema
   */
  public static function newRpcReportSchema($fillProperties = false)
  {
    $object = new GhRpcSchemaslibRpcReportSchema();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcLockData.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcSchemaslibRpcLockData
   */
  public static function newRpcLockData($fillProperties = false)
  {
    $object = new GhRpcSchemaslibRpcLockData();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcSchema.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcSchemaslibRpcSchema
   */
  public static function newRpcSchema($fillProperties = false)
  {
    $object = new GhRpcSchemaslibRpcSchema();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }
}


/**
 * RPC-Struct RpcTable.
 *
 * @package GhRpc
 * @subpackage rpc_schemaslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcSchemaslibRpcSchema extends GhRpcStruct
{
  /**
   * ID
   * @var int
   */
  public $ID;

  /**
   * ReportRefs
   * @var array
   */
  public $ReportRefs;

  /**
   * Order
   * @var int
   */
  public $Order;

  /**
   * Name
   * @var string
   */
  public $Name;

  /**
   * Layout
   * @var int
   */
  public $Layout;

  /**
   * States
   * @var int
   */
  public $States;

  /**
   * Kinds
   * @var int
   */
  public $Kinds;

  /**
   * Flags
   * @var int
   */
  public $Flags;

  /**
   * Specials
   * @var int
   */
  public $Specials;

  /**
   * GroupBys
   * @var int
   */
  public $GroupBys;

  /**
   * PeriodField
   * @var int
   */
  public $PeriodField;

  /**
   * ChartKind
   * @var int
   */
  public $ChartKind;

  /**
   * ChartSort
   * @var int
   */
  public $ChartSort;

  /**
   * ChartRowCount
   * @var int
   */
  public $ChartRowCount;

  /**
   * LockData
   * @var GhRpcSchemaslibRpcLockData
   */
  public $LockData;

  /**
   * Created
   * @var GhRpcDateTime
   */
  public $Created;

  /**
   * Modified
   * @var GhRpcDateTime
   */
  public $Modified;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'ID' => 'int',
    'ReportRefs' => 'array:int',
    'Order' => 'int',
    'Name' => 'string',
    'Layout' => 'int',
    'States' => 'int',
    'Kinds' => 'int',
    'Flags' => 'int',
    'Specials' => 'int',
    'GroupBys' => 'int',
    'PeriodField' => 'int',
    'ChartKind' => 'int',
    'ChartSort' => 'int',
    'ChartRowCount' => 'int',
    'LockData' => 'GhRpcSchemaslibRpcLockData',
    'Created' => 'GhRpcDateTime',
    'Modified' => 'GhRpcDateTime',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcTable.
 *
 * @package GhRpc
 * @subpackage rpc_schemaslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcSchemaslibRpcLockData extends GhRpcStruct
{
  /**
   * LockState
   * @var int
   */
  public $LockState;

  /**
   * UserRef
   * @var int
   */
  public $UserRef;

  /**
   * UserName
   * @var string
   */
  public $UserName;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'LockState' => 'int',
    'UserRef' => 'int',
    'UserName' => 'string',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcTable.
 *
 * @package GhRpc
 * @subpackage rpc_schemaslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcSchemaslibRpcReportSchema extends GhRpcStruct
{
  /**
   * Schema
   * @var GhRpcSchemaslibRpcSchema
   */
  public $Schema;

  /**
   * Table
   * @var array
   */
  public $Table;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'Schema' => 'GhRpcSchemaslibRpcSchema',
    'Table' => 'array:GhRpcSchemaslibRpcRow',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcTable.
 *
 * @package GhRpc
 * @subpackage rpc_schemaslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcSchemaslibRpcRow extends GhRpcStruct
{
  /**
   * Period
   * @var int
   */
  public $Period;

  /**
   * TotalCount
   * @var int
   */
  public $TotalCount;

  /**
   * Incoming
   * @var int
   */
  public $Incoming;

  /**
   * Outgoing
   * @var int
   */
  public $Outgoing;

  /**
   * InServiceLevel
   * @var int
   */
  public $InServiceLevel;

  /**
   * OutServiceLevel
   * @var int
   */
  public $OutServiceLevel;

  /**
   * ProcessTime
   * @var int
   */
  public $ProcessTime;

  /**
   * Open
   * @var int
   */
  public $Open;

  /**
   * New
   * @var int
   */
  public $New;

  /**
   * Question
   * @var int
   */
  public $Question;

  /**
   * Answer
   * @var int
   */
  public $Answer;

  /**
   * Done
   * @var int
   */
  public $Done;

  /**
   * Forward
   * @var int
   */
  public $Forward;

  /**
   * Draft
   * @var int
   */
  public $Draft;

  /**
   * Rejected
   * @var int
   */
  public $Rejected;

  /**
   * Email
   * @var int
   */
  public $Email;

  /**
   * Fax
   * @var int
   */
  public $Fax;

  /**
   * Letter
   * @var int
   */
  public $Letter;

  /**
   * Message
   * @var int
   */
  public $Message;

  /**
   * Call
   * @var int
   */
  public $Call;

  /**
   * Appointment
   * @var int
   */
  public $Appointment;

  /**
   * Task
   * @var int
   */
  public $Task;

  /**
   * Note
   * @var int
   */
  public $Note;

  /**
   * Contact
   * @var int
   */
  public $Contact;

  /**
   * Files
   * @var int
   */
  public $Files;

  /**
   * Read
   * @var int
   */
  public $Read;

  /**
   * Deleted
   * @var int
   */
  public $Deleted;

  /**
   * Escalated
   * @var int
   */
  public $Escalated;

  /**
   * Spam
   * @var int
   */
  public $Spam;

  /**
   * Failure
   * @var int
   */
  public $Failure;

  /**
   * Waiting
   * @var int
   */
  public $Waiting;

  /**
   * Unsent
   * @var int
   */
  public $Unsent;

  /**
   * Attachment
   * @var int
   */
  public $Attachment;

  /**
   * Wholeday
   * @var int
   */
  public $Wholeday;

  /**
   * Recurrence
   * @var int
   */
  public $Recurrence;

  /**
   * Unclassifiable
   * @var int
   */
  public $Unclassifiable;

  /**
   * Protocol
   * @var int
   */
  public $Protocol;

  /**
   * Remarks
   * @var int
   */
  public $Remarks;

  /**
   * UseHtml
   * @var int
   */
  public $UseHtml;

  /**
   * Eml
   * @var int
   */
  public $Eml;

  /**
   * DeliveryNotification
   * @var int
   */
  public $DeliveryNotification;

  /**
   * Campaign
   * @var int
   */
  public $Campaign;

  /**
   * GroupPath
   * @var string
   */
  public $GroupPath;

  /**
   * UserName
   * @var string
   */
  public $UserName;

  /**
   * TopicPath
   * @var string
   */
  public $TopicPath;

  /**
   * ColorName
   * @var string
   */
  public $ColorName;

  /**
   * Kind
   * @var int
   */
  public $Kind;

  /**
   * State
   * @var int
   */
  public $State;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'Period' => 'int',
    'TotalCount' => 'int',
    'Incoming' => 'int',
    'Outgoing' => 'int',
    'InServiceLevel' => 'int',
    'OutServiceLevel' => 'int',
    'ProcessTime' => 'int',
    'Open' => 'int',
    'New' => 'int',
    'Question' => 'int',
    'Answer' => 'int',
    'Done' => 'int',
    'Forward' => 'int',
    'Draft' => 'int',
    'Rejected' => 'int',
    'Email' => 'int',
    'Fax' => 'int',
    'Letter' => 'int',
    'Message' => 'int',
    'Call' => 'int',
    'Appointment' => 'int',
    'Task' => 'int',
    'Note' => 'int',
    'Contact' => 'int',
    'Files' => 'int',
    'Read' => 'int',
    'Deleted' => 'int',
    'Escalated' => 'int',
    'Spam' => 'int',
    'Failure' => 'int',
    'Waiting' => 'int',
    'Unsent' => 'int',
    'Attachment' => 'int',
    'Wholeday' => 'int',
    'Recurrence' => 'int',
    'Unclassifiable' => 'int',
    'Protocol' => 'int',
    'Remarks' => 'int',
    'UseHtml' => 'int',
    'Eml' => 'int',
    'DeliveryNotification' => 'int',
    'Campaign' => 'int',
    'GroupPath' => 'string',
    'UserName' => 'string',
    'TopicPath' => 'string',
    'ColorName' => 'string',
    'Kind' => 'int',
    'State' => 'int',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcTable.
 *
 * @package GhRpc
 * @subpackage rpc_schemaslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcSchemaslibRpcGenerateOptions extends GhRpcStruct
{
  /**
   * StartField
   * @var int
   */
  public $StartField;

  /**
   * StartOperator
   * @var int
   */
  public $StartOperator;

  /**
   * StartDate
   * @var GhRpcDateTime
   */
  public $StartDate;

  /**
   * EndField
   * @var int
   */
  public $EndField;

  /**
   * EndOperator
   * @var int
   */
  public $EndOperator;

  /**
   * EndDate
   * @var GhRpcDateTime
   */
  public $EndDate;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'StartField' => 'int',
    'StartOperator' => 'int',
    'StartDate' => 'GhRpcDateTime',
    'EndField' => 'int',
    'EndOperator' => 'int',
    'EndDate' => 'GhRpcDateTime',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Dienst RpcSchemas
 *
 * @package GhRpc
 * @subpackage rpc_schemaslib
 * @category PHP-RPC-Dienste
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcSchemaslibRpcSchemas extends GhRpcService
{
  /**
   * RPC-Methoden mit Parametern und Ergebnistypen.
   * @var array
   */
  protected static $_rpcMethods = array(
    'GetLockData' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => 'GhRpcSchemaslibRpcLockData',
    ),
    'Unlock' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => '',
    ),
    'Lock' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => '',
    ),
    'Export' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => 'binary',
    ),
    'Import' => array(
      'params' => array(
        'XmlData' => 'binary',
      ),
      'return' => 'int',
    ),
    'Generate' => array(
      'params' => array(
        'ID' => 'int',
        'ReportRef' => 'int',
        'Options' => 'GhRpcSchemaslibRpcGenerateOptions',
      ),
      'return' => 'GhRpcSchemaslibRpcReportSchema',
    ),
    'SetOrder' => array(
      'params' => array(
        'ID' => 'int',
        'Order' => 'int',
      ),
      'return' => '',
    ),
    'AddReport' => array(
      'params' => array(
        'ID' => 'int',
        'ReportRef' => 'int',
      ),
      'return' => '',
    ),
    'Delete' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => '',
    ),
    'Put' => array(
      'params' => array(
        'Schema' => 'GhRpcSchemaslibRpcSchema',
      ),
      'return' => '',
    ),
    'New_' => array(
      'params' => array(
        'Schema' => 'GhRpcSchemaslibRpcSchema',
      ),
      'return' => 'int',
    ),
    'GetList' => array(
      'params' => array(
        'AdvancedFields' => 'boolean',
      ),
      'return' => 'array:GhRpcSchemaslibRpcSchema',
    ),
    'Get' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => 'GhRpcSchemaslibRpcSchema',
    ),
  );


  /**
   * Ruft die RPC-Funktion RpcSchemas.Get auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   *
   * @return GhRpcSchemaslibRpcSchema
   */
  public function Get($ID = 0)
  {
    return $this->_sendRpcRequest('RpcSchemas.Get', array($ID), self::$_rpcMethods['Get']);
  }

  /**
   * Ruft die RPC-Funktion RpcSchemas.GetList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param boolean $AdvancedFields
   *
   * @return array
   */
  public function GetList($AdvancedFields = false)
  {
    return $this->_sendRpcRequest('RpcSchemas.GetList', array($AdvancedFields), self::$_rpcMethods['GetList']);
  }

  /**
   * Ruft die RPC-Funktion RpcSchemas.New auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param GhRpcSchemaslibRpcSchema $Schema
   *
   * @return int
   */
  public function New_(GhRpcSchemaslibRpcSchema $Schema = null)
  {
    return $this->_sendRpcRequest('RpcSchemas.New', array($Schema), self::$_rpcMethods['New_']);
  }

  /**
   * Ruft die RPC-Funktion RpcSchemas.Put auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param GhRpcSchemaslibRpcSchema $Schema
   */
  public function Put(GhRpcSchemaslibRpcSchema $Schema = null)
  {
    return $this->_sendRpcRequest('RpcSchemas.Put', array($Schema), self::$_rpcMethods['Put']);
  }

  /**
   * Ruft die RPC-Funktion RpcSchemas.Delete auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   */
  public function Delete($ID = 0)
  {
    return $this->_sendRpcRequest('RpcSchemas.Delete', array($ID), self::$_rpcMethods['Delete']);
  }

  /**
   * Ruft die RPC-Funktion RpcSchemas.AddReport auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param int $ReportRef
   */
  public function AddReport($ID = 0, $ReportRef = 0)
  {
    return $this->_sendRpcRequest('RpcSchemas.AddReport', array($ID, $ReportRef), self::$_rpcMethods['AddReport']);
  }

  /**
   * Ruft die RPC-Funktion RpcSchemas.SetOrder auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param int $Order
   */
  public function SetOrder($ID = 0, $Order = 0)
  {
    return $this->_sendRpcRequest('RpcSchemas.SetOrder', array($ID, $Order), self::$_rpcMethods['SetOrder']);
  }

  /**
   * Ruft die RPC-Funktion RpcSchemas.Generate auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param int $ReportRef
   * @param GhRpcSchemaslibRpcGenerateOptions $Options
   *
   * @return GhRpcSchemaslibRpcReportSchema
   */
  public function Generate($ID = 0, $ReportRef = 0, GhRpcSchemaslibRpcGenerateOptions $Options = null)
  {
    return $this->_sendRpcRequest('RpcSchemas.Generate', array($ID, $ReportRef, $Options), self::$_rpcMethods['Generate']);
  }

  /**
   * Ruft die RPC-Funktion RpcSchemas.Import auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param string $XmlData
   *
   * @return int
   */
  public function Import($XmlData = '')
  {
    return $this->_sendRpcRequest('RpcSchemas.Import', array($XmlData), self::$_rpcMethods['Import']);
  }

  /**
   * Ruft die RPC-Funktion RpcSchemas.Export auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   *
   * @return string
   */
  public function Export($ID = 0)
  {
    return $this->_sendRpcRequest('RpcSchemas.Export', array($ID), self::$_rpcMethods['Export']);
  }

  /**
   * Ruft die RPC-Funktion RpcSchemas.Lock auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   */
  public function Lock($ID = 0)
  {
    return $this->_sendRpcRequest('RpcSchemas.Lock', array($ID), self::$_rpcMethods['Lock']);
  }

  /**
   * Ruft die RPC-Funktion RpcSchemas.Unlock auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   */
  public function Unlock($ID = 0)
  {
    return $this->_sendRpcRequest('RpcSchemas.Unlock', array($ID), self::$_rpcMethods['Unlock']);
  }

  /**
   * Ruft die RPC-Funktion RpcSchemas.GetLockData auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   *
   * @return GhRpcSchemaslibRpcLockData
   */
  public function GetLockData($ID = 0)
  {
    return $this->_sendRpcRequest('RpcSchemas.GetLockData', array($ID), self::$_rpcMethods['GetLockData']);
  }
}
