/*
 * GREYHOUND PHP API
 *
 * Copyright (c) 2011-2013 digital guru GmbH & Co. KG
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of the GREYHOUND PHP API and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including without
 * limitation the rights to use, copy, modify, merge, publish, distribute,
 * sublicense, and/or sell copies of the Software, and to permit persons to
 * whom the Software is furnished to do so, subject to the following
 * conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
 * IN THE SOFTWARE.
 */

(function()
{
	CKEDITOR.dialog.add('inlineImage', function(editor) {
    return {
      title: "Bild einfügen",
      ghInlineImageMimeType: null,
      ghInlineImageData: null,
      ghInlineImageUploaded: function(mimeType, data)
      {
        this.ghInlineImageMimeType = mimeType;
        this.ghInlineImageData = data;

        if(mimeType && data && data.length > 0)
          this.dialog.enableButton('ok');
        else
          this.dialog.disableButton('ok');
      },
      resizable: CKEDITOR.DIALOG_RESIZE_NONE,
      minWidth: 220,
      minHeight: 150,
      buttons: [CKEDITOR.dialog.okButton, CKEDITOR.dialog.cancelButton],
      contents: [
        {
          id: "inlineImagePage",
          label: "",
          title: "",
          expand: true,
          elements: [
            {
              type: "iframe",
              width: 250,
              height: 150,
              src: editor.ghGuiBaseUrl + "/lib/greyhound/ckeditor/plugins/inlineimage/dialogs/inlineimage.php"
            }
          ]
        }
      ],
      onShow: function()
      {
        this.definition.ghInlineImageMimeType = null;
        this.definition.ghInlineImageData = null;
        this.disableButton('ok');
      },
      onOk: function()
      {
        if(this.definition.ghInlineImageMimeType, this.definition.ghInlineImageData)
          this._.editor.insertHtml("<img src=\"data:" + this.definition.ghInlineImageMimeType + ";base64,\r\n" + this.definition.ghInlineImageData + "\" />");
        else
          return false;
      }
    };
  });
})();
