<?php
/*
 * GREYHOUND PHP API
 *
 * Copyright (c) 2011-2013 digital guru GmbH & Co. KG
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of the GREYHOUND PHP API and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including without
 * limitation the rights to use, copy, modify, merge, publish, distribute,
 * sublicense, and/or sell copies of the Software, and to permit persons to
 * whom the Software is furnished to do so, subject to the following
 * conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
 * IN THE SOFTWARE.
 */

// XHTML Header ausgeben:
echo '<' . '?xml version="1.0" encoding="UTF-8" ?' . '>';
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
  <title>Inline Image</title>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
  <meta http-equiv="X-UA-Compatible" content="IE=EmulateIE8" />
</head>
<body style="margin:0px;border:0px;padding:0px;">

<?php
  // Hochgeladenes Bild analysieren:
  $imageData = null;
  $imageMimeType = null;
  $imageError = true;

  if(isset($_FILES['inlineImageFile']))
  {
    $imagePath = $_FILES['inlineImageFile']['tmp_name'];

    if(is_file($imagePath))
    {
      if(isset($_FILES['inlineImageFile']['type']))
        $imageMimeType = $_FILES['inlineImageFile']['type'];

      $imageSize = getimagesize($imagePath);
      if(is_array($imageSize) && isset($imageSize[0]) && isset($imageSize[1]))
      {
        $imageWidth = $imageSize[0];
        $imageHeight = $imageSize[1];
        $imageAspectRatio = $imageHeight != 0 ? $imageWidth / $imageHeight : 0;

        if(isset($imageSize[3]) && isset($imageSize[3]['mime']))
          $imageMimeType = $imageSize[3]['mime'];
      }

      if($imageWidth > 0 && $imageHeight > 0 && $imageAspectRatio > 0 && $imageMimeType)
      {
        $imageBinary = file_get_contents($imagePath);

        if($imageBinary)
        {
          $imageData = base64_encode($imageBinary);
          $imageError = false;
        }
      }
    }
  }
?>

<div style="width:102px;height:102px;overflow:hidden;">
  <?php
    // Die Bilddaten und den MIME-Type per Javascript dem Dialog mitteilen:
    if(!$imageError)
    {
      if($imageWidth >= $imageHeight)
      {
        $w = 100;
        $h = (int)floor(100 / $imageAspectRatio);
      }
      else
      {
        $w = (int)floor(100 * $imageAspectRatio);
        $h = 100;
      }
      echo '<img src="data:' . $imageMimeType . ';base64,' . "\r\n" . $imageData . '" width="' . $w . '" height="' . $h . '" style="border:1px solid #4c4c4c;" />';
      $jsImageData = str_replace(array("\r", "\n"), array('\\r', '\\n'), $imageData);
      echo '<script type="text/javascript">parent.CKEDITOR.dialog.getCurrent().definition.ghInlineImageUploaded("' . $imageMimeType . '", "' . $jsImageData . '");</script>';
    }
  ?>
</div>
<div style="position:absolute;left:0px;bottom:0px;">
  <form method="post" enctype="multipart/form-data">
    <input type="file" name="inlineImageFile" onchange="this.form.submit();" />
  </form>
</div>

</body>
</html>
