/*
 * GREYHOUND PHP API
 *
 * Copyright (c) 2011-2013 digital guru GmbH & Co. KG
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of the GREYHOUND PHP API and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including without
 * limitation the rights to use, copy, modify, merge, publish, distribute,
 * sublicense, and/or sell copies of the Software, and to permit persons to
 * whom the Software is furnished to do so, subject to the following
 * conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
 * IN THE SOFTWARE.
 */

dojo.provide("greyhound.dojo.AccordionContainer");

dojo.require("dijit.layout.AccordionContainer");

dojo.declare("greyhound.dojo.AccordionContainer", [dijit.layout.AccordionContainer],
{
  /**
   * Setzt/aktualisiert die Größe des Widget.
   * Diese überladene Methode behebt ein Problem, bei dem ungewollte Scrollbars beim
   * Verkleinern des AccordionContainers auftraten (z.B. wenn der AccordionContainer
   * in einem BorderContainer mit Splittern enthalten ist).
   *
   * @param object dim Größe
   */
  resize: function(dim)
  {
    // Beim Ändern der Größe werden Scrollbars der Akkordeon-Karten unterdrückt, da sonst
    // beim Verkleinern ungewollte Scrollbars erscheinen. Jede Akkordeon-Karte enthält eine
    // ContentPane, die selbst über Scrollbars entscheidet (diese wird durch GhGuiAccordionContainer::addCard()
    // eingefügt).

    var children = this.getChildren();

    if(children && children.length)
    {
      for(var i=0; i<children.length; i++)
        dojo.style(children[i].domNode, "overflow", "hidden");
    }

    this.inherited(arguments);
  }
});
