<?php
/**
 * GREYHOUND PHP API
 *
 * Copyright (c) 2011-2022 GREYHOUND Software GmbH & Co. KG
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of the GREYHOUND PHP API and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including without
 * limitation the rights to use, copy, modify, merge, publish, distribute,
 * sublicense, and/or sell copies of the Software, and to permit persons to
 * whom the Software is furnished to do so, subject to the following
 * conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
 * IN THE SOFTWARE.
 */


/**
 * RPC-Unit rpc_itemslib.
 *
 * @package GhRpc
 * @subpackage rpc_itemslib
 * @category PHP-RPC-Units
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class rpc_itemslib extends GhRpcLibrary
{
  // RpcItemExcludeAi Konstanten:

  /**
   * ieaiGroup Konstante (gehört zum Enum: RpcItemExcludeAi).
   */
  const ieaiGroup = 0;
  /**
   * ieaiUser Konstante (gehört zum Enum: RpcItemExcludeAi).
   */
  const ieaiUser = 1;
  /**
   * ieaiTopic Konstante (gehört zum Enum: RpcItemExcludeAi).
   */
  const ieaiTopic = 2;
  /**
   * ieaiColor Konstante (gehört zum Enum: RpcItemExcludeAi).
   */
  const ieaiColor = 3;
  /**
   * ieaiTextblock Konstante (gehört zum Enum: RpcItemExcludeAi).
   */
  const ieaiTextblock = 4;
  /**
   * ieaiDocumentType Konstante (gehört zum Enum: RpcItemExcludeAi).
   */
  const ieaiDocumentType = 5;

  // RpcMessageState Konstanten:

  /**
   * msNone Konstante (gehört zum Enum: RpcMessageState).
   */
  const msNone = 0;
  /**
   * msSent Konstante (gehört zum Enum: RpcMessageState).
   */
  const msSent = 1;
  /**
   * msReceived Konstante (gehört zum Enum: RpcMessageState).
   */
  const msReceived = 2;
  /**
   * msRead Konstante (gehört zum Enum: RpcMessageState).
   */
  const msRead = 3;
  /**
   * msError Konstante (gehört zum Enum: RpcMessageState).
   */
  const msError = 4;

  // RpcListValueEx Konstanten:

  /**
   * lvProtocol Konstante (gehört zum Enum: RpcListValueEx).
   */
  const lvProtocol = 0;
  /**
   * lvRemarks Konstante (gehört zum Enum: RpcListValueEx).
   */
  const lvRemarks = 1;
  /**
   * lvPop3Ref Konstante (gehört zum Enum: RpcListValueEx).
   */
  const lvPop3Ref = 2;
  /**
   * lvMessageState Konstante (gehört zum Enum: RpcListValueEx).
   */
  const lvMessageState = 3;
  /**
   * lvExcludesAi Konstante (gehört zum Enum: RpcListValueEx).
   */
  const lvExcludesAi = 4;

  // RpcUserFieldVisible Konstanten:

  /**
   * ufvNo Konstante (gehört zum Enum: RpcUserFieldVisible).
   */
  const ufvNo = 0;
  /**
   * ufvYes Konstante (gehört zum Enum: RpcUserFieldVisible).
   */
  const ufvYes = 1;
  /**
   * ufvConditional Konstante (gehört zum Enum: RpcUserFieldVisible).
   */
  const ufvConditional = 2;

  // RpcItemTrigger Konstanten:

  /**
   * itAfterIncoming Konstante (gehört zum Enum: RpcItemTrigger).
   */
  const itAfterIncoming = 0;
  /**
   * itAfterOutgoing Konstante (gehört zum Enum: RpcItemTrigger).
   */
  const itAfterOutgoing = 1;
  /**
   * itManual Konstante (gehört zum Enum: RpcItemTrigger).
   */
  const itManual = 2;
  /**
   * itNew Konstante (gehört zum Enum: RpcItemTrigger).
   */
  const itNew = 3;
  /**
   * itEdit Konstante (gehört zum Enum: RpcItemTrigger).
   */
  const itEdit = 4;
  /**
   * itTime Konstante (gehört zum Enum: RpcItemTrigger).
   */
  const itTime = 5;
  /**
   * itItemWorkflow Konstante (gehört zum Enum: RpcItemTrigger).
   */
  const itItemWorkflow = 6;
  /**
   * itRuleWorkflow Konstante (gehört zum Enum: RpcItemTrigger).
   */
  const itRuleWorkflow = 7;
  /**
   * itFirstMessage Konstante (gehört zum Enum: RpcItemTrigger).
   */
  const itFirstMessage = 8;
  /**
   * itNextMessage Konstante (gehört zum Enum: RpcItemTrigger).
   */
  const itNextMessage = 9;

  // RpcDocumentAnalyzeKind Konstanten:

  /**
   * dakNone Konstante (gehört zum Enum: RpcDocumentAnalyzeKind).
   */
  const dakNone = 0;
  /**
   * dakInvoice Konstante (gehört zum Enum: RpcDocumentAnalyzeKind).
   */
  const dakInvoice = 1;
  /**
   * dakPostalAddress Konstante (gehört zum Enum: RpcDocumentAnalyzeKind).
   */
  const dakPostalAddress = 2;
  /**
   * dakEmailAddress Konstante (gehört zum Enum: RpcDocumentAnalyzeKind).
   */
  const dakEmailAddress = 3;
  /**
   * dakPhoneNumber Konstante (gehört zum Enum: RpcDocumentAnalyzeKind).
   */
  const dakPhoneNumber = 4;
  /**
   * dakUrl Konstante (gehört zum Enum: RpcDocumentAnalyzeKind).
   */
  const dakUrl = 5;
  /**
   * dakBankAcount Konstante (gehört zum Enum: RpcDocumentAnalyzeKind).
   */
  const dakBankAcount = 6;
  /**
   * dakVatId Konstante (gehört zum Enum: RpcDocumentAnalyzeKind).
   */
  const dakVatId = 7;
  /**
   * dakTaxCodeNumber Konstante (gehört zum Enum: RpcDocumentAnalyzeKind).
   */
  const dakTaxCodeNumber = 8;
  /**
   * dakGln Konstante (gehört zum Enum: RpcDocumentAnalyzeKind).
   */
  const dakGln = 9;

  // RpcItemClassifyKind Konstanten:

  /**
   * ckNone Konstante (gehört zum Enum: RpcItemClassifyKind).
   */
  const ckNone = 0;
  /**
   * ckFrom Konstante (gehört zum Enum: RpcItemClassifyKind).
   */
  const ckFrom = 1;
  /**
   * ckRecipients Konstante (gehört zum Enum: RpcItemClassifyKind).
   */
  const ckRecipients = 2;
  /**
   * ckAuto Konstante (gehört zum Enum: RpcItemClassifyKind).
   */
  const ckAuto = 3;

  // RpcItemRenderColor Konstanten:

  /**
   * rcBlackWhite Konstante (gehört zum Enum: RpcItemRenderColor).
   */
  const rcBlackWhite = 0;
  /**
   * rcTrueColor Konstante (gehört zum Enum: RpcItemRenderColor).
   */
  const rcTrueColor = 1;

  // RpcCombineOperator Konstanten:

  /**
   * cmAnd Konstante (gehört zum Enum: RpcCombineOperator).
   */
  const cmAnd = 0;
  /**
   * cmOr Konstante (gehört zum Enum: RpcCombineOperator).
   */
  const cmOr = 1;

  // RpcCompareOperator Konstanten:

  /**
   * coEqual Konstante (gehört zum Enum: RpcCompareOperator).
   */
  const coEqual = 0;
  /**
   * coNotEqual Konstante (gehört zum Enum: RpcCompareOperator).
   */
  const coNotEqual = 1;
  /**
   * coStarts Konstante (gehört zum Enum: RpcCompareOperator).
   */
  const coStarts = 2;
  /**
   * coNotStarts Konstante (gehört zum Enum: RpcCompareOperator).
   */
  const coNotStarts = 3;
  /**
   * coEnds Konstante (gehört zum Enum: RpcCompareOperator).
   */
  const coEnds = 4;
  /**
   * coNotEnds Konstante (gehört zum Enum: RpcCompareOperator).
   */
  const coNotEnds = 5;
  /**
   * coContains Konstante (gehört zum Enum: RpcCompareOperator).
   */
  const coContains = 6;
  /**
   * coNotContains Konstante (gehört zum Enum: RpcCompareOperator).
   */
  const coNotContains = 7;
  /**
   * coGreater Konstante (gehört zum Enum: RpcCompareOperator).
   */
  const coGreater = 8;
  /**
   * coGreaterEqual Konstante (gehört zum Enum: RpcCompareOperator).
   */
  const coGreaterEqual = 9;
  /**
   * coLess Konstante (gehört zum Enum: RpcCompareOperator).
   */
  const coLess = 10;
  /**
   * coLessEqual Konstante (gehört zum Enum: RpcCompareOperator).
   */
  const coLessEqual = 11;

  // RpcItemDateField Konstanten:

  /**
   * idfStartDate Konstante (gehört zum Enum: RpcItemDateField).
   */
  const idfStartDate = 0;
  /**
   * idfEndDate Konstante (gehört zum Enum: RpcItemDateField).
   */
  const idfEndDate = 1;
  /**
   * idfCreated Konstante (gehört zum Enum: RpcItemDateField).
   */
  const idfCreated = 2;
  /**
   * idfModified Konstante (gehört zum Enum: RpcItemDateField).
   */
  const idfModified = 3;

  // RpcItemOperator Konstanten:

  /**
   * ioLessEqual Konstante (gehört zum Enum: RpcItemOperator).
   */
  const ioLessEqual = 0;
  /**
   * ioLess Konstante (gehört zum Enum: RpcItemOperator).
   */
  const ioLess = 1;
  /**
   * ioEqual Konstante (gehört zum Enum: RpcItemOperator).
   */
  const ioEqual = 2;
  /**
   * ioGreater Konstante (gehört zum Enum: RpcItemOperator).
   */
  const ioGreater = 3;
  /**
   * ioGreaterEqual Konstante (gehört zum Enum: RpcItemOperator).
   */
  const ioGreaterEqual = 4;

  // RpcViewOptionColumn Konstanten:

  /**
   * vocGroupName Konstante (gehört zum Enum: RpcViewOptionColumn).
   */
  const vocGroupName = 0;
  /**
   * vocGroupPath Konstante (gehört zum Enum: RpcViewOptionColumn).
   */
  const vocGroupPath = 1;
  /**
   * vocUserName Konstante (gehört zum Enum: RpcViewOptionColumn).
   */
  const vocUserName = 2;
  /**
   * vocTopicName Konstante (gehört zum Enum: RpcViewOptionColumn).
   */
  const vocTopicName = 3;
  /**
   * vocTopicPath Konstante (gehört zum Enum: RpcViewOptionColumn).
   */
  const vocTopicPath = 4;
  /**
   * vocColor Konstante (gehört zum Enum: RpcViewOptionColumn).
   */
  const vocColor = 5;
  /**
   * vocState Konstante (gehört zum Enum: RpcViewOptionColumn).
   */
  const vocState = 6;
  /**
   * vocPriority Konstante (gehört zum Enum: RpcViewOptionColumn).
   */
  const vocPriority = 7;
  /**
   * vocFlag Konstante (gehört zum Enum: RpcViewOptionColumn).
   */
  const vocFlag = 8;
  /**
   * vocFrom Konstante (gehört zum Enum: RpcViewOptionColumn).
   */
  const vocFrom = 9;
  /**
   * vocRecipients Konstante (gehört zum Enum: RpcViewOptionColumn).
   */
  const vocRecipients = 10;
  /**
   * vocClassified Konstante (gehört zum Enum: RpcViewOptionColumn).
   */
  const vocClassified = 11;
  /**
   * vocSubject Konstante (gehört zum Enum: RpcViewOptionColumn).
   */
  const vocSubject = 12;
  /**
   * vocNumber Konstante (gehört zum Enum: RpcViewOptionColumn).
   */
  const vocNumber = 13;
  /**
   * vocSize Konstante (gehört zum Enum: RpcViewOptionColumn).
   */
  const vocSize = 14;
  /**
   * vocBirthday Konstante (gehört zum Enum: RpcViewOptionColumn).
   */
  const vocBirthday = 15;
  /**
   * vocUrl Konstante (gehört zum Enum: RpcViewOptionColumn).
   */
  const vocUrl = 16;
  /**
   * vocEmail Konstante (gehört zum Enum: RpcViewOptionColumn).
   */
  const vocEmail = 17;
  /**
   * vocFax Konstante (gehört zum Enum: RpcViewOptionColumn).
   */
  const vocFax = 18;
  /**
   * vocPostalAddress Konstante (gehört zum Enum: RpcViewOptionColumn).
   */
  const vocPostalAddress = 19;
  /**
   * vocPhone Konstante (gehört zum Enum: RpcViewOptionColumn).
   */
  const vocPhone = 20;
  /**
   * vocMobile Konstante (gehört zum Enum: RpcViewOptionColumn).
   */
  const vocMobile = 21;
  /**
   * vocProgress Konstante (gehört zum Enum: RpcViewOptionColumn).
   */
  const vocProgress = 22;
  /**
   * vocPercent Konstante (gehört zum Enum: RpcViewOptionColumn).
   */
  const vocPercent = 23;
  /**
   * vocDone Konstante (gehört zum Enum: RpcViewOptionColumn).
   */
  const vocDone = 24;
  /**
   * vocStartDate Konstante (gehört zum Enum: RpcViewOptionColumn).
   */
  const vocStartDate = 25;
  /**
   * vocEndDate Konstante (gehört zum Enum: RpcViewOptionColumn).
   */
  const vocEndDate = 26;
  /**
   * vocRemind Konstante (gehört zum Enum: RpcViewOptionColumn).
   */
  const vocRemind = 27;
  /**
   * vocNextWorkflow Konstante (gehört zum Enum: RpcViewOptionColumn).
   */
  const vocNextWorkflow = 28;
  /**
   * vocCreated Konstante (gehört zum Enum: RpcViewOptionColumn).
   */
  const vocCreated = 29;
  /**
   * vocModified Konstante (gehört zum Enum: RpcViewOptionColumn).
   */
  const vocModified = 30;
  /**
   * vocMessage Konstante (gehört zum Enum: RpcViewOptionColumn).
   */
  const vocMessage = 31;

  // RpcViewOptionCalMode Konstanten:

  /**
   * vocmDay Konstante (gehört zum Enum: RpcViewOptionCalMode).
   */
  const vocmDay = 0;
  /**
   * vocmWorkWeek Konstante (gehört zum Enum: RpcViewOptionCalMode).
   */
  const vocmWorkWeek = 1;
  /**
   * vocmWeek Konstante (gehört zum Enum: RpcViewOptionCalMode).
   */
  const vocmWeek = 2;
  /**
   * vocmMonth Konstante (gehört zum Enum: RpcViewOptionCalMode).
   */
  const vocmMonth = 3;

  // RpcViewOptionKind Konstanten:

  /**
   * vokList Konstante (gehört zum Enum: RpcViewOptionKind).
   */
  const vokList = 0;
  /**
   * vokCard Konstante (gehört zum Enum: RpcViewOptionKind).
   */
  const vokCard = 1;
  /**
   * vokCal Konstante (gehört zum Enum: RpcViewOptionKind).
   */
  const vokCal = 2;

  // RpcItemField2 Konstanten:

  /**
   * ifSecondname Konstante (gehört zum Enum: RpcItemField2).
   */
  const ifSecondname = 0;
  /**
   * ifLastname Konstante (gehört zum Enum: RpcItemField2).
   */
  const ifLastname = 1;
  /**
   * ifCallname Konstante (gehört zum Enum: RpcItemField2).
   */
  const ifCallname = 2;
  /**
   * ifCompany Konstante (gehört zum Enum: RpcItemField2).
   */
  const ifCompany = 3;
  /**
   * ifBirthday Konstante (gehört zum Enum: RpcItemField2).
   */
  const ifBirthday = 4;
  /**
   * ifUrl Konstante (gehört zum Enum: RpcItemField2).
   */
  const ifUrl = 5;
  /**
   * ifSex Konstante (gehört zum Enum: RpcItemField2).
   */
  const ifSex = 6;
  /**
   * ifCC Konstante (gehört zum Enum: RpcItemField2).
   */
  const ifCC = 7;
  /**
   * ifBCC Konstante (gehört zum Enum: RpcItemField2).
   */
  const ifBCC = 8;
  /**
   * ifReplyTo Konstante (gehört zum Enum: RpcItemField2).
   */
  const ifReplyTo = 9;
  /**
   * ifProgress Konstante (gehört zum Enum: RpcItemField2).
   */
  const ifProgress = 10;
  /**
   * ifPercent Konstante (gehört zum Enum: RpcItemField2).
   */
  const ifPercent = 11;
  /**
   * ifDone Konstante (gehört zum Enum: RpcItemField2).
   */
  const ifDone = 12;
  /**
   * ifEmail Konstante (gehört zum Enum: RpcItemField2).
   */
  const ifEmail = 13;
  /**
   * ifTelefax Konstante (gehört zum Enum: RpcItemField2).
   */
  const ifTelefax = 14;
  /**
   * ifPostalAddress Konstante (gehört zum Enum: RpcItemField2).
   */
  const ifPostalAddress = 15;
  /**
   * ifPhone Konstante (gehört zum Enum: RpcItemField2).
   */
  const ifPhone = 16;
  /**
   * ifMobile Konstante (gehört zum Enum: RpcItemField2).
   */
  const ifMobile = 17;
  /**
   * ifLastRemark Konstante (gehört zum Enum: RpcItemField2).
   */
  const ifLastRemark = 18;
  /**
   * ifMessage Konstante (gehört zum Enum: RpcItemField2).
   */
  const ifMessage = 19;
  /**
   * ifExcludesAi Konstante (gehört zum Enum: RpcItemField2).
   */
  const ifExcludesAi = 20;

  // RpcItemField1 Konstanten:

  /**
   * ifID Konstante (gehört zum Enum: RpcItemField1).
   */
  const ifID = 0;
  /**
   * ifGroupRef Konstante (gehört zum Enum: RpcItemField1).
   */
  const ifGroupRef = 1;
  /**
   * ifGroupName Konstante (gehört zum Enum: RpcItemField1).
   */
  const ifGroupName = 2;
  /**
   * ifGroupPath Konstante (gehört zum Enum: RpcItemField1).
   */
  const ifGroupPath = 3;
  /**
   * ifUserRef Konstante (gehört zum Enum: RpcItemField1).
   */
  const ifUserRef = 4;
  /**
   * ifUserName Konstante (gehört zum Enum: RpcItemField1).
   */
  const ifUserName = 5;
  /**
   * ifTopicRef Konstante (gehört zum Enum: RpcItemField1).
   */
  const ifTopicRef = 6;
  /**
   * ifTopicName Konstante (gehört zum Enum: RpcItemField1).
   */
  const ifTopicName = 7;
  /**
   * ifTopicPath Konstante (gehört zum Enum: RpcItemField1).
   */
  const ifTopicPath = 8;
  /**
   * ifColorRef Konstante (gehört zum Enum: RpcItemField1).
   */
  const ifColorRef = 9;
  /**
   * ifColor Konstante (gehört zum Enum: RpcItemField1).
   */
  const ifColor = 10;
  /**
   * ifState Konstante (gehört zum Enum: RpcItemField1).
   */
  const ifState = 11;
  /**
   * ifKind Konstante (gehört zum Enum: RpcItemField1).
   */
  const ifKind = 12;
  /**
   * ifPriority Konstante (gehört zum Enum: RpcItemField1).
   */
  const ifPriority = 13;
  /**
   * ifFlags Konstante (gehört zum Enum: RpcItemField1).
   */
  const ifFlags = 14;
  /**
   * ifFrom Konstante (gehört zum Enum: RpcItemField1).
   */
  const ifFrom = 15;
  /**
   * ifRecipients Konstante (gehört zum Enum: RpcItemField1).
   */
  const ifRecipients = 16;
  /**
   * ifSubject Konstante (gehört zum Enum: RpcItemField1).
   */
  const ifSubject = 17;
  /**
   * ifNumber Konstante (gehört zum Enum: RpcItemField1).
   */
  const ifNumber = 18;
  /**
   * ifSize Konstante (gehört zum Enum: RpcItemField1).
   */
  const ifSize = 19;
  /**
   * ifStartDate Konstante (gehört zum Enum: RpcItemField1).
   */
  const ifStartDate = 20;
  /**
   * ifEndDate Konstante (gehört zum Enum: RpcItemField1).
   */
  const ifEndDate = 21;
  /**
   * ifRemind Konstante (gehört zum Enum: RpcItemField1).
   */
  const ifRemind = 22;
  /**
   * ifNextWorkflow Konstante (gehört zum Enum: RpcItemField1).
   */
  const ifNextWorkflow = 23;
  /**
   * ifCreated Konstante (gehört zum Enum: RpcItemField1).
   */
  const ifCreated = 24;
  /**
   * ifModified Konstante (gehört zum Enum: RpcItemField1).
   */
  const ifModified = 25;
  /**
   * ifLocation Konstante (gehört zum Enum: RpcItemField1).
   */
  const ifLocation = 26;
  /**
   * ifShowAs Konstante (gehört zum Enum: RpcItemField1).
   */
  const ifShowAs = 27;
  /**
   * ifSalutation Konstante (gehört zum Enum: RpcItemField1).
   */
  const ifSalutation = 28;
  /**
   * ifTitle Konstante (gehört zum Enum: RpcItemField1).
   */
  const ifTitle = 29;
  /**
   * ifFirstname Konstante (gehört zum Enum: RpcItemField1).
   */
  const ifFirstname = 30;

  // RpcItemExtraInfo Konstanten:

  /**
   * ieiFields Konstante (gehört zum Enum: RpcItemExtraInfo).
   */
  const ieiFields = 0;
  /**
   * ieiComLinks Konstante (gehört zum Enum: RpcItemExtraInfo).
   */
  const ieiComLinks = 1;
  /**
   * ieiHeader Konstante (gehört zum Enum: RpcItemExtraInfo).
   */
  const ieiHeader = 2;
  /**
   * ieiAttachments Konstante (gehört zum Enum: RpcItemExtraInfo).
   */
  const ieiAttachments = 3;
  /**
   * ieiClassified Konstante (gehört zum Enum: RpcItemExtraInfo).
   */
  const ieiClassified = 4;
  /**
   * ieiUserFields Konstante (gehört zum Enum: RpcItemExtraInfo).
   */
  const ieiUserFields = 5;
  /**
   * ieiRemarks Konstante (gehört zum Enum: RpcItemExtraInfo).
   */
  const ieiRemarks = 6;
  /**
   * ieiProtocol Konstante (gehört zum Enum: RpcItemExtraInfo).
   */
  const ieiProtocol = 7;

  // RpcRenderFileFormat Konstanten:

  /**
   * rffDif Konstante (gehört zum Enum: RpcRenderFileFormat).
   */
  const rffDif = 0;
  /**
   * rffTiff Konstante (gehört zum Enum: RpcRenderFileFormat).
   */
  const rffTiff = 1;
  /**
   * rffPdf Konstante (gehört zum Enum: RpcRenderFileFormat).
   */
  const rffPdf = 2;
  /**
   * rffPdfZugferd Konstante (gehört zum Enum: RpcRenderFileFormat).
   */
  const rffPdfZugferd = 3;
  /**
   * rffPdfDatevXml Konstante (gehört zum Enum: RpcRenderFileFormat).
   */
  const rffPdfDatevXml = 4;
  /**
   * rffPdfDatevXmlNet Konstante (gehört zum Enum: RpcRenderFileFormat).
   */
  const rffPdfDatevXmlNet = 5;
  /**
   * rffCsv Konstante (gehört zum Enum: RpcRenderFileFormat).
   */
  const rffCsv = 6;

  // RpcShareOrderDirection Konstanten:

  /**
   * sodAscending Konstante (gehört zum Enum: RpcShareOrderDirection).
   */
  const sodAscending = 0;
  /**
   * sodDescending Konstante (gehört zum Enum: RpcShareOrderDirection).
   */
  const sodDescending = 1;

  // RpcShareOrderBy Konstanten:

  /**
   * sobName Konstante (gehört zum Enum: RpcShareOrderBy).
   */
  const sobName = 0;
  /**
   * sobCreated Konstante (gehört zum Enum: RpcShareOrderBy).
   */
  const sobCreated = 1;
  /**
   * sobExpires Konstante (gehört zum Enum: RpcShareOrderBy).
   */
  const sobExpires = 2;

  // RpcShareFlag Konstanten:

  /**
   * sfHtml Konstante (gehört zum Enum: RpcShareFlag).
   */
  const sfHtml = 0;
  /**
   * sfImage Konstante (gehört zum Enum: RpcShareFlag).
   */
  const sfImage = 1;
  /**
   * sfComLinks Konstante (gehört zum Enum: RpcShareFlag).
   */
  const sfComLinks = 2;
  /**
   * sfHeader Konstante (gehört zum Enum: RpcShareFlag).
   */
  const sfHeader = 3;
  /**
   * sfAttachments Konstante (gehört zum Enum: RpcShareFlag).
   */
  const sfAttachments = 4;
  /**
   * sfClassified Konstante (gehört zum Enum: RpcShareFlag).
   */
  const sfClassified = 5;
  /**
   * sfUserValues Konstante (gehört zum Enum: RpcShareFlag).
   */
  const sfUserValues = 6;
  /**
   * sfRemarks Konstante (gehört zum Enum: RpcShareFlag).
   */
  const sfRemarks = 7;
  /**
   * sfProtocol Konstante (gehört zum Enum: RpcShareFlag).
   */
  const sfProtocol = 8;
  /**
   * sfAddRemark Konstante (gehört zum Enum: RpcShareFlag).
   */
  const sfAddRemark = 9;

  // RpcCallState Konstanten:

  /**
   * csUnknown Konstante (gehört zum Enum: RpcCallState).
   */
  const csUnknown = 0;
  /**
   * csCalled Konstante (gehört zum Enum: RpcCallState).
   */
  const csCalled = 1;
  /**
   * csUnavailable Konstante (gehört zum Enum: RpcCallState).
   */
  const csUnavailable = 2;
  /**
   * csBusy Konstante (gehört zum Enum: RpcCallState).
   */
  const csBusy = 3;

  // RpcItemNewState Konstanten:

  /**
   * insNone Konstante (gehört zum Enum: RpcItemNewState).
   */
  const insNone = 0;
  /**
   * insOpen Konstante (gehört zum Enum: RpcItemNewState).
   */
  const insOpen = 1;
  /**
   * insNew Konstante (gehört zum Enum: RpcItemNewState).
   */
  const insNew = 2;
  /**
   * insQuestion Konstante (gehört zum Enum: RpcItemNewState).
   */
  const insQuestion = 3;
  /**
   * insAnswer Konstante (gehört zum Enum: RpcItemNewState).
   */
  const insAnswer = 4;
  /**
   * insDone Konstante (gehört zum Enum: RpcItemNewState).
   */
  const insDone = 5;
  /**
   * insForward Konstante (gehört zum Enum: RpcItemNewState).
   */
  const insForward = 6;
  /**
   * insDraft Konstante (gehört zum Enum: RpcItemNewState).
   */
  const insDraft = 7;
  /**
   * insRejected Konstante (gehört zum Enum: RpcItemNewState).
   */
  const insRejected = 8;

  // RpcComlinkPreferred Konstanten:

  /**
   * clpYes Konstante (gehört zum Enum: RpcComlinkPreferred).
   */
  const clpYes = 0;
  /**
   * clpNo Konstante (gehört zum Enum: RpcComlinkPreferred).
   */
  const clpNo = 1;

  // RpcCardValue Konstanten:

  /**
   * cvGroupRef Konstante (gehört zum Enum: RpcCardValue).
   */
  const cvGroupRef = 0;
  /**
   * cvGroupName Konstante (gehört zum Enum: RpcCardValue).
   */
  const cvGroupName = 1;
  /**
   * cvGroupPath Konstante (gehört zum Enum: RpcCardValue).
   */
  const cvGroupPath = 2;
  /**
   * cvUserRef Konstante (gehört zum Enum: RpcCardValue).
   */
  const cvUserRef = 3;
  /**
   * cvUserName Konstante (gehört zum Enum: RpcCardValue).
   */
  const cvUserName = 4;
  /**
   * cvTopicRef Konstante (gehört zum Enum: RpcCardValue).
   */
  const cvTopicRef = 5;
  /**
   * cvTopicName Konstante (gehört zum Enum: RpcCardValue).
   */
  const cvTopicName = 6;
  /**
   * cvTopicPath Konstante (gehört zum Enum: RpcCardValue).
   */
  const cvTopicPath = 7;
  /**
   * cvColorRef Konstante (gehört zum Enum: RpcCardValue).
   */
  const cvColorRef = 8;
  /**
   * cvColorCode Konstante (gehört zum Enum: RpcCardValue).
   */
  const cvColorCode = 9;
  /**
   * cvColorName Konstante (gehört zum Enum: RpcCardValue).
   */
  const cvColorName = 10;
  /**
   * cvState Konstante (gehört zum Enum: RpcCardValue).
   */
  const cvState = 11;
  /**
   * cvKind Konstante (gehört zum Enum: RpcCardValue).
   */
  const cvKind = 12;
  /**
   * cvPriority Konstante (gehört zum Enum: RpcCardValue).
   */
  const cvPriority = 13;
  /**
   * cvFlags Konstante (gehört zum Enum: RpcCardValue).
   */
  const cvFlags = 14;
  /**
   * cvClassified Konstante (gehört zum Enum: RpcCardValue).
   */
  const cvClassified = 15;
  /**
   * cvSubject Konstante (gehört zum Enum: RpcCardValue).
   */
  const cvSubject = 16;
  /**
   * cvNumber Konstante (gehört zum Enum: RpcCardValue).
   */
  const cvNumber = 17;
  /**
   * cvSize Konstante (gehört zum Enum: RpcCardValue).
   */
  const cvSize = 18;
  /**
   * cvContactBirthday Konstante (gehört zum Enum: RpcCardValue).
   */
  const cvContactBirthday = 19;
  /**
   * cvContactUrl Konstante (gehört zum Enum: RpcCardValue).
   */
  const cvContactUrl = 20;
  /**
   * cvContactEmail Konstante (gehört zum Enum: RpcCardValue).
   */
  const cvContactEmail = 21;
  /**
   * cvContactFax Konstante (gehört zum Enum: RpcCardValue).
   */
  const cvContactFax = 22;
  /**
   * cvContactPostalAddress Konstante (gehört zum Enum: RpcCardValue).
   */
  const cvContactPostalAddress = 23;
  /**
   * cvContactPhone Konstante (gehört zum Enum: RpcCardValue).
   */
  const cvContactPhone = 24;
  /**
   * cvContactMobile Konstante (gehört zum Enum: RpcCardValue).
   */
  const cvContactMobile = 25;
  /**
   * cvStartDate Konstante (gehört zum Enum: RpcCardValue).
   */
  const cvStartDate = 26;
  /**
   * cvEndDate Konstante (gehört zum Enum: RpcCardValue).
   */
  const cvEndDate = 27;
  /**
   * cvRemind Konstante (gehört zum Enum: RpcCardValue).
   */
  const cvRemind = 28;
  /**
   * cvContactMessage Konstante (gehört zum Enum: RpcCardValue).
   */
  const cvContactMessage = 29;
  /**
   * cvCreated Konstante (gehört zum Enum: RpcCardValue).
   */
  const cvCreated = 30;
  /**
   * cvModified Konstante (gehört zum Enum: RpcCardValue).
   */
  const cvModified = 31;

  // RpcListValue Konstanten:

  /**
   * lvGroupRef Konstante (gehört zum Enum: RpcListValue).
   */
  const lvGroupRef = 0;
  /**
   * lvGroupName Konstante (gehört zum Enum: RpcListValue).
   */
  const lvGroupName = 1;
  /**
   * lvGroupPath Konstante (gehört zum Enum: RpcListValue).
   */
  const lvGroupPath = 2;
  /**
   * lvUserRef Konstante (gehört zum Enum: RpcListValue).
   */
  const lvUserRef = 3;
  /**
   * lvUserName Konstante (gehört zum Enum: RpcListValue).
   */
  const lvUserName = 4;
  /**
   * lvTopicRef Konstante (gehört zum Enum: RpcListValue).
   */
  const lvTopicRef = 5;
  /**
   * lvTopicName Konstante (gehört zum Enum: RpcListValue).
   */
  const lvTopicName = 6;
  /**
   * lvTopicPath Konstante (gehört zum Enum: RpcListValue).
   */
  const lvTopicPath = 7;
  /**
   * lvColorRef Konstante (gehört zum Enum: RpcListValue).
   */
  const lvColorRef = 8;
  /**
   * lvColorCode Konstante (gehört zum Enum: RpcListValue).
   */
  const lvColorCode = 9;
  /**
   * lvColorName Konstante (gehört zum Enum: RpcListValue).
   */
  const lvColorName = 10;
  /**
   * lvState Konstante (gehört zum Enum: RpcListValue).
   */
  const lvState = 11;
  /**
   * lvKind Konstante (gehört zum Enum: RpcListValue).
   */
  const lvKind = 12;
  /**
   * lvPriority Konstante (gehört zum Enum: RpcListValue).
   */
  const lvPriority = 13;
  /**
   * lvFlags Konstante (gehört zum Enum: RpcListValue).
   */
  const lvFlags = 14;
  /**
   * lvClassified Konstante (gehört zum Enum: RpcListValue).
   */
  const lvClassified = 15;
  /**
   * lvFrom Konstante (gehört zum Enum: RpcListValue).
   */
  const lvFrom = 16;
  /**
   * lvRecipients Konstante (gehört zum Enum: RpcListValue).
   */
  const lvRecipients = 17;
  /**
   * lvSubject Konstante (gehört zum Enum: RpcListValue).
   */
  const lvSubject = 18;
  /**
   * lvNumber Konstante (gehört zum Enum: RpcListValue).
   */
  const lvNumber = 19;
  /**
   * lvSize Konstante (gehört zum Enum: RpcListValue).
   */
  const lvSize = 20;
  /**
   * lvTaskProgress Konstante (gehört zum Enum: RpcListValue).
   */
  const lvTaskProgress = 21;
  /**
   * lvTaskPercent Konstante (gehört zum Enum: RpcListValue).
   */
  const lvTaskPercent = 22;
  /**
   * lvTaskDone Konstante (gehört zum Enum: RpcListValue).
   */
  const lvTaskDone = 23;
  /**
   * lvStartDate Konstante (gehört zum Enum: RpcListValue).
   */
  const lvStartDate = 24;
  /**
   * lvEndDate Konstante (gehört zum Enum: RpcListValue).
   */
  const lvEndDate = 25;
  /**
   * lvRemind Konstante (gehört zum Enum: RpcListValue).
   */
  const lvRemind = 26;
  /**
   * lvNextWorkflow Konstante (gehört zum Enum: RpcListValue).
   */
  const lvNextWorkflow = 27;
  /**
   * lvCreated Konstante (gehört zum Enum: RpcListValue).
   */
  const lvCreated = 28;
  /**
   * lvModified Konstante (gehört zum Enum: RpcListValue).
   */
  const lvModified = 29;
  /**
   * lvViewData Konstante (gehört zum Enum: RpcListValue).
   */
  const lvViewData = 30;
  /**
   * lvAttachments Konstante (gehört zum Enum: RpcListValue).
   */
  const lvAttachments = 31;

  // RpcLockState Konstanten:

  /**
   * lsUnlocked Konstante (gehört zum Enum: RpcLockState).
   */
  const lsUnlocked = 0;
  /**
   * lsModified Konstante (gehört zum Enum: RpcLockState).
   */
  const lsModified = 1;
  /**
   * lsLocked Konstante (gehört zum Enum: RpcLockState).
   */
  const lsLocked = 2;

  // RpcUserFieldDataType Konstanten:

  /**
   * ufdtString Konstante (gehört zum Enum: RpcUserFieldDataType).
   */
  const ufdtString = 0;
  /**
   * ufdtInteger Konstante (gehört zum Enum: RpcUserFieldDataType).
   */
  const ufdtInteger = 1;
  /**
   * ufdtInt64 Konstante (gehört zum Enum: RpcUserFieldDataType).
   */
  const ufdtInt64 = 2;
  /**
   * ufdtBoolean Konstante (gehört zum Enum: RpcUserFieldDataType).
   */
  const ufdtBoolean = 3;
  /**
   * ufdtDateTime Konstante (gehört zum Enum: RpcUserFieldDataType).
   */
  const ufdtDateTime = 4;
  /**
   * ufdtFloat Konstante (gehört zum Enum: RpcUserFieldDataType).
   */
  const ufdtFloat = 5;
  /**
   * ufdtBlob Konstante (gehört zum Enum: RpcUserFieldDataType).
   */
  const ufdtBlob = 6;
  /**
   * ufdtCurrency Konstante (gehört zum Enum: RpcUserFieldDataType).
   */
  const ufdtCurrency = 7;
  /**
   * ufdtList Konstante (gehört zum Enum: RpcUserFieldDataType).
   */
  const ufdtList = 8;

  // RpcRecurrenceType Konstanten:

  /**
   * rtDaily Konstante (gehört zum Enum: RpcRecurrenceType).
   */
  const rtDaily = 0;
  /**
   * rtWeekly Konstante (gehört zum Enum: RpcRecurrenceType).
   */
  const rtWeekly = 1;
  /**
   * rtMonthly Konstante (gehört zum Enum: RpcRecurrenceType).
   */
  const rtMonthly = 2;
  /**
   * rtYearly Konstante (gehört zum Enum: RpcRecurrenceType).
   */
  const rtYearly = 3;

  // RpcOccurDay Konstanten:

  /**
   * odMonday Konstante (gehört zum Enum: RpcOccurDay).
   */
  const odMonday = 0;
  /**
   * odTuesday Konstante (gehört zum Enum: RpcOccurDay).
   */
  const odTuesday = 1;
  /**
   * odWednesday Konstante (gehört zum Enum: RpcOccurDay).
   */
  const odWednesday = 2;
  /**
   * odThursday Konstante (gehört zum Enum: RpcOccurDay).
   */
  const odThursday = 3;
  /**
   * odFriday Konstante (gehört zum Enum: RpcOccurDay).
   */
  const odFriday = 4;
  /**
   * odSaturday Konstante (gehört zum Enum: RpcOccurDay).
   */
  const odSaturday = 5;
  /**
   * odSunday Konstante (gehört zum Enum: RpcOccurDay).
   */
  const odSunday = 6;

  // RpcDayType Konstanten:

  /**
   * dtDay Konstante (gehört zum Enum: RpcDayType).
   */
  const dtDay = 0;
  /**
   * dtEveryday Konstante (gehört zum Enum: RpcDayType).
   */
  const dtEveryday = 1;
  /**
   * dtWeekday Konstante (gehört zum Enum: RpcDayType).
   */
  const dtWeekday = 2;
  /**
   * dtWeekendday Konstante (gehört zum Enum: RpcDayType).
   */
  const dtWeekendday = 3;
  /**
   * dtSunday Konstante (gehört zum Enum: RpcDayType).
   */
  const dtSunday = 4;
  /**
   * dtMonday Konstante (gehört zum Enum: RpcDayType).
   */
  const dtMonday = 5;
  /**
   * dtTuesday Konstante (gehört zum Enum: RpcDayType).
   */
  const dtTuesday = 6;
  /**
   * dtWednesday Konstante (gehört zum Enum: RpcDayType).
   */
  const dtWednesday = 7;
  /**
   * dtThursday Konstante (gehört zum Enum: RpcDayType).
   */
  const dtThursday = 8;
  /**
   * dtFriday Konstante (gehört zum Enum: RpcDayType).
   */
  const dtFriday = 9;
  /**
   * dtSaturday Konstante (gehört zum Enum: RpcDayType).
   */
  const dtSaturday = 10;

  // RpcItemSearchField Konstanten:

  /**
   * isfAddress Konstante (gehört zum Enum: RpcItemSearchField).
   */
  const isfAddress = 0;
  /**
   * isfSubject Konstante (gehört zum Enum: RpcItemSearchField).
   */
  const isfSubject = 1;
  /**
   * isfData Konstante (gehört zum Enum: RpcItemSearchField).
   */
  const isfData = 2;
  /**
   * isfNumber Konstante (gehört zum Enum: RpcItemSearchField).
   */
  const isfNumber = 3;
  /**
   * isfUserFields Konstante (gehört zum Enum: RpcItemSearchField).
   */
  const isfUserFields = 4;
  /**
   * isfRemarks Konstante (gehört zum Enum: RpcItemSearchField).
   */
  const isfRemarks = 5;
  /**
   * isfAttachments Konstante (gehört zum Enum: RpcItemSearchField).
   */
  const isfAttachments = 6;

  // RpcItemFlag Konstanten:

  /**
   * ifRead Konstante (gehört zum Enum: RpcItemFlag).
   */
  const ifRead = 0;
  /**
   * ifDeleted Konstante (gehört zum Enum: RpcItemFlag).
   */
  const ifDeleted = 1;
  /**
   * ifEscalated Konstante (gehört zum Enum: RpcItemFlag).
   */
  const ifEscalated = 2;
  /**
   * ifSpam Konstante (gehört zum Enum: RpcItemFlag).
   */
  const ifSpam = 3;
  /**
   * ifFailure Konstante (gehört zum Enum: RpcItemFlag).
   */
  const ifFailure = 4;
  /**
   * ifWaiting Konstante (gehört zum Enum: RpcItemFlag).
   */
  const ifWaiting = 5;
  /**
   * ifUnsent Konstante (gehört zum Enum: RpcItemFlag).
   */
  const ifUnsent = 6;
  /**
   * ifAttachment Konstante (gehört zum Enum: RpcItemFlag).
   */
  const ifAttachment = 7;
  /**
   * ifWholeday Konstante (gehört zum Enum: RpcItemFlag).
   */
  const ifWholeday = 8;
  /**
   * ifRecurrence Konstante (gehört zum Enum: RpcItemFlag).
   */
  const ifRecurrence = 9;
  /**
   * ifUnclassifiable Konstante (gehört zum Enum: RpcItemFlag).
   */
  const ifUnclassifiable = 10;
  /**
   * ifProtocol Konstante (gehört zum Enum: RpcItemFlag).
   */
  const ifProtocol = 11;
  /**
   * ifRemarks Konstante (gehört zum Enum: RpcItemFlag).
   */
  const ifRemarks = 12;
  /**
   * ifUseHtml Konstante (gehört zum Enum: RpcItemFlag).
   */
  const ifUseHtml = 13;
  /**
   * ifEml Konstante (gehört zum Enum: RpcItemFlag).
   */
  const ifEml = 14;
  /**
   * ifDeliveryNotification Konstante (gehört zum Enum: RpcItemFlag).
   */
  const ifDeliveryNotification = 15;
  /**
   * ifCampaign Konstante (gehört zum Enum: RpcItemFlag).
   */
  const ifCampaign = 16;

  // RpcItemState Konstanten:

  /**
   * isOpen Konstante (gehört zum Enum: RpcItemState).
   */
  const isOpen = 0;
  /**
   * isNew Konstante (gehört zum Enum: RpcItemState).
   */
  const isNew = 1;
  /**
   * isQuestion Konstante (gehört zum Enum: RpcItemState).
   */
  const isQuestion = 2;
  /**
   * isAnswer Konstante (gehört zum Enum: RpcItemState).
   */
  const isAnswer = 3;
  /**
   * isDone Konstante (gehört zum Enum: RpcItemState).
   */
  const isDone = 4;
  /**
   * isForward Konstante (gehört zum Enum: RpcItemState).
   */
  const isForward = 5;
  /**
   * isDraft Konstante (gehört zum Enum: RpcItemState).
   */
  const isDraft = 6;
  /**
   * isRejected Konstante (gehört zum Enum: RpcItemState).
   */
  const isRejected = 7;

  // RpcAppointmentShowAs Konstanten:

  /**
   * asaFree Konstante (gehört zum Enum: RpcAppointmentShowAs).
   */
  const asaFree = 0;
  /**
   * asaTentative Konstante (gehört zum Enum: RpcAppointmentShowAs).
   */
  const asaTentative = 1;
  /**
   * asaBusy Konstante (gehört zum Enum: RpcAppointmentShowAs).
   */
  const asaBusy = 2;
  /**
   * asaOutOfOffice Konstante (gehört zum Enum: RpcAppointmentShowAs).
   */
  const asaOutOfOffice = 3;

  // RpcItemOrderDirection Konstanten:

  /**
   * iodAscending Konstante (gehört zum Enum: RpcItemOrderDirection).
   */
  const iodAscending = 0;
  /**
   * iodDescending Konstante (gehört zum Enum: RpcItemOrderDirection).
   */
  const iodDescending = 1;

  // RpcItemOrderBy Konstanten:

  /**
   * iobGroup Konstante (gehört zum Enum: RpcItemOrderBy).
   */
  const iobGroup = 0;
  /**
   * iobUser Konstante (gehört zum Enum: RpcItemOrderBy).
   */
  const iobUser = 1;
  /**
   * iobTopic Konstante (gehört zum Enum: RpcItemOrderBy).
   */
  const iobTopic = 2;
  /**
   * iobColor Konstante (gehört zum Enum: RpcItemOrderBy).
   */
  const iobColor = 3;
  /**
   * iobPriority Konstante (gehört zum Enum: RpcItemOrderBy).
   */
  const iobPriority = 4;
  /**
   * iobFrom Konstante (gehört zum Enum: RpcItemOrderBy).
   */
  const iobFrom = 5;
  /**
   * iobSubject Konstante (gehört zum Enum: RpcItemOrderBy).
   */
  const iobSubject = 6;
  /**
   * iobNumber Konstante (gehört zum Enum: RpcItemOrderBy).
   */
  const iobNumber = 7;
  /**
   * iobSize Konstante (gehört zum Enum: RpcItemOrderBy).
   */
  const iobSize = 8;
  /**
   * iobStartDate Konstante (gehört zum Enum: RpcItemOrderBy).
   */
  const iobStartDate = 9;
  /**
   * iobEndDate Konstante (gehört zum Enum: RpcItemOrderBy).
   */
  const iobEndDate = 10;
  /**
   * iobCreated Konstante (gehört zum Enum: RpcItemOrderBy).
   */
  const iobCreated = 11;
  /**
   * iobModified Konstante (gehört zum Enum: RpcItemOrderBy).
   */
  const iobModified = 12;
  /**
   * iobRemind Konstante (gehört zum Enum: RpcItemOrderBy).
   */
  const iobRemind = 13;
  /**
   * iobRecipient Konstante (gehört zum Enum: RpcItemOrderBy).
   */
  const iobRecipient = 14;

  // RpcTaskProgress Konstanten:

  /**
   * tpOpen Konstante (gehört zum Enum: RpcTaskProgress).
   */
  const tpOpen = 0;
  /**
   * tpInProgress Konstante (gehört zum Enum: RpcTaskProgress).
   */
  const tpInProgress = 1;
  /**
   * tpDone Konstante (gehört zum Enum: RpcTaskProgress).
   */
  const tpDone = 2;
  /**
   * tpWaiting Konstante (gehört zum Enum: RpcTaskProgress).
   */
  const tpWaiting = 3;
  /**
   * tpSuspended Konstante (gehört zum Enum: RpcTaskProgress).
   */
  const tpSuspended = 4;

  // RpcContactSex Konstanten:

  /**
   * csNone Konstante (gehört zum Enum: RpcContactSex).
   */
  const csNone = 0;
  /**
   * csMale Konstante (gehört zum Enum: RpcContactSex).
   */
  const csMale = 1;
  /**
   * csFemale Konstante (gehört zum Enum: RpcContactSex).
   */
  const csFemale = 2;
  /**
   * csDiverse Konstante (gehört zum Enum: RpcContactSex).
   */
  const csDiverse = 3;

  // RpcComLinkCategory Konstanten:

  /**
   * clcNone Konstante (gehört zum Enum: RpcComLinkCategory).
   */
  const clcNone = 0;
  /**
   * clcBusiness Konstante (gehört zum Enum: RpcComLinkCategory).
   */
  const clcBusiness = 1;
  /**
   * clcPrivate Konstante (gehört zum Enum: RpcComLinkCategory).
   */
  const clcPrivate = 2;
  /**
   * clcInvoice Konstante (gehört zum Enum: RpcComLinkCategory).
   */
  const clcInvoice = 3;
  /**
   * clcSupplier Konstante (gehört zum Enum: RpcComLinkCategory).
   */
  const clcSupplier = 4;

  // RpcComLinkKind Konstanten:

  /**
   * clkEmail Konstante (gehört zum Enum: RpcComLinkKind).
   */
  const clkEmail = 0;
  /**
   * clkFax Konstante (gehört zum Enum: RpcComLinkKind).
   */
  const clkFax = 1;
  /**
   * clkLetter Konstante (gehört zum Enum: RpcComLinkKind).
   */
  const clkLetter = 2;
  /**
   * clkPhone Konstante (gehört zum Enum: RpcComLinkKind).
   */
  const clkPhone = 3;
  /**
   * clkMobile Konstante (gehört zum Enum: RpcComLinkKind).
   */
  const clkMobile = 4;
  /**
   * clkMessage Konstante (gehört zum Enum: RpcComLinkKind).
   */
  const clkMessage = 5;

  // RpcAddressKind Konstanten:

  /**
   * akTo Konstante (gehört zum Enum: RpcAddressKind).
   */
  const akTo = 0;
  /**
   * akCC Konstante (gehört zum Enum: RpcAddressKind).
   */
  const akCC = 1;
  /**
   * akBCC Konstante (gehört zum Enum: RpcAddressKind).
   */
  const akBCC = 2;
  /**
   * akReplyTo Konstante (gehört zum Enum: RpcAddressKind).
   */
  const akReplyTo = 3;

  // RpcItemPriority Konstanten:

  /**
   * ipLowest Konstante (gehört zum Enum: RpcItemPriority).
   */
  const ipLowest = 0;
  /**
   * ipLow Konstante (gehört zum Enum: RpcItemPriority).
   */
  const ipLow = 1;
  /**
   * ipNormal Konstante (gehört zum Enum: RpcItemPriority).
   */
  const ipNormal = 2;
  /**
   * ipHigh Konstante (gehört zum Enum: RpcItemPriority).
   */
  const ipHigh = 3;
  /**
   * ipHighest Konstante (gehört zum Enum: RpcItemPriority).
   */
  const ipHighest = 4;

  // RpcItemKind Konstanten:

  /**
   * ikEmail Konstante (gehört zum Enum: RpcItemKind).
   */
  const ikEmail = 0;
  /**
   * ikFax Konstante (gehört zum Enum: RpcItemKind).
   */
  const ikFax = 1;
  /**
   * ikLetter Konstante (gehört zum Enum: RpcItemKind).
   */
  const ikLetter = 2;
  /**
   * ikMessage Konstante (gehört zum Enum: RpcItemKind).
   */
  const ikMessage = 3;
  /**
   * ikCall Konstante (gehört zum Enum: RpcItemKind).
   */
  const ikCall = 4;
  /**
   * ikAppointment Konstante (gehört zum Enum: RpcItemKind).
   */
  const ikAppointment = 5;
  /**
   * ikTask Konstante (gehört zum Enum: RpcItemKind).
   */
  const ikTask = 6;
  /**
   * ikNote Konstante (gehört zum Enum: RpcItemKind).
   */
  const ikNote = 7;
  /**
   * ikContact Konstante (gehört zum Enum: RpcItemKind).
   */
  const ikContact = 8;
  /**
   * ikFile Konstante (gehört zum Enum: RpcItemKind).
   */
  const ikFile = 9;
  /**
   * ikShortMessage Konstante (gehört zum Enum: RpcItemKind).
   * @deprecated Kurznachrichten wurden als Typ entfernt, die Konstante 3 wird in Zukunft möglicherweise für einen anderen, neuen Datentyp verwendet.
   */
  const ikShortMessage = 3;

  // RpcWorkSpace Konstanten:

  /**
   * wsSystem Konstante (gehört zum Enum: RpcWorkSpace).
   */
  const wsSystem = 0;
  /**
   * wsPersonal Konstante (gehört zum Enum: RpcWorkSpace).
   */
  const wsPersonal = 1;

  /**
   * Hilfskonstante, die ein Set darstellt, in dem alle Enums gesetzt sind.
   * @var int
   */
  const SET_ALL = -1;


  /**
   * Erzeugt eine Instanz des RPC-Dienstes RpcItems.
   *
   * @param GhRpcClient $client Client Instanz
   *
   * @return GhRpcItemslibRpcItems
   */
  public static function newRpcItems(GhRpcClient $client)
  {
    return new GhRpcItemslibRpcItems($client);
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcClassifyItem.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcItemslibRpcClassifyItem
   */
  public static function newRpcClassifyItem($fillProperties = false)
  {
    $object = new GhRpcItemslibRpcClassifyItem();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcAnalyzeDocumentAmountItem.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcItemslibRpcAnalyzeDocumentAmountItem
   */
  public static function newRpcAnalyzeDocumentAmountItem($fillProperties = false)
  {
    $object = new GhRpcItemslibRpcAnalyzeDocumentAmountItem();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcAnalyzeDocumentInvoiceData.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcItemslibRpcAnalyzeDocumentInvoiceData
   */
  public static function newRpcAnalyzeDocumentInvoiceData($fillProperties = false)
  {
    $object = new GhRpcItemslibRpcAnalyzeDocumentInvoiceData();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcAnalyzeDocumentData.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcItemslibRpcAnalyzeDocumentData
   */
  public static function newRpcAnalyzeDocumentData($fillProperties = false)
  {
    $object = new GhRpcItemslibRpcAnalyzeDocumentData();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcLockDataItem.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcItemslibRpcLockDataItem
   */
  public static function newRpcLockDataItem($fillProperties = false)
  {
    $object = new GhRpcItemslibRpcLockDataItem();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcFilterUserFieldItem.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcItemslibRpcFilterUserFieldItem
   */
  public static function newRpcFilterUserFieldItem($fillProperties = false)
  {
    $object = new GhRpcItemslibRpcFilterUserFieldItem();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcSyncDetails.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcItemslibRpcSyncDetails
   */
  public static function newRpcSyncDetails($fillProperties = false)
  {
    $object = new GhRpcItemslibRpcSyncDetails();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcSyncItem.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcItemslibRpcSyncItem
   */
  public static function newRpcSyncItem($fillProperties = false)
  {
    $object = new GhRpcItemslibRpcSyncItem();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcViewOptionColumnItem.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcItemslibRpcViewOptionColumnItem
   */
  public static function newRpcViewOptionColumnItem($fillProperties = false)
  {
    $object = new GhRpcItemslibRpcViewOptionColumnItem();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcViewOptionItem.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcItemslibRpcViewOptionItem
   */
  public static function newRpcViewOptionItem($fillProperties = false)
  {
    $object = new GhRpcItemslibRpcViewOptionItem();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcRenderOptions.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcItemslibRpcRenderOptions
   */
  public static function newRpcRenderOptions($fillProperties = false)
  {
    $object = new GhRpcItemslibRpcRenderOptions();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcShareItem.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcItemslibRpcShareItem
   */
  public static function newRpcShareItem($fillProperties = false)
  {
    $object = new GhRpcItemslibRpcShareItem();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcAddressItem.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcItemslibRpcAddressItem
   */
  public static function newRpcAddressItem($fillProperties = false)
  {
    $object = new GhRpcItemslibRpcAddressItem();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcReadingUser.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcItemslibRpcReadingUser
   */
  public static function newRpcReadingUser($fillProperties = false)
  {
    $object = new GhRpcItemslibRpcReadingUser();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcReminderItem.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcItemslibRpcReminderItem
   */
  public static function newRpcReminderItem($fillProperties = false)
  {
    $object = new GhRpcItemslibRpcReminderItem();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcFileProperties.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcItemslibRpcFileProperties
   */
  public static function newRpcFileProperties($fillProperties = false)
  {
    $object = new GhRpcItemslibRpcFileProperties();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcVariableItem.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcItemslibRpcVariableItem
   */
  public static function newRpcVariableItem($fillProperties = false)
  {
    $object = new GhRpcItemslibRpcVariableItem();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcUserValueItem.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcItemslibRpcUserValueItem
   */
  public static function newRpcUserValueItem($fillProperties = false)
  {
    $object = new GhRpcItemslibRpcUserValueItem();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcLockData.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcItemslibRpcLockData
   */
  public static function newRpcLockData($fillProperties = false)
  {
    $object = new GhRpcItemslibRpcLockData();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcUserFieldItem.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcItemslibRpcUserFieldItem
   */
  public static function newRpcUserFieldItem($fillProperties = false)
  {
    $object = new GhRpcItemslibRpcUserFieldItem();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcCallProperties.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcItemslibRpcCallProperties
   */
  public static function newRpcCallProperties($fillProperties = false)
  {
    $object = new GhRpcItemslibRpcCallProperties();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcItemProperties.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcItemslibRpcItemProperties
   */
  public static function newRpcItemProperties($fillProperties = false)
  {
    $object = new GhRpcItemslibRpcItemProperties();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcTaskProperties.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcItemslibRpcTaskProperties
   */
  public static function newRpcTaskProperties($fillProperties = false)
  {
    $object = new GhRpcItemslibRpcTaskProperties();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcMessageProperties.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcItemslibRpcMessageProperties
   */
  public static function newRpcMessageProperties($fillProperties = false)
  {
    $object = new GhRpcItemslibRpcMessageProperties();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcNoteProperties.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcItemslibRpcNoteProperties
   */
  public static function newRpcNoteProperties($fillProperties = false)
  {
    $object = new GhRpcItemslibRpcNoteProperties();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcLetterProperties.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcItemslibRpcLetterProperties
   */
  public static function newRpcLetterProperties($fillProperties = false)
  {
    $object = new GhRpcItemslibRpcLetterProperties();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcFaxProperties.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcItemslibRpcFaxProperties
   */
  public static function newRpcFaxProperties($fillProperties = false)
  {
    $object = new GhRpcItemslibRpcFaxProperties();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcEmailProperties.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcItemslibRpcEmailProperties
   */
  public static function newRpcEmailProperties($fillProperties = false)
  {
    $object = new GhRpcItemslibRpcEmailProperties();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcContactProperties.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcItemslibRpcContactProperties
   */
  public static function newRpcContactProperties($fillProperties = false)
  {
    $object = new GhRpcItemslibRpcContactProperties();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcAppointmentProperties.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcItemslibRpcAppointmentProperties
   */
  public static function newRpcAppointmentProperties($fillProperties = false)
  {
    $object = new GhRpcItemslibRpcAppointmentProperties();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcProtocolItem.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcItemslibRpcProtocolItem
   */
  public static function newRpcProtocolItem($fillProperties = false)
  {
    $object = new GhRpcItemslibRpcProtocolItem();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcEvents.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcItemslibRpcEvents
   */
  public static function newRpcEvents($fillProperties = false)
  {
    $object = new GhRpcItemslibRpcEvents();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcRecurrenceItem.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcItemslibRpcRecurrenceItem
   */
  public static function newRpcRecurrenceItem($fillProperties = false)
  {
    $object = new GhRpcItemslibRpcRecurrenceItem();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcEventItem.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcItemslibRpcEventItem
   */
  public static function newRpcEventItem($fillProperties = false)
  {
    $object = new GhRpcItemslibRpcEventItem();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcContactItem.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcItemslibRpcContactItem
   */
  public static function newRpcContactItem($fillProperties = false)
  {
    $object = new GhRpcItemslibRpcContactItem();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcItemFilter.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcItemslibRpcItemFilter
   */
  public static function newRpcItemFilter($fillProperties = false)
  {
    $object = new GhRpcItemslibRpcItemFilter();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcComLinkItem.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcItemslibRpcComLinkItem
   */
  public static function newRpcComLinkItem($fillProperties = false)
  {
    $object = new GhRpcItemslibRpcComLinkItem();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcAttachmentItem.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcItemslibRpcAttachmentItem
   */
  public static function newRpcAttachmentItem($fillProperties = false)
  {
    $object = new GhRpcItemslibRpcAttachmentItem();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcDetailedItem.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcItemslibRpcDetailedItem
   */
  public static function newRpcDetailedItem($fillProperties = false)
  {
    $object = new GhRpcItemslibRpcDetailedItem();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcCardItem.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcItemslibRpcCardItem
   */
  public static function newRpcCardItem($fillProperties = false)
  {
    $object = new GhRpcItemslibRpcCardItem();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }

  /**
   * Erzeugt eine Instanz des RPC-Structs RpcListItem.
   *
   * @param boolean $fillProperties true: Objekt-Eigenschaften mit leeren Objekten / Arrays vorbefüllen
   * @return GhRpcItemslibRpcListItem
   */
  public static function newRpcListItem($fillProperties = false)
  {
    $object = new GhRpcItemslibRpcListItem();

    if($fillProperties)
        $object = self::_fillProperties($object);

    return $object;
  }
}


/**
 * RPC-Struct RpcClassifyList.
 *
 * @package GhRpc
 * @subpackage rpc_itemslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcItemslibRpcListItem extends GhRpcStruct
{
  /**
   * ID
   * @var int
   */
  public $ID;

  /**
   * GroupRef
   * @var int
   */
  public $GroupRef;

  /**
   * GroupName
   * @var string
   */
  public $GroupName;

  /**
   * GroupPath
   * @var string
   */
  public $GroupPath;

  /**
   * GroupForceTopic
   * @var boolean
   */
  public $GroupForceTopic;

  /**
   * GroupPrevRef
   * @var int
   */
  public $GroupPrevRef;

  /**
   * UserRef
   * @var int
   */
  public $UserRef;

  /**
   * UserName
   * @var string
   */
  public $UserName;

  /**
   * UserPrevRef
   * @var int
   */
  public $UserPrevRef;

  /**
   * TopicRef
   * @var int
   */
  public $TopicRef;

  /**
   * TopicName
   * @var string
   */
  public $TopicName;

  /**
   * TopicPath
   * @var string
   */
  public $TopicPath;

  /**
   * TopicPrevRef
   * @var int
   */
  public $TopicPrevRef;

  /**
   * ColorRef
   * @var int
   */
  public $ColorRef;

  /**
   * ColorCode
   * @var int
   */
  public $ColorCode;

  /**
   * ColorName
   * @var string
   */
  public $ColorName;

  /**
   * ColorPrevRef
   * @var int
   */
  public $ColorPrevRef;

  /**
   * State
   * @var int
   */
  public $State;

  /**
   * Kind
   * @var int
   */
  public $Kind;

  /**
   * Priority
   * @var int
   */
  public $Priority;

  /**
   * Flags
   * @var int
   */
  public $Flags;

  /**
   * Classified
   * @var int
   */
  public $Classified;

  /**
   * From
   * @var string
   */
  public $From;

  /**
   * Recipients
   * @var array
   */
  public $Recipients;

  /**
   * Subject
   * @var string
   */
  public $Subject;

  /**
   * Number
   * @var string
   */
  public $Number;

  /**
   * Size
   * @var int
   */
  public $Size;

  /**
   * TaskProgress
   * @var int
   */
  public $TaskProgress;

  /**
   * TaskPercent
   * @var int
   */
  public $TaskPercent;

  /**
   * TaskDone
   * @var GhRpcDateTime
   */
  public $TaskDone;

  /**
   * StartDate
   * @var GhRpcDateTime
   */
  public $StartDate;

  /**
   * EndDate
   * @var GhRpcDateTime
   */
  public $EndDate;

  /**
   * Remind
   * @var GhRpcDateTime
   */
  public $Remind;

  /**
   * NextWorkflow
   * @var GhRpcDateTime
   */
  public $NextWorkflow;

  /**
   * ReadingUsers
   * @var array
   */
  public $ReadingUsers;

  /**
   * LockData
   * @var GhRpcItemslibRpcLockData
   */
  public $LockData;

  /**
   * Created
   * @var GhRpcDateTime
   */
  public $Created;

  /**
   * Modified
   * @var GhRpcDateTime
   */
  public $Modified;

  /**
   * UserValues
   * @var array
   */
  public $UserValues;

  /**
   * ViewData
   * @var string
   */
  public $ViewData;

  /**
   * Attachments
   * @var array
   */
  public $Attachments;

  /**
   * Protocols
   * @var array
   */
  public $Protocols;

  /**
   * Remarks
   * @var array
   */
  public $Remarks;

  /**
   * Pop3Ref
   * @var int
   */
  public $Pop3Ref;

  /**
   * MessageState
   * @var int
   */
  public $MessageState;

  /**
   * ExcludesAi
   * @var int
   */
  public $ExcludesAi;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'ID' => 'int',
    'GroupRef' => 'int',
    'GroupName' => 'string',
    'GroupPath' => 'string',
    'GroupForceTopic' => 'boolean',
    'GroupPrevRef' => 'int',
    'UserRef' => 'int',
    'UserName' => 'string',
    'UserPrevRef' => 'int',
    'TopicRef' => 'int',
    'TopicName' => 'string',
    'TopicPath' => 'string',
    'TopicPrevRef' => 'int',
    'ColorRef' => 'int',
    'ColorCode' => 'int',
    'ColorName' => 'string',
    'ColorPrevRef' => 'int',
    'State' => 'int',
    'Kind' => 'int',
    'Priority' => 'int',
    'Flags' => 'int',
    'Classified' => 'int',
    'From' => 'string',
    'Recipients' => 'array:string',
    'Subject' => 'string',
    'Number' => 'string',
    'Size' => 'int',
    'TaskProgress' => 'int',
    'TaskPercent' => 'int',
    'TaskDone' => 'GhRpcDateTime',
    'StartDate' => 'GhRpcDateTime',
    'EndDate' => 'GhRpcDateTime',
    'Remind' => 'GhRpcDateTime',
    'NextWorkflow' => 'GhRpcDateTime',
    'ReadingUsers' => 'array:GhRpcItemslibRpcReadingUser',
    'LockData' => 'GhRpcItemslibRpcLockData',
    'Created' => 'GhRpcDateTime',
    'Modified' => 'GhRpcDateTime',
    'UserValues' => 'array:GhRpcItemslibRpcUserValueItem',
    'ViewData' => 'string',
    'Attachments' => 'array:GhRpcItemslibRpcAttachmentItem',
    'Protocols' => 'array:GhRpcItemslibRpcProtocolItem',
    'Remarks' => 'array:GhRpcItemslibRpcProtocolItem',
    'Pop3Ref' => 'int',
    'MessageState' => 'int',
    'ExcludesAi' => 'int',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcClassifyList.
 *
 * @package GhRpc
 * @subpackage rpc_itemslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcItemslibRpcCardItem extends GhRpcStruct
{
  /**
   * ID
   * @var int
   */
  public $ID;

  /**
   * GroupRef
   * @var int
   */
  public $GroupRef;

  /**
   * GroupName
   * @var string
   */
  public $GroupName;

  /**
   * GroupPath
   * @var string
   */
  public $GroupPath;

  /**
   * GroupForceTopic
   * @var boolean
   */
  public $GroupForceTopic;

  /**
   * GroupPrevRef
   * @var int
   */
  public $GroupPrevRef;

  /**
   * UserRef
   * @var int
   */
  public $UserRef;

  /**
   * UserName
   * @var string
   */
  public $UserName;

  /**
   * UserPrevRef
   * @var int
   */
  public $UserPrevRef;

  /**
   * TopicRef
   * @var int
   */
  public $TopicRef;

  /**
   * TopicName
   * @var string
   */
  public $TopicName;

  /**
   * TopicPath
   * @var string
   */
  public $TopicPath;

  /**
   * TopicPrevRef
   * @var int
   */
  public $TopicPrevRef;

  /**
   * ColorRef
   * @var int
   */
  public $ColorRef;

  /**
   * ColorCode
   * @var int
   */
  public $ColorCode;

  /**
   * ColorName
   * @var string
   */
  public $ColorName;

  /**
   * ColorPrevRef
   * @var int
   */
  public $ColorPrevRef;

  /**
   * State
   * @var int
   */
  public $State;

  /**
   * Kind
   * @var int
   */
  public $Kind;

  /**
   * Priority
   * @var int
   */
  public $Priority;

  /**
   * Flags
   * @var int
   */
  public $Flags;

  /**
   * Classified
   * @var int
   */
  public $Classified;

  /**
   * Subject
   * @var string
   */
  public $Subject;

  /**
   * Number
   * @var string
   */
  public $Number;

  /**
   * Size
   * @var int
   */
  public $Size;

  /**
   * ContactBirthday
   * @var GhRpcDateTime
   */
  public $ContactBirthday;

  /**
   * ContactUrl
   * @var string
   */
  public $ContactUrl;

  /**
   * ContactEmail
   * @var string
   */
  public $ContactEmail;

  /**
   * ContactFax
   * @var string
   */
  public $ContactFax;

  /**
   * ContactPostalAddress
   * @var string
   */
  public $ContactPostalAddress;

  /**
   * ContactPhone
   * @var string
   */
  public $ContactPhone;

  /**
   * ContactMobile
   * @var string
   */
  public $ContactMobile;

  /**
   * ContactMessage
   * @var string
   */
  public $ContactMessage;

  /**
   * StartDate
   * @var GhRpcDateTime
   */
  public $StartDate;

  /**
   * EndDate
   * @var GhRpcDateTime
   */
  public $EndDate;

  /**
   * Remind
   * @var GhRpcDateTime
   */
  public $Remind;

  /**
   * NextWorkflow
   * @var GhRpcDateTime
   */
  public $NextWorkflow;

  /**
   * ReadingUsers
   * @var array
   */
  public $ReadingUsers;

  /**
   * LockData
   * @var GhRpcItemslibRpcLockData
   */
  public $LockData;

  /**
   * Created
   * @var GhRpcDateTime
   */
  public $Created;

  /**
   * Modified
   * @var GhRpcDateTime
   */
  public $Modified;

  /**
   * UserValues
   * @var array
   */
  public $UserValues;

  /**
   * ExcludesAi
   * @var int
   */
  public $ExcludesAi;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'ID' => 'int',
    'GroupRef' => 'int',
    'GroupName' => 'string',
    'GroupPath' => 'string',
    'GroupForceTopic' => 'boolean',
    'GroupPrevRef' => 'int',
    'UserRef' => 'int',
    'UserName' => 'string',
    'UserPrevRef' => 'int',
    'TopicRef' => 'int',
    'TopicName' => 'string',
    'TopicPath' => 'string',
    'TopicPrevRef' => 'int',
    'ColorRef' => 'int',
    'ColorCode' => 'int',
    'ColorName' => 'string',
    'ColorPrevRef' => 'int',
    'State' => 'int',
    'Kind' => 'int',
    'Priority' => 'int',
    'Flags' => 'int',
    'Classified' => 'int',
    'Subject' => 'string',
    'Number' => 'string',
    'Size' => 'int',
    'ContactBirthday' => 'GhRpcDateTime',
    'ContactUrl' => 'string',
    'ContactEmail' => 'string',
    'ContactFax' => 'string',
    'ContactPostalAddress' => 'string',
    'ContactPhone' => 'string',
    'ContactMobile' => 'string',
    'ContactMessage' => 'string',
    'StartDate' => 'GhRpcDateTime',
    'EndDate' => 'GhRpcDateTime',
    'Remind' => 'GhRpcDateTime',
    'NextWorkflow' => 'GhRpcDateTime',
    'ReadingUsers' => 'array:GhRpcItemslibRpcReadingUser',
    'LockData' => 'GhRpcItemslibRpcLockData',
    'Created' => 'GhRpcDateTime',
    'Modified' => 'GhRpcDateTime',
    'UserValues' => 'array:GhRpcItemslibRpcUserValueItem',
    'ExcludesAi' => 'int',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcClassifyList.
 *
 * @package GhRpc
 * @subpackage rpc_itemslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcItemslibRpcDetailedItem extends GhRpcStruct
{
  /**
   * ID
   * @var int
   */
  public $ID;

  /**
   * RefID
   * @var int
   */
  public $RefID;

  /**
   * GroupRef
   * @var int
   */
  public $GroupRef;

  /**
   * GroupName
   * @var string
   */
  public $GroupName;

  /**
   * GroupPath
   * @var string
   */
  public $GroupPath;

  /**
   * GroupForceTopic
   * @var boolean
   */
  public $GroupForceTopic;

  /**
   * GroupPrevRef
   * @var int
   */
  public $GroupPrevRef;

  /**
   * UserRef
   * @var int
   */
  public $UserRef;

  /**
   * UserName
   * @var string
   */
  public $UserName;

  /**
   * UserPrevRef
   * @var int
   */
  public $UserPrevRef;

  /**
   * TopicRef
   * @var int
   */
  public $TopicRef;

  /**
   * TopicName
   * @var string
   */
  public $TopicName;

  /**
   * TopicPath
   * @var string
   */
  public $TopicPath;

  /**
   * TopicPrevRef
   * @var int
   */
  public $TopicPrevRef;

  /**
   * ColorRef
   * @var int
   */
  public $ColorRef;

  /**
   * ColorCode
   * @var int
   */
  public $ColorCode;

  /**
   * ColorName
   * @var string
   */
  public $ColorName;

  /**
   * ColorPrevRef
   * @var int
   */
  public $ColorPrevRef;

  /**
   * TemplateRef
   * @var int
   */
  public $TemplateRef;

  /**
   * TemplateName
   * @var string
   */
  public $TemplateName;

  /**
   * TextBlockRef
   * @var int
   */
  public $TextBlockRef;

  /**
   * TextBlockName
   * @var string
   */
  public $TextBlockName;

  /**
   * TextBlockPath
   * @var string
   */
  public $TextBlockPath;

  /**
   * State
   * @var int
   */
  public $State;

  /**
   * Kind
   * @var int
   */
  public $Kind;

  /**
   * PreviousKind
   * @var int
   */
  public $PreviousKind;

  /**
   * Priority
   * @var int
   */
  public $Priority;

  /**
   * Flags
   * @var int
   */
  public $Flags;

  /**
   * Classified
   * @var array
   */
  public $Classified;

  /**
   * From
   * @var GhRpcItemslibRpcAddressItem
   */
  public $From;

  /**
   * Recipients
   * @var array
   */
  public $Recipients;

  /**
   * Subject
   * @var string
   */
  public $Subject;

  /**
   * Number
   * @var string
   */
  public $Number;

  /**
   * Size
   * @var int
   */
  public $Size;

  /**
   * StartDate
   * @var GhRpcDateTime
   */
  public $StartDate;

  /**
   * EndDate
   * @var GhRpcDateTime
   */
  public $EndDate;

  /**
   * Remind
   * @var GhRpcDateTime
   */
  public $Remind;

  /**
   * NextWorkflow
   * @var GhRpcDateTime
   */
  public $NextWorkflow;

  /**
   * ReadingUsers
   * @var array
   */
  public $ReadingUsers;

  /**
   * LockData
   * @var GhRpcItemslibRpcLockData
   */
  public $LockData;

  /**
   * Created
   * @var GhRpcDateTime
   */
  public $Created;

  /**
   * Modified
   * @var GhRpcDateTime
   */
  public $Modified;

  /**
   * Protocol
   * @var array
   */
  public $Protocol;

  /**
   * Remarks
   * @var array
   */
  public $Remarks;

  /**
   * Attachments
   * @var array
   */
  public $Attachments;

  /**
   * Recurrence
   * @var GhRpcItemslibRpcRecurrenceItem
   */
  public $Recurrence;

  /**
   * Properties
   * @var GhRpcItemslibRpcItemProperties
   */
  public $Properties;

  /**
   * UserFields
   * @var array
   */
  public $UserFields;

  /**
   * RemindUsers
   * @var array
   */
  public $RemindUsers;

  /**
   * ReadUsers
   * @var array
   */
  public $ReadUsers;

  /**
   * Rules
   * @var array
   */
  public $Rules;

  /**
   * Variables
   * @var array
   */
  public $Variables;

  /**
   * Pop3Ref
   * @var int
   */
  public $Pop3Ref;

  /**
   * ExcludesAi
   * @var int
   */
  public $ExcludesAi;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'ID' => 'int',
    'RefID' => 'int',
    'GroupRef' => 'int',
    'GroupName' => 'string',
    'GroupPath' => 'string',
    'GroupForceTopic' => 'boolean',
    'GroupPrevRef' => 'int',
    'UserRef' => 'int',
    'UserName' => 'string',
    'UserPrevRef' => 'int',
    'TopicRef' => 'int',
    'TopicName' => 'string',
    'TopicPath' => 'string',
    'TopicPrevRef' => 'int',
    'ColorRef' => 'int',
    'ColorCode' => 'int',
    'ColorName' => 'string',
    'ColorPrevRef' => 'int',
    'TemplateRef' => 'int',
    'TemplateName' => 'string',
    'TextBlockRef' => 'int',
    'TextBlockName' => 'string',
    'TextBlockPath' => 'string',
    'State' => 'int',
    'Kind' => 'int',
    'PreviousKind' => 'int',
    'Priority' => 'int',
    'Flags' => 'int',
    'Classified' => 'array:int',
    'From' => 'GhRpcItemslibRpcAddressItem',
    'Recipients' => 'array:GhRpcItemslibRpcAddressItem',
    'Subject' => 'string',
    'Number' => 'string',
    'Size' => 'int',
    'StartDate' => 'GhRpcDateTime',
    'EndDate' => 'GhRpcDateTime',
    'Remind' => 'GhRpcDateTime',
    'NextWorkflow' => 'GhRpcDateTime',
    'ReadingUsers' => 'array:GhRpcItemslibRpcReadingUser',
    'LockData' => 'GhRpcItemslibRpcLockData',
    'Created' => 'GhRpcDateTime',
    'Modified' => 'GhRpcDateTime',
    'Protocol' => 'array:GhRpcItemslibRpcProtocolItem',
    'Remarks' => 'array:GhRpcItemslibRpcProtocolItem',
    'Attachments' => 'array:GhRpcItemslibRpcAttachmentItem',
    'Recurrence' => 'GhRpcItemslibRpcRecurrenceItem',
    'Properties' => 'GhRpcItemslibRpcItemProperties',
    'UserFields' => 'array:GhRpcItemslibRpcUserFieldItem',
    'RemindUsers' => 'array:int',
    'ReadUsers' => 'array:int',
    'Rules' => 'array:int',
    'Variables' => 'array:GhRpcItemslibRpcVariableItem',
    'Pop3Ref' => 'int',
    'ExcludesAi' => 'int',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcClassifyList.
 *
 * @package GhRpc
 * @subpackage rpc_itemslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcItemslibRpcAttachmentItem extends GhRpcStruct
{
  /**
   * ID
   * @var int
   */
  public $ID;

  /**
   * Name
   * @var string
   */
  public $Name;

  /**
   * Size
   * @var int
   */
  public $Size;

  /**
   * Revision
   * @var int
   */
  public $Revision;

  /**
   * RevGroup
   * @var int
   */
  public $RevGroup;

  /**
   * UserRef
   * @var int
   */
  public $UserRef;

  /**
   * UserName
   * @var string
   */
  public $UserName;

  /**
   * ContentID
   * @var string
   */
  public $ContentID;

  /**
   * ContentType
   * @var string
   */
  public $ContentType;

  /**
   * Created
   * @var GhRpcDateTime
   */
  public $Created;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'ID' => 'int',
    'Name' => 'string',
    'Size' => 'int',
    'Revision' => 'int',
    'RevGroup' => 'int',
    'UserRef' => 'int',
    'UserName' => 'string',
    'ContentID' => 'string',
    'ContentType' => 'string',
    'Created' => 'GhRpcDateTime',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcClassifyList.
 *
 * @package GhRpc
 * @subpackage rpc_itemslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcItemslibRpcComLinkItem extends GhRpcStruct
{
  /**
   * ItemRef
   * @var int
   */
  public $ItemRef;

  /**
   * Kind
   * @var int
   */
  public $Kind;

  /**
   * Category
   * @var int
   */
  public $Category;

  /**
   * Preferred
   * @var boolean
   */
  public $Preferred;

  /**
   * Text
   * @var string
   */
  public $Text;

  /**
   * Relevance
   * @var double
   */
  public $Relevance;

  /**
   * Mru
   * @var boolean
   */
  public $Mru;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'ItemRef' => 'int',
    'Kind' => 'int',
    'Category' => 'int',
    'Preferred' => 'boolean',
    'Text' => 'string',
    'Relevance' => 'double',
    'Mru' => 'boolean',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcClassifyList.
 *
 * @package GhRpc
 * @subpackage rpc_itemslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcItemslibRpcItemFilter extends GhRpcStruct
{
  /**
   * GroupRefs
   * @var array
   */
  public $GroupRefs;

  /**
   * UserRefs
   * @var array
   */
  public $UserRefs;

  /**
   * TopicRefs
   * @var array
   */
  public $TopicRefs;

  /**
   * ColorRefs
   * @var array
   */
  public $ColorRefs;

  /**
   * ItemRefs
   * @var array
   */
  public $ItemRefs;

  /**
   * ContactRef
   * @var int
   */
  public $ContactRef;

  /**
   * SearchFor
   * @var string
   */
  public $SearchFor;

  /**
   * SearchFields
   * @var int
   */
  public $SearchFields;

  /**
   * Kinds
   * @var int
   */
  public $Kinds;

  /**
   * Priorities
   * @var int
   */
  public $Priorities;

  /**
   * States
   * @var int
   */
  public $States;

  /**
   * PositiveFlags
   * @var int
   */
  public $PositiveFlags;

  /**
   * NegativeFlags
   * @var int
   */
  public $NegativeFlags;

  /**
   * MinClassified
   * @var int
   */
  public $MinClassified = -1;

  /**
   * MaxClassified
   * @var int
   */
  public $MaxClassified = -1;

  /**
   * StartDate
   * @var GhRpcDateTime
   */
  public $StartDate;

  /**
   * StartOperator
   * @var int
   */
  public $StartOperator;

  /**
   * StartField
   * @var int
   */
  public $StartField;

  /**
   * EndDate
   * @var GhRpcDateTime
   */
  public $EndDate;

  /**
   * EndOperator
   * @var int
   */
  public $EndOperator;

  /**
   * EndField
   * @var int
   */
  public $EndField;

  /**
   * MinAge
   * @var double
   */
  public $MinAge;

  /**
   * MaxAge
   * @var double
   */
  public $MaxAge;

  /**
   * MinSize
   * @var int
   */
  public $MinSize;

  /**
   * MaxSize
   * @var int
   */
  public $MaxSize;

  /**
   * MinRemind
   * @var double
   */
  public $MinRemind;

  /**
   * MaxRemind
   * @var double
   */
  public $MaxRemind;

  /**
   * FirstChar
   * @var string
   */
  public $FirstChar;

  /**
   * UserFields
   * @var array
   */
  public $UserFields;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'GroupRefs' => 'array:int',
    'UserRefs' => 'array:int',
    'TopicRefs' => 'array:int',
    'ColorRefs' => 'array:int',
    'ItemRefs' => 'array:int',
    'ContactRef' => 'int',
    'SearchFor' => 'string',
    'SearchFields' => 'int',
    'Kinds' => 'int',
    'Priorities' => 'int',
    'States' => 'int',
    'PositiveFlags' => 'int',
    'NegativeFlags' => 'int',
    'MinClassified' => 'int',
    'MaxClassified' => 'int',
    'StartDate' => 'GhRpcDateTime',
    'StartOperator' => 'int',
    'StartField' => 'int',
    'EndDate' => 'GhRpcDateTime',
    'EndOperator' => 'int',
    'EndField' => 'int',
    'MinAge' => 'double',
    'MaxAge' => 'double',
    'MinSize' => 'int',
    'MaxSize' => 'int',
    'MinRemind' => 'double',
    'MaxRemind' => 'double',
    'FirstChar' => 'string',
    'UserFields' => 'array:GhRpcItemslibRpcFilterUserFieldItem',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcClassifyList.
 *
 * @package GhRpc
 * @subpackage rpc_itemslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcItemslibRpcContactItem extends GhRpcStruct
{
  /**
   * ID
   * @var int
   */
  public $ID;

  /**
   * Sex
   * @var int
   */
  public $Sex;

  /**
   * Name
   * @var string
   */
  public $Name;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'ID' => 'int',
    'Sex' => 'int',
    'Name' => 'string',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcClassifyList.
 *
 * @package GhRpc
 * @subpackage rpc_itemslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcItemslibRpcEventItem extends GhRpcStruct
{
  /**
   * ID
   * @var int
   */
  public $ID;

  /**
   * GroupRef
   * @var int
   */
  public $GroupRef;

  /**
   * GroupForceTopic
   * @var boolean
   */
  public $GroupForceTopic;

  /**
   * ColorRef
   * @var int
   */
  public $ColorRef;

  /**
   * ColorCode
   * @var int
   */
  public $ColorCode;

  /**
   * ColorName
   * @var string
   */
  public $ColorName;

  /**
   * ColorPrevRef
   * @var int
   */
  public $ColorPrevRef;

  /**
   * TopicRef
   * @var int
   */
  public $TopicRef;

  /**
   * TopicName
   * @var string
   */
  public $TopicName;

  /**
   * TopicPath
   * @var string
   */
  public $TopicPath;

  /**
   * TopicPrevRef
   * @var int
   */
  public $TopicPrevRef;

  /**
   * State
   * @var int
   */
  public $State;

  /**
   * Kind
   * @var int
   */
  public $Kind;

  /**
   * Flags
   * @var int
   */
  public $Flags;

  /**
   * Subject
   * @var string
   */
  public $Subject;

  /**
   * Number
   * @var string
   */
  public $Number;

  /**
   * StartDate
   * @var GhRpcDateTime
   */
  public $StartDate;

  /**
   * EndDate
   * @var GhRpcDateTime
   */
  public $EndDate;

  /**
   * AppointmentShowAs
   * @var int
   */
  public $AppointmentShowAs;

  /**
   * ReadingUsers
   * @var array
   */
  public $ReadingUsers;

  /**
   * LockData
   * @var GhRpcItemslibRpcLockData
   */
  public $LockData;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'ID' => 'int',
    'GroupRef' => 'int',
    'GroupForceTopic' => 'boolean',
    'ColorRef' => 'int',
    'ColorCode' => 'int',
    'ColorName' => 'string',
    'ColorPrevRef' => 'int',
    'TopicRef' => 'int',
    'TopicName' => 'string',
    'TopicPath' => 'string',
    'TopicPrevRef' => 'int',
    'State' => 'int',
    'Kind' => 'int',
    'Flags' => 'int',
    'Subject' => 'string',
    'Number' => 'string',
    'StartDate' => 'GhRpcDateTime',
    'EndDate' => 'GhRpcDateTime',
    'AppointmentShowAs' => 'int',
    'ReadingUsers' => 'array:GhRpcItemslibRpcReadingUser',
    'LockData' => 'GhRpcItemslibRpcLockData',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcClassifyList.
 *
 * @package GhRpc
 * @subpackage rpc_itemslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcItemslibRpcRecurrenceItem extends GhRpcStruct
{
  /**
   * ID
   * @var int
   */
  public $ID;

  /**
   * Count
   * @var int
   */
  public $Count;

  /**
   * DayNumber
   * @var int
   */
  public $DayNumber;

  /**
   * DayType
   * @var int
   */
  public $DayType;

  /**
   * OccurDays
   * @var int
   */
  public $OccurDays;

  /**
   * Recurrence
   * @var int
   */
  public $Recurrence;

  /**
   * Periodicity
   * @var int
   */
  public $Periodicity;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'ID' => 'int',
    'Count' => 'int',
    'DayNumber' => 'int',
    'DayType' => 'int',
    'OccurDays' => 'int',
    'Recurrence' => 'int',
    'Periodicity' => 'int',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcClassifyList.
 *
 * @package GhRpc
 * @subpackage rpc_itemslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcItemslibRpcEvents extends GhRpcStruct
{
  /**
   * EventList
   * @var array
   */
  public $EventList;

  /**
   * RecurrenceList
   * @var array
   */
  public $RecurrenceList;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'EventList' => 'array:GhRpcItemslibRpcEventItem',
    'RecurrenceList' => 'array:GhRpcItemslibRpcRecurrenceItem',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcClassifyList.
 *
 * @package GhRpc
 * @subpackage rpc_itemslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcItemslibRpcProtocolItem extends GhRpcStruct
{
  /**
   * Date
   * @var GhRpcDateTime
   */
  public $Date;

  /**
   * UserRef
   * @var int
   */
  public $UserRef;

  /**
   * UserName
   * @var string
   */
  public $UserName;

  /**
   * RuleName
   * @var string
   */
  public $RuleName;

  /**
   * Text
   * @var string
   */
  public $Text;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'Date' => 'GhRpcDateTime',
    'UserRef' => 'int',
    'UserName' => 'string',
    'RuleName' => 'string',
    'Text' => 'string',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcClassifyList.
 *
 * @package GhRpc
 * @subpackage rpc_itemslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcItemslibRpcAppointmentProperties extends GhRpcStruct
{
  /**
   * Location
   * @var string
   */
  public $Location;

  /**
   * ShowAs
   * @var int
   */
  public $ShowAs;

  /**
   * EditorData
   * @var string
   */
  public $EditorData;

  /**
   * ViewData
   * @var string
   */
  public $ViewData;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'Location' => 'string',
    'ShowAs' => 'int',
    'EditorData' => 'binary',
    'ViewData' => 'binary',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcClassifyList.
 *
 * @package GhRpc
 * @subpackage rpc_itemslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcItemslibRpcContactProperties extends GhRpcStruct
{
  /**
   * Salutation
   * @var string
   */
  public $Salutation;

  /**
   * Title
   * @var string
   */
  public $Title;

  /**
   * Firstname
   * @var string
   */
  public $Firstname;

  /**
   * Secondname
   * @var string
   */
  public $Secondname;

  /**
   * Lastname
   * @var string
   */
  public $Lastname;

  /**
   * Callname
   * @var string
   */
  public $Callname;

  /**
   * Company
   * @var string
   */
  public $Company;

  /**
   * Birthday
   * @var GhRpcDateTime
   */
  public $Birthday;

  /**
   * Url
   * @var string
   */
  public $Url;

  /**
   * Sex
   * @var int
   */
  public $Sex;

  /**
   * Picture
   * @var string
   */
  public $Picture;

  /**
   * EditorData
   * @var string
   */
  public $EditorData;

  /**
   * ViewData
   * @var string
   */
  public $ViewData;

  /**
   * ComLinks
   * @var array
   */
  public $ComLinks;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'Salutation' => 'string',
    'Title' => 'string',
    'Firstname' => 'string',
    'Secondname' => 'string',
    'Lastname' => 'string',
    'Callname' => 'string',
    'Company' => 'string',
    'Birthday' => 'GhRpcDateTime',
    'Url' => 'string',
    'Sex' => 'int',
    'Picture' => 'binary',
    'EditorData' => 'binary',
    'ViewData' => 'binary',
    'ComLinks' => 'array:GhRpcItemslibRpcComLinkItem',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcClassifyList.
 *
 * @package GhRpc
 * @subpackage rpc_itemslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcItemslibRpcEmailProperties extends GhRpcStruct
{
  /**
   * Header
   * @var string
   */
  public $Header;

  /**
   * MessageID
   * @var string
   */
  public $MessageID;

  /**
   * EditorData
   * @var string
   */
  public $EditorData;

  /**
   * ViewData
   * @var string
   */
  public $ViewData;

  /**
   * EnvelopeTo
   * @var GhRpcItemslibRpcAddressItem
   */
  public $EnvelopeTo;

  /**
   * CC
   * @var array
   */
  public $CC;

  /**
   * BCC
   * @var array
   */
  public $BCC;

  /**
   * ReplyTo
   * @var array
   */
  public $ReplyTo;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'Header' => 'string',
    'MessageID' => 'string',
    'EditorData' => 'binary',
    'ViewData' => 'binary',
    'EnvelopeTo' => 'GhRpcItemslibRpcAddressItem',
    'CC' => 'array:GhRpcItemslibRpcAddressItem',
    'BCC' => 'array:GhRpcItemslibRpcAddressItem',
    'ReplyTo' => 'array:GhRpcItemslibRpcAddressItem',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcClassifyList.
 *
 * @package GhRpc
 * @subpackage rpc_itemslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcItemslibRpcFaxProperties extends GhRpcStruct
{
  /**
   * Header
   * @var string
   */
  public $Header;

  /**
   * EditorData
   * @var string
   */
  public $EditorData;

  /**
   * ViewData
   * @var string
   */
  public $ViewData;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'Header' => 'string',
    'EditorData' => 'binary',
    'ViewData' => 'binary',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcClassifyList.
 *
 * @package GhRpc
 * @subpackage rpc_itemslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcItemslibRpcLetterProperties extends GhRpcStruct
{
  /**
   * Header
   * @var string
   */
  public $Header;

  /**
   * EditorData
   * @var string
   */
  public $EditorData;

  /**
   * ViewData
   * @var string
   */
  public $ViewData;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'Header' => 'string',
    'EditorData' => 'binary',
    'ViewData' => 'binary',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcClassifyList.
 *
 * @package GhRpc
 * @subpackage rpc_itemslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcItemslibRpcNoteProperties extends GhRpcStruct
{
  /**
   * EditorData
   * @var string
   */
  public $EditorData;

  /**
   * ViewData
   * @var string
   */
  public $ViewData;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'EditorData' => 'binary',
    'ViewData' => 'binary',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcClassifyList.
 *
 * @package GhRpc
 * @subpackage rpc_itemslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcItemslibRpcMessageProperties extends GhRpcStruct
{
  /**
   * MsgID
   * @var string
   */
  public $MsgID;

  /**
   * EditorData
   * @var string
   */
  public $EditorData;

  /**
   * ViewData
   * @var string
   */
  public $ViewData;

  /**
   * State
   * @var int
   */
  public $State;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'MsgID' => 'string',
    'EditorData' => 'binary',
    'ViewData' => 'binary',
    'State' => 'int',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcClassifyList.
 *
 * @package GhRpc
 * @subpackage rpc_itemslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcItemslibRpcTaskProperties extends GhRpcStruct
{
  /**
   * Progress
   * @var int
   */
  public $Progress;

  /**
   * Percent
   * @var int
   */
  public $Percent;

  /**
   * Done
   * @var GhRpcDateTime
   */
  public $Done;

  /**
   * EditorData
   * @var string
   */
  public $EditorData;

  /**
   * ViewData
   * @var string
   */
  public $ViewData;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'Progress' => 'int',
    'Percent' => 'int',
    'Done' => 'GhRpcDateTime',
    'EditorData' => 'binary',
    'ViewData' => 'binary',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcClassifyList.
 *
 * @package GhRpc
 * @subpackage rpc_itemslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcItemslibRpcItemProperties extends GhRpcStruct
{
  /**
   * Appointment
   * @var GhRpcItemslibRpcAppointmentProperties
   */
  public $Appointment;

  /**
   * Contact
   * @var GhRpcItemslibRpcContactProperties
   */
  public $Contact;

  /**
   * Email
   * @var GhRpcItemslibRpcEmailProperties
   */
  public $Email;

  /**
   * Fax
   * @var GhRpcItemslibRpcFaxProperties
   */
  public $Fax;

  /**
   * Letter
   * @var GhRpcItemslibRpcLetterProperties
   */
  public $Letter;

  /**
   * Note
   * @var GhRpcItemslibRpcNoteProperties
   */
  public $Note;

  /**
   * Message
   * @var GhRpcItemslibRpcMessageProperties
   */
  public $Message;

  /**
   * Task
   * @var GhRpcItemslibRpcTaskProperties
   */
  public $Task;

  /**
   * Call
   * @var GhRpcItemslibRpcCallProperties
   */
  public $Call;

  /**
   * Files
   * @var GhRpcItemslibRpcFileProperties
   */
  public $Files;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'Appointment' => 'GhRpcItemslibRpcAppointmentProperties',
    'Contact' => 'GhRpcItemslibRpcContactProperties',
    'Email' => 'GhRpcItemslibRpcEmailProperties',
    'Fax' => 'GhRpcItemslibRpcFaxProperties',
    'Letter' => 'GhRpcItemslibRpcLetterProperties',
    'Note' => 'GhRpcItemslibRpcNoteProperties',
    'Message' => 'GhRpcItemslibRpcMessageProperties',
    'Task' => 'GhRpcItemslibRpcTaskProperties',
    'Call' => 'GhRpcItemslibRpcCallProperties',
    'Files' => 'GhRpcItemslibRpcFileProperties',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcClassifyList.
 *
 * @package GhRpc
 * @subpackage rpc_itemslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcItemslibRpcCallProperties extends GhRpcStruct
{
  /**
   * State
   * @var int
   */
  public $State;

  /**
   * EditorData
   * @var string
   */
  public $EditorData;

  /**
   * ViewData
   * @var string
   */
  public $ViewData;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'State' => 'int',
    'EditorData' => 'binary',
    'ViewData' => 'binary',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcClassifyList.
 *
 * @package GhRpc
 * @subpackage rpc_itemslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcItemslibRpcUserFieldItem extends GhRpcStruct
{
  /**
   * FieldRef
   * @var int
   */
  public $FieldRef;

  /**
   * Name
   * @var string
   */
  public $Name;

  /**
   * Description
   * @var string
   */
  public $Description;

  /**
   * Visible
   * @var int
   */
  public $Visible;

  /**
   * Condition
   * @var string
   */
  public $Condition;

  /**
   * Highlight
   * @var boolean
   */
  public $Highlight;

  /**
   * ReadOnly
   * @var boolean
   */
  public $ReadOnly;

  /**
   * DataType
   * @var int
   */
  public $DataType;

  /**
   * Validation
   * @var string
   */
  public $Validation;

  /**
   * Values
   * @var string
   */
  public $Values;

  /**
   * Regex
   * @var string
   */
  public $Regex;

  /**
   * DisplayFormat
   * @var string
   */
  public $DisplayFormat;

  /**
   * Value
   * @var string
   */
  public $Value;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'FieldRef' => 'int',
    'Name' => 'string',
    'Description' => 'string',
    'Visible' => 'int',
    'Condition' => 'string',
    'Highlight' => 'boolean',
    'ReadOnly' => 'boolean',
    'DataType' => 'int',
    'Validation' => 'string',
    'Values' => 'string',
    'Regex' => 'string',
    'DisplayFormat' => 'string',
    'Value' => 'string',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcClassifyList.
 *
 * @package GhRpc
 * @subpackage rpc_itemslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcItemslibRpcLockData extends GhRpcStruct
{
  /**
   * LockState
   * @var int
   */
  public $LockState;

  /**
   * UserRef
   * @var int
   */
  public $UserRef;

  /**
   * UserName
   * @var string
   */
  public $UserName;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'LockState' => 'int',
    'UserRef' => 'int',
    'UserName' => 'string',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcClassifyList.
 *
 * @package GhRpc
 * @subpackage rpc_itemslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcItemslibRpcUserValueItem extends GhRpcStruct
{
  /**
   * FieldRef
   * @var int
   */
  public $FieldRef;

  /**
   * Value
   * @var string
   */
  public $Value;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'FieldRef' => 'int',
    'Value' => 'string',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcClassifyList.
 *
 * @package GhRpc
 * @subpackage rpc_itemslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcItemslibRpcVariableItem extends GhRpcStruct
{
  /**
   * Name
   * @var string
   */
  public $Name;

  /**
   * Data
   * @var string
   */
  public $Data;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'Name' => 'string',
    'Data' => 'string',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcClassifyList.
 *
 * @package GhRpc
 * @subpackage rpc_itemslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcItemslibRpcFileProperties extends GhRpcStruct
{
  /**
   * ViewData
   * @var string
   */
  public $ViewData;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'ViewData' => 'binary',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcClassifyList.
 *
 * @package GhRpc
 * @subpackage rpc_itemslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcItemslibRpcReminderItem extends GhRpcStruct
{
  /**
   * ID
   * @var int
   */
  public $ID;

  /**
   * ItemRef
   * @var int
   */
  public $ItemRef;

  /**
   * State
   * @var int
   */
  public $State;

  /**
   * Kind
   * @var int
   */
  public $Kind;

  /**
   * Flags
   * @var int
   */
  public $Flags;

  /**
   * Subject
   * @var string
   */
  public $Subject;

  /**
   * Number
   * @var string
   */
  public $Number;

  /**
   * StartDate
   * @var GhRpcDateTime
   */
  public $StartDate;

  /**
   * EndDate
   * @var GhRpcDateTime
   */
  public $EndDate;

  /**
   * Remind
   * @var GhRpcDateTime
   */
  public $Remind;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'ID' => 'int',
    'ItemRef' => 'int',
    'State' => 'int',
    'Kind' => 'int',
    'Flags' => 'int',
    'Subject' => 'string',
    'Number' => 'string',
    'StartDate' => 'GhRpcDateTime',
    'EndDate' => 'GhRpcDateTime',
    'Remind' => 'GhRpcDateTime',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcClassifyList.
 *
 * @package GhRpc
 * @subpackage rpc_itemslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcItemslibRpcReadingUser extends GhRpcStruct
{
  /**
   * UserRef
   * @var int
   */
  public $UserRef;

  /**
   * UserName
   * @var string
   */
  public $UserName;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'UserRef' => 'int',
    'UserName' => 'string',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcClassifyList.
 *
 * @package GhRpc
 * @subpackage rpc_itemslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcItemslibRpcAddressItem extends GhRpcStruct
{
  /**
   * Text
   * @var string
   */
  public $Text;

  /**
   * ContactRef
   * @var int
   */
  public $ContactRef;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'Text' => 'string',
    'ContactRef' => 'int',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcClassifyList.
 *
 * @package GhRpc
 * @subpackage rpc_itemslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcItemslibRpcShareItem extends GhRpcStruct
{
  /**
   * ID
   * @var int
   */
  public $ID;

  /**
   * ItemRef
   * @var int
   */
  public $ItemRef;

  /**
   * UserRef
   * @var int
   */
  public $UserRef;

  /**
   * UserName
   * @var string
   */
  public $UserName;

  /**
   * Name
   * @var string
   */
  public $Name;

  /**
   * Flags
   * @var int
   */
  public $Flags;

  /**
   * URL
   * @var string
   */
  public $URL;

  /**
   * Login
   * @var string
   */
  public $Login;

  /**
   * Password
   * @var string
   */
  public $Password;

  /**
   * Created
   * @var GhRpcDateTime
   */
  public $Created;

  /**
   * Expires
   * @var GhRpcDateTime
   */
  public $Expires;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'ID' => 'int',
    'ItemRef' => 'int',
    'UserRef' => 'int',
    'UserName' => 'string',
    'Name' => 'string',
    'Flags' => 'int',
    'URL' => 'string',
    'Login' => 'string',
    'Password' => 'string',
    'Created' => 'GhRpcDateTime',
    'Expires' => 'GhRpcDateTime',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcClassifyList.
 *
 * @package GhRpc
 * @subpackage rpc_itemslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcItemslibRpcRenderOptions extends GhRpcStruct
{
  /**
   * PageWidth
   * @var int
   */
  public $PageWidth;

  /**
   * PageHeight
   * @var int
   */
  public $PageHeight;

  /**
   * MarginLeft
   * @var int
   */
  public $MarginLeft;

  /**
   * MarginTop
   * @var int
   */
  public $MarginTop;

  /**
   * MarginRight
   * @var int
   */
  public $MarginRight;

  /**
   * MarginBottom
   * @var int
   */
  public $MarginBottom;

  /**
   * DpiX
   * @var int
   */
  public $DpiX;

  /**
   * DpiY
   * @var int
   */
  public $DpiY;

  /**
   * Color
   * @var int
   */
  public $Color;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'PageWidth' => 'int',
    'PageHeight' => 'int',
    'MarginLeft' => 'int',
    'MarginTop' => 'int',
    'MarginRight' => 'int',
    'MarginBottom' => 'int',
    'DpiX' => 'int',
    'DpiY' => 'int',
    'Color' => 'int',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcClassifyList.
 *
 * @package GhRpc
 * @subpackage rpc_itemslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcItemslibRpcViewOptionItem extends GhRpcStruct
{
  /**
   * ID
   * @var int
   */
  public $ID;

  /**
   * FilterRefs
   * @var array
   */
  public $FilterRefs;

  /**
   * WorkSpace
   * @var int
   */
  public $WorkSpace;

  /**
   * Preferred
   * @var boolean
   */
  public $Preferred;

  /**
   * Name
   * @var string
   */
  public $Name;

  /**
   * Kind
   * @var int
   */
  public $Kind;

  /**
   * ItemFields1
   * @var int
   */
  public $ItemFields1;

  /**
   * ItemFields2
   * @var int
   */
  public $ItemFields2;

  /**
   * UserFieldRefs
   * @var array
   */
  public $UserFieldRefs;

  /**
   * Columns
   * @var array
   */
  public $Columns;

  /**
   * OrderBy
   * @var int
   */
  public $OrderBy;

  /**
   * OrderDirection
   * @var int
   */
  public $OrderDirection;

  /**
   * OrderUserFieldRef
   * @var int
   */
  public $OrderUserFieldRef;

  /**
   * CalMode
   * @var int
   */
  public $CalMode;

  /**
   * Folded
   * @var boolean
   */
  public $Folded;

  /**
   * LockData
   * @var GhRpcItemslibRpcLockData
   */
  public $LockData;

  /**
   * Created
   * @var GhRpcDateTime
   */
  public $Created;

  /**
   * Modified
   * @var GhRpcDateTime
   */
  public $Modified;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'ID' => 'int',
    'FilterRefs' => 'array:int',
    'WorkSpace' => 'int',
    'Preferred' => 'boolean',
    'Name' => 'string',
    'Kind' => 'int',
    'ItemFields1' => 'int',
    'ItemFields2' => 'int',
    'UserFieldRefs' => 'array:int',
    'Columns' => 'array:GhRpcItemslibRpcViewOptionColumnItem',
    'OrderBy' => 'int',
    'OrderDirection' => 'int',
    'OrderUserFieldRef' => 'int',
    'CalMode' => 'int',
    'Folded' => 'boolean',
    'LockData' => 'GhRpcItemslibRpcLockData',
    'Created' => 'GhRpcDateTime',
    'Modified' => 'GhRpcDateTime',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcClassifyList.
 *
 * @package GhRpc
 * @subpackage rpc_itemslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcItemslibRpcViewOptionColumnItem extends GhRpcStruct
{
  /**
   * Column
   * @var int
   */
  public $Column;

  /**
   * Flag
   * @var int
   */
  public $Flag;

  /**
   * UserFieldRef
   * @var int
   */
  public $UserFieldRef;

  /**
   * Width
   * @var int
   */
  public $Width;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'Column' => 'int',
    'Flag' => 'int',
    'UserFieldRef' => 'int',
    'Width' => 'int',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcClassifyList.
 *
 * @package GhRpc
 * @subpackage rpc_itemslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcItemslibRpcSyncItem extends GhRpcStruct
{
  /**
   * ID
   * @var int
   */
  public $ID;

  /**
   * GroupRef
   * @var int
   */
  public $GroupRef;

  /**
   * Subject
   * @var string
   */
  public $Subject;

  /**
   * Modified
   * @var GhRpcDateTime
   */
  public $Modified;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'ID' => 'int',
    'GroupRef' => 'int',
    'Subject' => 'string',
    'Modified' => 'GhRpcDateTime',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcClassifyList.
 *
 * @package GhRpc
 * @subpackage rpc_itemslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcItemslibRpcSyncDetails extends GhRpcStruct
{
  /**
   * ID
   * @var int
   */
  public $ID;

  /**
   * Created
   * @var GhRpcDateTime
   */
  public $Created;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'ID' => 'int',
    'Created' => 'GhRpcDateTime',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcClassifyList.
 *
 * @package GhRpc
 * @subpackage rpc_itemslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcItemslibRpcFilterUserFieldItem extends GhRpcStruct
{
  /**
   * FieldRef
   * @var int
   */
  public $FieldRef;

  /**
   * Compare
   * @var int
   */
  public $Compare;

  /**
   * Value
   * @var string
   */
  public $Value;

  /**
   * Combine
   * @var int
   */
  public $Combine;

  /**
   * Order
   * @var int
   */
  public $Order;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'FieldRef' => 'int',
    'Compare' => 'int',
    'Value' => 'string',
    'Combine' => 'int',
    'Order' => 'int',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcClassifyList.
 *
 * @package GhRpc
 * @subpackage rpc_itemslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcItemslibRpcLockDataItem extends GhRpcStruct
{
  /**
   * ID
   * @var int
   */
  public $ID;

  /**
   * LockState
   * @var int
   */
  public $LockState;

  /**
   * UserRef
   * @var int
   */
  public $UserRef;

  /**
   * UserName
   * @var string
   */
  public $UserName;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'ID' => 'int',
    'LockState' => 'int',
    'UserRef' => 'int',
    'UserName' => 'string',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcClassifyList.
 *
 * @package GhRpc
 * @subpackage rpc_itemslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcItemslibRpcAnalyzeDocumentData extends GhRpcStruct
{
  /**
   * VatIDs
   * @var array
   */
  public $VatIDs;

  /**
   * TaxCodeNumbers
   * @var array
   */
  public $TaxCodeNumbers;

  /**
   * Ibans
   * @var array
   */
  public $Ibans;

  /**
   * Bics
   * @var array
   */
  public $Bics;

  /**
   * Invoice
   * @var GhRpcItemslibRpcAnalyzeDocumentInvoiceData
   */
  public $Invoice;

  /**
   * EMailAddresses
   * @var array
   */
  public $EMailAddresses;

  /**
   * PhoneAddresses
   * @var array
   */
  public $PhoneAddresses;

  /**
   * PostalAddresses
   * @var array
   */
  public $PostalAddresses;

  /**
   * Urls
   * @var array
   */
  public $Urls;

  /**
   * Glns
   * @var array
   */
  public $Glns;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'VatIDs' => 'array:string',
    'TaxCodeNumbers' => 'array:string',
    'Ibans' => 'array:string',
    'Bics' => 'array:string',
    'Invoice' => 'GhRpcItemslibRpcAnalyzeDocumentInvoiceData',
    'EMailAddresses' => 'array:string',
    'PhoneAddresses' => 'array:string',
    'PostalAddresses' => 'array:string',
    'Urls' => 'array:string',
    'Glns' => 'array:string',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcClassifyList.
 *
 * @package GhRpc
 * @subpackage rpc_itemslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcItemslibRpcAnalyzeDocumentInvoiceData extends GhRpcStruct
{
  /**
   * DocumentType
   * @var string
   */
  public $DocumentType;

  /**
   * UserDocumentNumber
   * @var string
   */
  public $UserDocumentNumber;

  /**
   * UserReferenceNumber
   * @var string
   */
  public $UserReferenceNumber;

  /**
   * ReferenceNumbers
   * @var array
   */
  public $ReferenceNumbers;

  /**
   * DocumentDate
   * @var GhRpcDateTime
   */
  public $DocumentDate;

  /**
   * ServiceDate
   * @var GhRpcDateTime
   */
  public $ServiceDate;

  /**
   * Amounts
   * @var array
   */
  public $Amounts;

  /**
   * TotalAmount
   * @var double
   */
  public $TotalAmount;

  /**
   * Currency
   * @var string
   */
  public $Currency;

  /**
   * PaymentReference
   * @var string
   */
  public $PaymentReference;

  /**
   * TradeRegisterNumbers
   * @var array
   */
  public $TradeRegisterNumbers;

  /**
   * CustomerNumbers
   * @var array
   */
  public $CustomerNumbers;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'DocumentType' => 'string',
    'UserDocumentNumber' => 'string',
    'UserReferenceNumber' => 'string',
    'ReferenceNumbers' => 'array:string',
    'DocumentDate' => 'GhRpcDateTime',
    'ServiceDate' => 'GhRpcDateTime',
    'Amounts' => 'array:GhRpcItemslibRpcAnalyzeDocumentAmountItem',
    'TotalAmount' => 'double',
    'Currency' => 'string',
    'PaymentReference' => 'string',
    'TradeRegisterNumbers' => 'array:string',
    'CustomerNumbers' => 'array:string',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcClassifyList.
 *
 * @package GhRpc
 * @subpackage rpc_itemslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcItemslibRpcAnalyzeDocumentAmountItem extends GhRpcStruct
{
  /**
   * GrossAmount
   * @var double
   */
  public $GrossAmount;

  /**
   * NetAmount
   * @var double
   */
  public $NetAmount;

  /**
   * VatAmount
   * @var double
   */
  public $VatAmount;

  /**
   * VatRate
   * @var double
   */
  public $VatRate;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'GrossAmount' => 'double',
    'NetAmount' => 'double',
    'VatAmount' => 'double',
    'VatRate' => 'double',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Struct RpcClassifyList.
 *
 * @package GhRpc
 * @subpackage rpc_itemslib
 * @category PHP-RPC-Datenklassen
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcItemslibRpcClassifyItem extends GhRpcStruct
{
  /**
   * ItemRef
   * @var int
   */
  public $ItemRef;

  /**
   * Kind
   * @var int
   */
  public $Kind;

  /**
   * Eigenschaften und Typen des RPC-Structs.
   * @var array
   */
  protected static $_rpcProperties = array(
    'ItemRef' => 'int',
    'Kind' => 'int',
  );


  /**
   * Liefert die Eigenschaften dieses RPC-Structs.
   *
   * @return array
   */
  public function getRpcProperties()
  {
    return self::$_rpcProperties;
  }

  /**
   * Liefert den Typ einer Eigenschaft dieses RPC-Structs.
   *
   * @param string $property Name der Eigenschaft
   * @return string
   */
  public function getRpcPropertyType($property)
  {
    return isset(self::$_rpcProperties[$property]) ? self::$_rpcProperties[$property] : null;
  }
}


/**
 * RPC-Dienst RpcItems
 *
 * @package GhRpc
 * @subpackage rpc_itemslib
 * @category PHP-RPC-Dienste
 *
 * @author GREYHOUND Software GmbH &amp; Co. KG <develop@greyhound-software.com>
 * @copyright 2011-2022 GREYHOUND Software GmbH &amp; Co. KG
 * @link greyhound-software.com
 */
class GhRpcItemslibRpcItems extends GhRpcService
{
  /**
   * RPC-Methoden mit Parametern und Ergebnistypen.
   * @var array
   */
  protected static $_rpcMethods = array(
    'GetLastModifiedForTaskNumber' => array(
      'params' => array(
        'Number' => 'string',
      ),
      'return' => 'GhRpcDateTime',
    ),
    'SetStateByTaskNumber' => array(
      'params' => array(
        'ID' => 'int',
        'OldState' => 'int',
        'NewState' => 'int',
        'IncludeReferredItem' => 'boolean',
      ),
      'return' => '',
    ),
    'TriggerRules' => array(
      'params' => array(
        'ID' => 'int',
        'Trigger' => 'int',
        'DeleteExistingWorkflowRules' => 'boolean',
      ),
      'return' => '',
    ),
    'ExtractDocumentData' => array(
      'params' => array(
        'ID' => 'int',
        'Kinds' => 'int',
      ),
      'return' => 'GhRpcItemslibRpcAnalyzeDocumentData',
    ),
    'DeleteMruAddressItem' => array(
      'params' => array(
        'Kind' => 'int',
        'Text' => 'string',
      ),
      'return' => '',
    ),
    'AddMruAddressItems' => array(
      'params' => array(
        'Kind' => 'int',
        'Texts' => 'array:string',
      ),
      'return' => '',
    ),
    'AddMruAddressItem' => array(
      'params' => array(
        'Kind' => 'int',
        'Text' => 'string',
      ),
      'return' => '',
    ),
    'GetViewOptionLockData' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => 'GhRpcItemslibRpcLockData',
    ),
    'UnlockViewOption' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => '',
    ),
    'LockViewOption' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => '',
    ),
    'AddViewOptionFilter' => array(
      'params' => array(
        'ID' => 'int',
        'FilterRef' => 'int',
      ),
      'return' => '',
    ),
    'DeleteViewOption' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => '',
    ),
    'PutViewOption' => array(
      'params' => array(
        'ViewOption' => 'GhRpcItemslibRpcViewOptionItem',
      ),
      'return' => '',
    ),
    'NewViewOption' => array(
      'params' => array(
        'ViewOption' => 'GhRpcItemslibRpcViewOptionItem',
      ),
      'return' => 'int',
    ),
    'GetViewOptionList' => array(
      'params' => array(
      ),
      'return' => 'array:GhRpcItemslibRpcViewOptionItem',
    ),
    'GetViewOption' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => 'GhRpcItemslibRpcViewOptionItem',
    ),
    'GetLockDataList' => array(
      'params' => array(
        'IDs' => 'array:int',
      ),
      'return' => 'array:GhRpcItemslibRpcLockDataItem',
    ),
    'GetLockData' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => 'GhRpcItemslibRpcLockData',
    ),
    'UnlockList' => array(
      'params' => array(
        'IDs' => 'array:int',
      ),
      'return' => '',
    ),
    'Unlock' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => '',
    ),
    'LockList' => array(
      'params' => array(
        'IDs' => 'array:int',
      ),
      'return' => '',
    ),
    'Lock' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => '',
    ),
    'DeleteReminder' => array(
      'params' => array(
        'ReminderID' => 'int',
      ),
      'return' => '',
    ),
    'UpdateReminder' => array(
      'params' => array(
        'ReminderID' => 'int',
        'SecondsDelta' => 'int',
      ),
      'return' => '',
    ),
    'ExecuteRuleList' => array(
      'params' => array(
        'IDs' => 'array:int',
        'RuleID' => 'int',
      ),
      'return' => '',
    ),
    'ExecuteRule' => array(
      'params' => array(
        'ID' => 'int',
        'RuleID' => 'int',
      ),
      'return' => '',
    ),
    'RenameAttachment' => array(
      'params' => array(
        'AttachmentID' => 'int',
        'Name' => 'string',
      ),
      'return' => '',
    ),
    'DeleteAttachment' => array(
      'params' => array(
        'AttachmentID' => 'int',
        'DeleteRevGroup' => 'boolean',
      ),
      'return' => '',
    ),
    'CopyAttachment' => array(
      'params' => array(
        'AttachmentID' => 'int',
        'TargetID' => 'int',
        'RevGroup' => 'int',
      ),
      'return' => 'int',
    ),
    'DeleteShare' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => '',
    ),
    'AddShare' => array(
      'params' => array(
        'Item' => 'GhRpcItemslibRpcShareItem',
      ),
      'return' => 'string',
    ),
    'DeleteClassified' => array(
      'params' => array(
        'ID' => 'int',
        'ItemRef' => 'int',
        'Remark' => 'string',
      ),
      'return' => '',
    ),
    'AddClassified' => array(
      'params' => array(
        'ID' => 'int',
        'ItemRef' => 'int',
        'Kind' => 'int',
        'SetDocumentSenderFlag' => 'boolean',
        'SetDocumentReceiverFlag' => 'boolean',
        'Remark' => 'string',
      ),
      'return' => '',
    ),
    'AddComLink' => array(
      'params' => array(
        'ComLink' => 'GhRpcItemslibRpcComLinkItem',
      ),
      'return' => '',
    ),
    'AddProtocolList' => array(
      'params' => array(
        'IDs' => 'array:int',
        'Protocol' => 'string',
      ),
      'return' => '',
    ),
    'AddProtocol' => array(
      'params' => array(
        'ID' => 'int',
        'Protocol' => 'string',
      ),
      'return' => '',
    ),
    'AddRemarkList' => array(
      'params' => array(
        'IDs' => 'array:int',
        'Remark' => 'string',
      ),
      'return' => '',
    ),
    'AddRemark' => array(
      'params' => array(
        'ID' => 'int',
        'Remark' => 'string',
      ),
      'return' => '',
    ),
    'SetSubject' => array(
      'params' => array(
        'ID' => 'int',
        'Value' => 'string',
        'Remark' => 'string',
      ),
      'return' => '',
    ),
    'SetReadingState' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => '',
    ),
    'SetPeriodList' => array(
      'params' => array(
        'IDs' => 'array:int',
        'StartDate' => 'GhRpcDateTime',
        'EndDate' => 'GhRpcDateTime',
        'Remark' => 'string',
      ),
      'return' => '',
    ),
    'SetPeriod' => array(
      'params' => array(
        'ID' => 'int',
        'StartDate' => 'GhRpcDateTime',
        'EndDate' => 'GhRpcDateTime',
        'Remark' => 'string',
      ),
      'return' => '',
    ),
    'SetUserFieldList' => array(
      'params' => array(
        'IDs' => 'array:int',
        'FieldRef' => 'int',
        'Value' => 'string',
        'Remark' => 'string',
      ),
      'return' => '',
    ),
    'SetUserFields' => array(
      'params' => array(
        'ID' => 'int',
        'UserFields' => 'array:GhRpcItemslibRpcUserFieldItem',
        'Remark' => 'string',
      ),
      'return' => '',
    ),
    'SetUserField' => array(
      'params' => array(
        'ID' => 'int',
        'FieldRef' => 'int',
        'Value' => 'string',
        'Remark' => 'string',
      ),
      'return' => '',
    ),
    'SetNumberList' => array(
      'params' => array(
        'IDs' => 'array:int',
        'Value' => 'string',
        'AllItemsInTask' => 'boolean',
        'Remark' => 'string',
      ),
      'return' => '',
    ),
    'SetNumber' => array(
      'params' => array(
        'ID' => 'int',
        'Value' => 'string',
        'AllItemsInTask' => 'boolean',
        'Remark' => 'string',
      ),
      'return' => '',
    ),
    'SetEscalatedList' => array(
      'params' => array(
        'IDs' => 'array:int',
        'Value' => 'boolean',
        'Remark' => 'string',
      ),
      'return' => '',
    ),
    'SetEscalated' => array(
      'params' => array(
        'ID' => 'int',
        'Value' => 'boolean',
        'Remark' => 'string',
      ),
      'return' => '',
    ),
    'SetRejectedList' => array(
      'params' => array(
        'IDs' => 'array:int',
        'Value' => 'boolean',
        'Remark' => 'string',
      ),
      'return' => '',
    ),
    'SetRejected' => array(
      'params' => array(
        'ID' => 'int',
        'Value' => 'boolean',
        'Remark' => 'string',
      ),
      'return' => '',
    ),
    'SetDoneList' => array(
      'params' => array(
        'IDs' => 'array:int',
        'Value' => 'boolean',
        'Remark' => 'string',
      ),
      'return' => '',
    ),
    'SetDone' => array(
      'params' => array(
        'ID' => 'int',
        'Value' => 'boolean',
        'Remark' => 'string',
      ),
      'return' => '',
    ),
    'SetWaitingList' => array(
      'params' => array(
        'IDs' => 'array:int',
        'Value' => 'boolean',
        'Remark' => 'string',
      ),
      'return' => '',
    ),
    'SetWaiting' => array(
      'params' => array(
        'ID' => 'int',
        'Value' => 'boolean',
        'Remark' => 'string',
      ),
      'return' => '',
    ),
    'SetClassified' => array(
      'params' => array(
        'ID' => 'int',
        'List' => 'array:GhRpcItemslibRpcClassifyItem',
        'Unclassifiable' => 'boolean',
        'SetDocumentSenderFlag' => 'boolean',
        'SetDocumentReceiverFlag' => 'boolean',
        'Remark' => 'string',
      ),
      'return' => '',
    ),
    'SetUnclassifiableList' => array(
      'params' => array(
        'IDs' => 'array:int',
        'Value' => 'boolean',
        'Remark' => 'string',
      ),
      'return' => '',
    ),
    'SetUnclassifiable' => array(
      'params' => array(
        'ID' => 'int',
        'Value' => 'boolean',
        'Remark' => 'string',
      ),
      'return' => '',
    ),
    'SetQuestionList' => array(
      'params' => array(
        'IDs' => 'array:int',
        'TopicRef' => 'int',
        'ColorRef' => 'int',
        'Remark' => 'string',
      ),
      'return' => '',
    ),
    'SetQuestionEx' => array(
      'params' => array(
        'ID' => 'int',
        'TopicRef' => 'int',
        'ColorRef' => 'int',
        'TextBlockRef' => 'int',
        'Remark' => 'string',
      ),
      'return' => '',
    ),
    'SetQuestion' => array(
      'params' => array(
        'ID' => 'int',
        'TopicRef' => 'int',
        'ColorRef' => 'int',
        'Remark' => 'string',
      ),
      'return' => '',
    ),
    'SetUnreadForAllList' => array(
      'params' => array(
        'IDs' => 'array:int',
        'Remark' => 'string',
      ),
      'return' => '',
    ),
    'SetUnreadForAll' => array(
      'params' => array(
        'ID' => 'int',
        'Remark' => 'string',
      ),
      'return' => '',
    ),
    'SetReadList' => array(
      'params' => array(
        'IDs' => 'array:int',
        'Value' => 'boolean',
        'Remark' => 'string',
      ),
      'return' => '',
    ),
    'SetRead' => array(
      'params' => array(
        'ID' => 'int',
        'Value' => 'boolean',
        'Remark' => 'string',
      ),
      'return' => '',
    ),
    'SetSpamList' => array(
      'params' => array(
        'IDs' => 'array:int',
        'Value' => 'boolean',
        'Remark' => 'string',
      ),
      'return' => '',
    ),
    'SetSpam' => array(
      'params' => array(
        'ID' => 'int',
        'Value' => 'boolean',
        'Remark' => 'string',
      ),
      'return' => '',
    ),
    'SetTemplateList' => array(
      'params' => array(
        'IDs' => 'array:int',
        'TemplateRef' => 'int',
        'Remark' => 'string',
      ),
      'return' => '',
    ),
    'SetTemplate' => array(
      'params' => array(
        'ID' => 'int',
        'TemplateRef' => 'int',
        'Remark' => 'string',
      ),
      'return' => '',
    ),
    'SetColorList' => array(
      'params' => array(
        'IDs' => 'array:int',
        'ColorRef' => 'int',
        'Remark' => 'string',
      ),
      'return' => '',
    ),
    'SetColor' => array(
      'params' => array(
        'ID' => 'int',
        'ColorRef' => 'int',
        'Remark' => 'string',
      ),
      'return' => '',
    ),
    'SetTopicList' => array(
      'params' => array(
        'IDs' => 'array:int',
        'TopicRef' => 'int',
        'Remark' => 'string',
      ),
      'return' => '',
    ),
    'SetTopic' => array(
      'params' => array(
        'ID' => 'int',
        'TopicRef' => 'int',
        'Remark' => 'string',
      ),
      'return' => '',
    ),
    'SetUserList' => array(
      'params' => array(
        'IDs' => 'array:int',
        'UserRef' => 'int',
        'Remark' => 'string',
      ),
      'return' => '',
    ),
    'SetUser' => array(
      'params' => array(
        'ID' => 'int',
        'UserRef' => 'int',
        'Remark' => 'string',
      ),
      'return' => '',
    ),
    'SetGroupList' => array(
      'params' => array(
        'IDs' => 'array:int',
        'GroupRef' => 'int',
        'Remark' => 'string',
      ),
      'return' => '',
    ),
    'SetGroup' => array(
      'params' => array(
        'ID' => 'int',
        'GroupRef' => 'int',
        'Remark' => 'string',
      ),
      'return' => '',
    ),
    'SetTrashList' => array(
      'params' => array(
        'IDs' => 'array:int',
        'Value' => 'boolean',
        'Remark' => 'string',
      ),
      'return' => '',
    ),
    'SetTrash' => array(
      'params' => array(
        'ID' => 'int',
        'Value' => 'boolean',
        'Remark' => 'string',
      ),
      'return' => '',
    ),
    'SetStateList' => array(
      'params' => array(
        'IDs' => 'array:int',
        'State' => 'int',
        'Remark' => 'string',
      ),
      'return' => '',
    ),
    'SetState' => array(
      'params' => array(
        'ID' => 'int',
        'State' => 'int',
        'Remark' => 'string',
      ),
      'return' => '',
    ),
    'DeleteList' => array(
      'params' => array(
        'IDs' => 'array:int',
      ),
      'return' => '',
    ),
    'Delete' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => '',
    ),
    'New_' => array(
      'params' => array(
        'Item' => 'GhRpcItemslibRpcDetailedItem',
        'CreateLocked' => 'boolean',
      ),
      'return' => 'int',
    ),
    'PutList' => array(
      'params' => array(
        'Items' => 'array:GhRpcItemslibRpcListItem',
        'ListValues' => 'int',
        'RemindUsers' => 'array:int',
        'Rules' => 'array:int',
        'Remark' => 'string',
        'UnreadForAll' => 'boolean',
        'ListValuesEx' => 'int',
      ),
      'return' => '',
    ),
    'Put' => array(
      'params' => array(
        'Item' => 'GhRpcItemslibRpcDetailedItem',
      ),
      'return' => '',
    ),
    'GetReadingState' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => 'array:GhRpcItemslibRpcReadingUser',
    ),
    'GetModified' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => 'GhRpcDateTime',
    ),
    'GetSyncDetails' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => 'GhRpcItemslibRpcSyncDetails',
    ),
    'GetSyncList' => array(
      'params' => array(
        'GroupRefs' => 'array:int',
      ),
      'return' => 'array:GhRpcItemslibRpcSyncItem',
    ),
    'GetShareList' => array(
      'params' => array(
        'Offset' => 'int',
        'OrderBy' => 'int',
        'OrderDirection' => 'int',
      ),
      'return' => 'array:GhRpcItemslibRpcShareItem',
    ),
    'GetRules' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => 'array:int',
    ),
    'GetReminderList' => array(
      'params' => array(
      ),
      'return' => 'array:GhRpcItemslibRpcReminderItem',
    ),
    'GetContactSalutation' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => 'string',
    ),
    'GetVariables' => array(
      'params' => array(
        'Item' => 'GhRpcItemslibRpcDetailedItem',
      ),
      'return' => 'array:GhRpcItemslibRpcVariableItem',
    ),
    'GetPreviewDif' => array(
      'params' => array(
        'Item' => 'GhRpcItemslibRpcDetailedItem',
      ),
      'return' => 'binary',
    ),
    'GetPreviewHtml' => array(
      'params' => array(
        'Item' => 'GhRpcItemslibRpcDetailedItem',
      ),
      'return' => 'binary',
    ),
    'GetPreviewText' => array(
      'params' => array(
        'Item' => 'GhRpcItemslibRpcDetailedItem',
      ),
      'return' => 'string',
    ),
    'GetUserFieldList' => array(
      'params' => array(
        'ID' => 'int',
        'Kind' => 'int',
      ),
      'return' => 'array:GhRpcItemslibRpcUserFieldItem',
    ),
    'GetSubComLinkList' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => 'array:GhRpcItemslibRpcComLinkItem',
    ),
    'GetComLinkList' => array(
      'params' => array(
        'Search' => 'string',
        'Kinds' => 'int',
        'ListMruItems' => 'boolean',
      ),
      'return' => 'array:GhRpcItemslibRpcComLinkItem',
    ),
    'GetThreadList' => array(
      'params' => array(
        'ID' => 'int',
        'ListValues' => 'int',
        'UserFields' => 'array:int',
        'IncludeReferredItem' => 'boolean',
        'ListValuesEx' => 'int',
      ),
      'return' => 'array:GhRpcItemslibRpcListItem',
    ),
    'GetEventList' => array(
      'params' => array(
        'Filter' => 'GhRpcItemslibRpcItemFilter',
        'VisibleDates' => 'array:GhRpcItemslibGhRpcDateTime',
        'AdvancedFields' => 'boolean',
      ),
      'return' => 'GhRpcItemslibRpcEvents',
    ),
    'GetCardList' => array(
      'params' => array(
        'Filter' => 'GhRpcItemslibRpcItemFilter',
        'OrderBy' => 'int',
        'OrderDirection' => 'int',
        'Offset' => 'int',
        'CardValues' => 'int',
        'UserFields' => 'array:int',
        'OrderUserFieldRef' => 'int',
      ),
      'return' => 'array:GhRpcItemslibRpcCardItem',
    ),
    'GetList' => array(
      'params' => array(
        'Filter' => 'GhRpcItemslibRpcItemFilter',
        'OrderBy' => 'int',
        'OrderDirection' => 'int',
        'Offset' => 'int',
        'ListValues' => 'int',
        'UserFields' => 'array:int',
        'OrderUserFieldRef' => 'int',
        'ListValuesEx' => 'int',
      ),
      'return' => 'array:GhRpcItemslibRpcListItem',
    ),
    'GetAttachmentList' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => 'array:GhRpcItemslibRpcAttachmentItem',
    ),
    'GetOcrBlocks' => array(
      'params' => array(
        'ID' => 'int',
      ),
      'return' => 'binary',
    ),
    'GetAs' => array(
      'params' => array(
        'ID' => 'int',
        'Kind' => 'int',
        'NewState' => 'int',
        'MarkAsReading' => 'boolean',
      ),
      'return' => 'GhRpcItemslibRpcDetailedItem',
    ),
    'Get' => array(
      'params' => array(
        'ID' => 'int',
        'MarkAsReading' => 'boolean',
      ),
      'return' => 'GhRpcItemslibRpcDetailedItem',
    ),
  );


  /**
   * Ruft die RPC-Funktion RpcItems.Get auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param boolean $MarkAsReading
   *
   * @return GhRpcItemslibRpcDetailedItem
   */
  public function Get($ID = 0, $MarkAsReading = false)
  {
    return $this->_sendRpcRequest('RpcItems.Get', array($ID, $MarkAsReading), self::$_rpcMethods['Get']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.GetAs auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param int $Kind
   * @param int $NewState
   * @param boolean $MarkAsReading
   *
   * @return GhRpcItemslibRpcDetailedItem
   */
  public function GetAs($ID = 0, $Kind = 0, $NewState = 0, $MarkAsReading = false)
  {
    return $this->_sendRpcRequest('RpcItems.GetAs', array($ID, $Kind, $NewState, $MarkAsReading), self::$_rpcMethods['GetAs']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.GetOcrBlocks auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   *
   * @return string
   */
  public function GetOcrBlocks($ID = 0)
  {
    return $this->_sendRpcRequest('RpcItems.GetOcrBlocks', array($ID), self::$_rpcMethods['GetOcrBlocks']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.GetAttachmentList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   *
   * @return array
   */
  public function GetAttachmentList($ID = 0)
  {
    return $this->_sendRpcRequest('RpcItems.GetAttachmentList', array($ID), self::$_rpcMethods['GetAttachmentList']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.GetList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param GhRpcItemslibRpcItemFilter $Filter
   * @param int $OrderBy
   * @param int $OrderDirection
   * @param int $Offset
   * @param int $ListValues
   * @param array $UserFields
   * @param int $OrderUserFieldRef
   * @param int $ListValuesEx
   *
   * @return array
   */
  public function GetList(GhRpcItemslibRpcItemFilter $Filter = null, $OrderBy = 0, $OrderDirection = 0, $Offset = 0, $ListValues = 0, array $UserFields = array(), $OrderUserFieldRef = 0, $ListValuesEx = 0)
  {
    return $this->_sendRpcRequest('RpcItems.GetList', array($Filter, $OrderBy, $OrderDirection, $Offset, $ListValues, $UserFields, $OrderUserFieldRef, $ListValuesEx), self::$_rpcMethods['GetList']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.GetCardList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param GhRpcItemslibRpcItemFilter $Filter
   * @param int $OrderBy
   * @param int $OrderDirection
   * @param int $Offset
   * @param int $CardValues
   * @param array $UserFields
   * @param int $OrderUserFieldRef
   *
   * @return array
   */
  public function GetCardList(GhRpcItemslibRpcItemFilter $Filter = null, $OrderBy = 0, $OrderDirection = 0, $Offset = 0, $CardValues = 0, array $UserFields = array(), $OrderUserFieldRef = 0)
  {
    return $this->_sendRpcRequest('RpcItems.GetCardList', array($Filter, $OrderBy, $OrderDirection, $Offset, $CardValues, $UserFields, $OrderUserFieldRef), self::$_rpcMethods['GetCardList']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.GetEventList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param GhRpcItemslibRpcItemFilter $Filter
   * @param array $VisibleDates
   * @param boolean $AdvancedFields
   *
   * @return GhRpcItemslibRpcEvents
   */
  public function GetEventList(GhRpcItemslibRpcItemFilter $Filter = null, array $VisibleDates = array(), $AdvancedFields = false)
  {
    return $this->_sendRpcRequest('RpcItems.GetEventList', array($Filter, $VisibleDates, $AdvancedFields), self::$_rpcMethods['GetEventList']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.GetThreadList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param int $ListValues
   * @param array $UserFields
   * @param boolean $IncludeReferredItem
   * @param int $ListValuesEx
   *
   * @return array
   */
  public function GetThreadList($ID = 0, $ListValues = 0, array $UserFields = array(), $IncludeReferredItem = false, $ListValuesEx = 0)
  {
    return $this->_sendRpcRequest('RpcItems.GetThreadList', array($ID, $ListValues, $UserFields, $IncludeReferredItem, $ListValuesEx), self::$_rpcMethods['GetThreadList']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.GetComLinkList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param string $Search
   * @param int $Kinds
   * @param boolean $ListMruItems
   *
   * @return array
   */
  public function GetComLinkList($Search = '', $Kinds = 0, $ListMruItems = false)
  {
    return $this->_sendRpcRequest('RpcItems.GetComLinkList', array($Search, $Kinds, $ListMruItems), self::$_rpcMethods['GetComLinkList']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.GetSubComLinkList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   *
   * @return array
   */
  public function GetSubComLinkList($ID = 0)
  {
    return $this->_sendRpcRequest('RpcItems.GetSubComLinkList', array($ID), self::$_rpcMethods['GetSubComLinkList']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.GetUserFieldList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param int $Kind
   *
   * @return array
   */
  public function GetUserFieldList($ID = 0, $Kind = 0)
  {
    return $this->_sendRpcRequest('RpcItems.GetUserFieldList', array($ID, $Kind), self::$_rpcMethods['GetUserFieldList']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.GetPreviewText auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param GhRpcItemslibRpcDetailedItem $Item
   *
   * @return string
   */
  public function GetPreviewText(GhRpcItemslibRpcDetailedItem $Item = null)
  {
    return $this->_sendRpcRequest('RpcItems.GetPreviewText', array($Item), self::$_rpcMethods['GetPreviewText']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.GetPreviewHtml auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param GhRpcItemslibRpcDetailedItem $Item
   *
   * @return string
   */
  public function GetPreviewHtml(GhRpcItemslibRpcDetailedItem $Item = null)
  {
    return $this->_sendRpcRequest('RpcItems.GetPreviewHtml', array($Item), self::$_rpcMethods['GetPreviewHtml']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.GetPreviewDif auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param GhRpcItemslibRpcDetailedItem $Item
   *
   * @return string
   */
  public function GetPreviewDif(GhRpcItemslibRpcDetailedItem $Item = null)
  {
    return $this->_sendRpcRequest('RpcItems.GetPreviewDif', array($Item), self::$_rpcMethods['GetPreviewDif']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.GetVariables auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param GhRpcItemslibRpcDetailedItem $Item
   *
   * @return array
   */
  public function GetVariables(GhRpcItemslibRpcDetailedItem $Item = null)
  {
    return $this->_sendRpcRequest('RpcItems.GetVariables', array($Item), self::$_rpcMethods['GetVariables']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.GetContactSalutation auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   *
   * @return string
   */
  public function GetContactSalutation($ID = 0)
  {
    return $this->_sendRpcRequest('RpcItems.GetContactSalutation', array($ID), self::$_rpcMethods['GetContactSalutation']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.GetReminderList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @return array
   */
  public function GetReminderList()
  {
    return $this->_sendRpcRequest('RpcItems.GetReminderList', array(), self::$_rpcMethods['GetReminderList']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.GetRules auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   *
   * @return array
   */
  public function GetRules($ID = 0)
  {
    return $this->_sendRpcRequest('RpcItems.GetRules', array($ID), self::$_rpcMethods['GetRules']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.GetShareList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $Offset
   * @param int $OrderBy
   * @param int $OrderDirection
   *
   * @return array
   */
  public function GetShareList($Offset = 0, $OrderBy = 0, $OrderDirection = 0)
  {
    return $this->_sendRpcRequest('RpcItems.GetShareList', array($Offset, $OrderBy, $OrderDirection), self::$_rpcMethods['GetShareList']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.GetSyncList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param array $GroupRefs
   *
   * @return array
   */
  public function GetSyncList(array $GroupRefs = array())
  {
    return $this->_sendRpcRequest('RpcItems.GetSyncList', array($GroupRefs), self::$_rpcMethods['GetSyncList']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.GetSyncDetails auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   *
   * @return GhRpcItemslibRpcSyncDetails
   */
  public function GetSyncDetails($ID = 0)
  {
    return $this->_sendRpcRequest('RpcItems.GetSyncDetails', array($ID), self::$_rpcMethods['GetSyncDetails']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.GetModified auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   *
   * @return GhRpcDateTime
   */
  public function GetModified($ID = 0)
  {
    return $this->_sendRpcRequest('RpcItems.GetModified', array($ID), self::$_rpcMethods['GetModified']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.GetReadingState auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   *
   * @return array
   */
  public function GetReadingState($ID = 0)
  {
    return $this->_sendRpcRequest('RpcItems.GetReadingState', array($ID), self::$_rpcMethods['GetReadingState']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.Put auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param GhRpcItemslibRpcDetailedItem $Item
   */
  public function Put(GhRpcItemslibRpcDetailedItem $Item = null)
  {
    return $this->_sendRpcRequest('RpcItems.Put', array($Item), self::$_rpcMethods['Put']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.PutList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param array $Items
   * @param int $ListValues
   * @param array $RemindUsers
   * @param array $Rules
   * @param string $Remark
   * @param boolean $UnreadForAll
   * @param int $ListValuesEx
   */
  public function PutList(array $Items = array(), $ListValues = 0, array $RemindUsers = array(), array $Rules = array(), $Remark = '', $UnreadForAll = false, $ListValuesEx = 0)
  {
    return $this->_sendRpcRequest('RpcItems.PutList', array($Items, $ListValues, $RemindUsers, $Rules, $Remark, $UnreadForAll, $ListValuesEx), self::$_rpcMethods['PutList']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.New auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param GhRpcItemslibRpcDetailedItem $Item
   * @param boolean $CreateLocked
   *
   * @return int
   */
  public function New_(GhRpcItemslibRpcDetailedItem $Item = null, $CreateLocked = false)
  {
    return $this->_sendRpcRequest('RpcItems.New', array($Item, $CreateLocked), self::$_rpcMethods['New_']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.Delete auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   */
  public function Delete($ID = 0)
  {
    return $this->_sendRpcRequest('RpcItems.Delete', array($ID), self::$_rpcMethods['Delete']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.DeleteList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param array $IDs
   */
  public function DeleteList(array $IDs = array())
  {
    return $this->_sendRpcRequest('RpcItems.DeleteList', array($IDs), self::$_rpcMethods['DeleteList']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.SetState auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param int $State
   * @param string $Remark
   */
  public function SetState($ID = 0, $State = 0, $Remark = '')
  {
    return $this->_sendRpcRequest('RpcItems.SetState', array($ID, $State, $Remark), self::$_rpcMethods['SetState']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.SetStateList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param array $IDs
   * @param int $State
   * @param string $Remark
   */
  public function SetStateList(array $IDs = array(), $State = 0, $Remark = '')
  {
    return $this->_sendRpcRequest('RpcItems.SetStateList', array($IDs, $State, $Remark), self::$_rpcMethods['SetStateList']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.SetTrash auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param boolean $Value
   * @param string $Remark
   */
  public function SetTrash($ID = 0, $Value = false, $Remark = '')
  {
    return $this->_sendRpcRequest('RpcItems.SetTrash', array($ID, $Value, $Remark), self::$_rpcMethods['SetTrash']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.SetTrashList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param array $IDs
   * @param boolean $Value
   * @param string $Remark
   */
  public function SetTrashList(array $IDs = array(), $Value = false, $Remark = '')
  {
    return $this->_sendRpcRequest('RpcItems.SetTrashList', array($IDs, $Value, $Remark), self::$_rpcMethods['SetTrashList']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.SetGroup auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param int $GroupRef
   * @param string $Remark
   */
  public function SetGroup($ID = 0, $GroupRef = 0, $Remark = '')
  {
    return $this->_sendRpcRequest('RpcItems.SetGroup', array($ID, $GroupRef, $Remark), self::$_rpcMethods['SetGroup']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.SetGroupList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param array $IDs
   * @param int $GroupRef
   * @param string $Remark
   */
  public function SetGroupList(array $IDs = array(), $GroupRef = 0, $Remark = '')
  {
    return $this->_sendRpcRequest('RpcItems.SetGroupList', array($IDs, $GroupRef, $Remark), self::$_rpcMethods['SetGroupList']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.SetUser auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param int $UserRef
   * @param string $Remark
   */
  public function SetUser($ID = 0, $UserRef = 0, $Remark = '')
  {
    return $this->_sendRpcRequest('RpcItems.SetUser', array($ID, $UserRef, $Remark), self::$_rpcMethods['SetUser']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.SetUserList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param array $IDs
   * @param int $UserRef
   * @param string $Remark
   */
  public function SetUserList(array $IDs = array(), $UserRef = 0, $Remark = '')
  {
    return $this->_sendRpcRequest('RpcItems.SetUserList', array($IDs, $UserRef, $Remark), self::$_rpcMethods['SetUserList']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.SetTopic auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param int $TopicRef
   * @param string $Remark
   */
  public function SetTopic($ID = 0, $TopicRef = 0, $Remark = '')
  {
    return $this->_sendRpcRequest('RpcItems.SetTopic', array($ID, $TopicRef, $Remark), self::$_rpcMethods['SetTopic']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.SetTopicList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param array $IDs
   * @param int $TopicRef
   * @param string $Remark
   */
  public function SetTopicList(array $IDs = array(), $TopicRef = 0, $Remark = '')
  {
    return $this->_sendRpcRequest('RpcItems.SetTopicList', array($IDs, $TopicRef, $Remark), self::$_rpcMethods['SetTopicList']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.SetColor auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param int $ColorRef
   * @param string $Remark
   */
  public function SetColor($ID = 0, $ColorRef = 0, $Remark = '')
  {
    return $this->_sendRpcRequest('RpcItems.SetColor', array($ID, $ColorRef, $Remark), self::$_rpcMethods['SetColor']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.SetColorList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param array $IDs
   * @param int $ColorRef
   * @param string $Remark
   */
  public function SetColorList(array $IDs = array(), $ColorRef = 0, $Remark = '')
  {
    return $this->_sendRpcRequest('RpcItems.SetColorList', array($IDs, $ColorRef, $Remark), self::$_rpcMethods['SetColorList']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.SetTemplate auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param int $TemplateRef
   * @param string $Remark
   */
  public function SetTemplate($ID = 0, $TemplateRef = 0, $Remark = '')
  {
    return $this->_sendRpcRequest('RpcItems.SetTemplate', array($ID, $TemplateRef, $Remark), self::$_rpcMethods['SetTemplate']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.SetTemplateList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param array $IDs
   * @param int $TemplateRef
   * @param string $Remark
   */
  public function SetTemplateList(array $IDs = array(), $TemplateRef = 0, $Remark = '')
  {
    return $this->_sendRpcRequest('RpcItems.SetTemplateList', array($IDs, $TemplateRef, $Remark), self::$_rpcMethods['SetTemplateList']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.SetSpam auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param boolean $Value
   * @param string $Remark
   */
  public function SetSpam($ID = 0, $Value = false, $Remark = '')
  {
    return $this->_sendRpcRequest('RpcItems.SetSpam', array($ID, $Value, $Remark), self::$_rpcMethods['SetSpam']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.SetSpamList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param array $IDs
   * @param boolean $Value
   * @param string $Remark
   */
  public function SetSpamList(array $IDs = array(), $Value = false, $Remark = '')
  {
    return $this->_sendRpcRequest('RpcItems.SetSpamList', array($IDs, $Value, $Remark), self::$_rpcMethods['SetSpamList']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.SetRead auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param boolean $Value
   * @param string $Remark
   */
  public function SetRead($ID = 0, $Value = false, $Remark = '')
  {
    return $this->_sendRpcRequest('RpcItems.SetRead', array($ID, $Value, $Remark), self::$_rpcMethods['SetRead']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.SetReadList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param array $IDs
   * @param boolean $Value
   * @param string $Remark
   */
  public function SetReadList(array $IDs = array(), $Value = false, $Remark = '')
  {
    return $this->_sendRpcRequest('RpcItems.SetReadList', array($IDs, $Value, $Remark), self::$_rpcMethods['SetReadList']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.SetUnreadForAll auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param string $Remark
   */
  public function SetUnreadForAll($ID = 0, $Remark = '')
  {
    return $this->_sendRpcRequest('RpcItems.SetUnreadForAll', array($ID, $Remark), self::$_rpcMethods['SetUnreadForAll']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.SetUnreadForAllList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param array $IDs
   * @param string $Remark
   */
  public function SetUnreadForAllList(array $IDs = array(), $Remark = '')
  {
    return $this->_sendRpcRequest('RpcItems.SetUnreadForAllList', array($IDs, $Remark), self::$_rpcMethods['SetUnreadForAllList']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.SetQuestion auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param int $TopicRef
   * @param int $ColorRef
   * @param string $Remark
   */
  public function SetQuestion($ID = 0, $TopicRef = 0, $ColorRef = 0, $Remark = '')
  {
    return $this->_sendRpcRequest('RpcItems.SetQuestion', array($ID, $TopicRef, $ColorRef, $Remark), self::$_rpcMethods['SetQuestion']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.SetQuestionEx auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param int $TopicRef
   * @param int $ColorRef
   * @param int $TextBlockRef
   * @param string $Remark
   */
  public function SetQuestionEx($ID = 0, $TopicRef = 0, $ColorRef = 0, $TextBlockRef = 0, $Remark = '')
  {
    return $this->_sendRpcRequest('RpcItems.SetQuestionEx', array($ID, $TopicRef, $ColorRef, $TextBlockRef, $Remark), self::$_rpcMethods['SetQuestionEx']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.SetQuestionList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param array $IDs
   * @param int $TopicRef
   * @param int $ColorRef
   * @param string $Remark
   */
  public function SetQuestionList(array $IDs = array(), $TopicRef = 0, $ColorRef = 0, $Remark = '')
  {
    return $this->_sendRpcRequest('RpcItems.SetQuestionList', array($IDs, $TopicRef, $ColorRef, $Remark), self::$_rpcMethods['SetQuestionList']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.SetUnclassifiable auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param boolean $Value
   * @param string $Remark
   */
  public function SetUnclassifiable($ID = 0, $Value = false, $Remark = '')
  {
    return $this->_sendRpcRequest('RpcItems.SetUnclassifiable', array($ID, $Value, $Remark), self::$_rpcMethods['SetUnclassifiable']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.SetUnclassifiableList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param array $IDs
   * @param boolean $Value
   * @param string $Remark
   */
  public function SetUnclassifiableList(array $IDs = array(), $Value = false, $Remark = '')
  {
    return $this->_sendRpcRequest('RpcItems.SetUnclassifiableList', array($IDs, $Value, $Remark), self::$_rpcMethods['SetUnclassifiableList']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.SetClassified auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param array $List
   * @param boolean $Unclassifiable
   * @param boolean $SetDocumentSenderFlag
   * @param boolean $SetDocumentReceiverFlag
   * @param string $Remark
   */
  public function SetClassified($ID = 0, array $List = array(), $Unclassifiable = false, $SetDocumentSenderFlag = false, $SetDocumentReceiverFlag = false, $Remark = '')
  {
    return $this->_sendRpcRequest('RpcItems.SetClassified', array($ID, $List, $Unclassifiable, $SetDocumentSenderFlag, $SetDocumentReceiverFlag, $Remark), self::$_rpcMethods['SetClassified']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.SetWaiting auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param boolean $Value
   * @param string $Remark
   */
  public function SetWaiting($ID = 0, $Value = false, $Remark = '')
  {
    return $this->_sendRpcRequest('RpcItems.SetWaiting', array($ID, $Value, $Remark), self::$_rpcMethods['SetWaiting']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.SetWaitingList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param array $IDs
   * @param boolean $Value
   * @param string $Remark
   */
  public function SetWaitingList(array $IDs = array(), $Value = false, $Remark = '')
  {
    return $this->_sendRpcRequest('RpcItems.SetWaitingList', array($IDs, $Value, $Remark), self::$_rpcMethods['SetWaitingList']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.SetDone auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param boolean $Value
   * @param string $Remark
   */
  public function SetDone($ID = 0, $Value = false, $Remark = '')
  {
    return $this->_sendRpcRequest('RpcItems.SetDone', array($ID, $Value, $Remark), self::$_rpcMethods['SetDone']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.SetDoneList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param array $IDs
   * @param boolean $Value
   * @param string $Remark
   */
  public function SetDoneList(array $IDs = array(), $Value = false, $Remark = '')
  {
    return $this->_sendRpcRequest('RpcItems.SetDoneList', array($IDs, $Value, $Remark), self::$_rpcMethods['SetDoneList']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.SetRejected auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param boolean $Value
   * @param string $Remark
   */
  public function SetRejected($ID = 0, $Value = false, $Remark = '')
  {
    return $this->_sendRpcRequest('RpcItems.SetRejected', array($ID, $Value, $Remark), self::$_rpcMethods['SetRejected']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.SetRejectedList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param array $IDs
   * @param boolean $Value
   * @param string $Remark
   */
  public function SetRejectedList(array $IDs = array(), $Value = false, $Remark = '')
  {
    return $this->_sendRpcRequest('RpcItems.SetRejectedList', array($IDs, $Value, $Remark), self::$_rpcMethods['SetRejectedList']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.SetEscalated auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param boolean $Value
   * @param string $Remark
   */
  public function SetEscalated($ID = 0, $Value = false, $Remark = '')
  {
    return $this->_sendRpcRequest('RpcItems.SetEscalated', array($ID, $Value, $Remark), self::$_rpcMethods['SetEscalated']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.SetEscalatedList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param array $IDs
   * @param boolean $Value
   * @param string $Remark
   */
  public function SetEscalatedList(array $IDs = array(), $Value = false, $Remark = '')
  {
    return $this->_sendRpcRequest('RpcItems.SetEscalatedList', array($IDs, $Value, $Remark), self::$_rpcMethods['SetEscalatedList']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.SetNumber auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param string $Value
   * @param boolean $AllItemsInTask
   * @param string $Remark
   */
  public function SetNumber($ID = 0, $Value = '', $AllItemsInTask = false, $Remark = '')
  {
    return $this->_sendRpcRequest('RpcItems.SetNumber', array($ID, $Value, $AllItemsInTask, $Remark), self::$_rpcMethods['SetNumber']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.SetNumberList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param array $IDs
   * @param string $Value
   * @param boolean $AllItemsInTask
   * @param string $Remark
   */
  public function SetNumberList(array $IDs = array(), $Value = '', $AllItemsInTask = false, $Remark = '')
  {
    return $this->_sendRpcRequest('RpcItems.SetNumberList', array($IDs, $Value, $AllItemsInTask, $Remark), self::$_rpcMethods['SetNumberList']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.SetUserField auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param int $FieldRef
   * @param string $Value
   * @param string $Remark
   */
  public function SetUserField($ID = 0, $FieldRef = 0, $Value = '', $Remark = '')
  {
    return $this->_sendRpcRequest('RpcItems.SetUserField', array($ID, $FieldRef, $Value, $Remark), self::$_rpcMethods['SetUserField']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.SetUserFields auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param array $UserFields
   * @param string $Remark
   */
  public function SetUserFields($ID = 0, array $UserFields = array(), $Remark = '')
  {
    return $this->_sendRpcRequest('RpcItems.SetUserFields', array($ID, $UserFields, $Remark), self::$_rpcMethods['SetUserFields']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.SetUserFieldList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param array $IDs
   * @param int $FieldRef
   * @param string $Value
   * @param string $Remark
   */
  public function SetUserFieldList(array $IDs = array(), $FieldRef = 0, $Value = '', $Remark = '')
  {
    return $this->_sendRpcRequest('RpcItems.SetUserFieldList', array($IDs, $FieldRef, $Value, $Remark), self::$_rpcMethods['SetUserFieldList']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.SetPeriod auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param GhRpcDateTime $StartDate
   * @param GhRpcDateTime $EndDate
   * @param string $Remark
   */
  public function SetPeriod($ID = 0, GhRpcDateTime $StartDate = null, GhRpcDateTime $EndDate = null, $Remark = '')
  {
    return $this->_sendRpcRequest('RpcItems.SetPeriod', array($ID, $StartDate, $EndDate, $Remark), self::$_rpcMethods['SetPeriod']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.SetPeriodList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param array $IDs
   * @param GhRpcDateTime $StartDate
   * @param GhRpcDateTime $EndDate
   * @param string $Remark
   */
  public function SetPeriodList(array $IDs = array(), GhRpcDateTime $StartDate = null, GhRpcDateTime $EndDate = null, $Remark = '')
  {
    return $this->_sendRpcRequest('RpcItems.SetPeriodList', array($IDs, $StartDate, $EndDate, $Remark), self::$_rpcMethods['SetPeriodList']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.SetReadingState auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   */
  public function SetReadingState($ID = 0)
  {
    return $this->_sendRpcRequest('RpcItems.SetReadingState', array($ID), self::$_rpcMethods['SetReadingState']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.SetSubject auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param string $Value
   * @param string $Remark
   */
  public function SetSubject($ID = 0, $Value = '', $Remark = '')
  {
    return $this->_sendRpcRequest('RpcItems.SetSubject', array($ID, $Value, $Remark), self::$_rpcMethods['SetSubject']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.AddRemark auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param string $Remark
   */
  public function AddRemark($ID = 0, $Remark = '')
  {
    return $this->_sendRpcRequest('RpcItems.AddRemark', array($ID, $Remark), self::$_rpcMethods['AddRemark']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.AddRemarkList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param array $IDs
   * @param string $Remark
   */
  public function AddRemarkList(array $IDs = array(), $Remark = '')
  {
    return $this->_sendRpcRequest('RpcItems.AddRemarkList', array($IDs, $Remark), self::$_rpcMethods['AddRemarkList']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.AddProtocol auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param string $Protocol
   */
  public function AddProtocol($ID = 0, $Protocol = '')
  {
    return $this->_sendRpcRequest('RpcItems.AddProtocol', array($ID, $Protocol), self::$_rpcMethods['AddProtocol']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.AddProtocolList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param array $IDs
   * @param string $Protocol
   */
  public function AddProtocolList(array $IDs = array(), $Protocol = '')
  {
    return $this->_sendRpcRequest('RpcItems.AddProtocolList', array($IDs, $Protocol), self::$_rpcMethods['AddProtocolList']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.AddComLink auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param GhRpcItemslibRpcComLinkItem $ComLink
   */
  public function AddComLink(GhRpcItemslibRpcComLinkItem $ComLink = null)
  {
    return $this->_sendRpcRequest('RpcItems.AddComLink', array($ComLink), self::$_rpcMethods['AddComLink']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.AddClassified auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param int $ItemRef
   * @param int $Kind
   * @param boolean $SetDocumentSenderFlag
   * @param boolean $SetDocumentReceiverFlag
   * @param string $Remark
   */
  public function AddClassified($ID = 0, $ItemRef = 0, $Kind = 0, $SetDocumentSenderFlag = false, $SetDocumentReceiverFlag = false, $Remark = '')
  {
    return $this->_sendRpcRequest('RpcItems.AddClassified', array($ID, $ItemRef, $Kind, $SetDocumentSenderFlag, $SetDocumentReceiverFlag, $Remark), self::$_rpcMethods['AddClassified']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.DeleteClassified auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param int $ItemRef
   * @param string $Remark
   */
  public function DeleteClassified($ID = 0, $ItemRef = 0, $Remark = '')
  {
    return $this->_sendRpcRequest('RpcItems.DeleteClassified', array($ID, $ItemRef, $Remark), self::$_rpcMethods['DeleteClassified']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.AddShare auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param GhRpcItemslibRpcShareItem $Item
   *
   * @return string
   */
  public function AddShare(GhRpcItemslibRpcShareItem $Item = null)
  {
    return $this->_sendRpcRequest('RpcItems.AddShare', array($Item), self::$_rpcMethods['AddShare']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.DeleteShare auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   */
  public function DeleteShare($ID = 0)
  {
    return $this->_sendRpcRequest('RpcItems.DeleteShare', array($ID), self::$_rpcMethods['DeleteShare']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.CopyAttachment auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $AttachmentID
   * @param int $TargetID
   * @param int $RevGroup
   *
   * @return int
   */
  public function CopyAttachment($AttachmentID = 0, $TargetID = 0, $RevGroup = 0)
  {
    return $this->_sendRpcRequest('RpcItems.CopyAttachment', array($AttachmentID, $TargetID, $RevGroup), self::$_rpcMethods['CopyAttachment']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.DeleteAttachment auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $AttachmentID
   * @param boolean $DeleteRevGroup
   */
  public function DeleteAttachment($AttachmentID = 0, $DeleteRevGroup = false)
  {
    return $this->_sendRpcRequest('RpcItems.DeleteAttachment', array($AttachmentID, $DeleteRevGroup), self::$_rpcMethods['DeleteAttachment']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.RenameAttachment auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $AttachmentID
   * @param string $Name
   */
  public function RenameAttachment($AttachmentID = 0, $Name = '')
  {
    return $this->_sendRpcRequest('RpcItems.RenameAttachment', array($AttachmentID, $Name), self::$_rpcMethods['RenameAttachment']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.ExecuteRule auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param int $RuleID
   */
  public function ExecuteRule($ID = 0, $RuleID = 0)
  {
    return $this->_sendRpcRequest('RpcItems.ExecuteRule', array($ID, $RuleID), self::$_rpcMethods['ExecuteRule']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.ExecuteRuleList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param array $IDs
   * @param int $RuleID
   */
  public function ExecuteRuleList(array $IDs = array(), $RuleID = 0)
  {
    return $this->_sendRpcRequest('RpcItems.ExecuteRuleList', array($IDs, $RuleID), self::$_rpcMethods['ExecuteRuleList']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.UpdateReminder auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ReminderID
   * @param int $SecondsDelta
   */
  public function UpdateReminder($ReminderID = 0, $SecondsDelta = 0)
  {
    return $this->_sendRpcRequest('RpcItems.UpdateReminder', array($ReminderID, $SecondsDelta), self::$_rpcMethods['UpdateReminder']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.DeleteReminder auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ReminderID
   */
  public function DeleteReminder($ReminderID = 0)
  {
    return $this->_sendRpcRequest('RpcItems.DeleteReminder', array($ReminderID), self::$_rpcMethods['DeleteReminder']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.Lock auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   */
  public function Lock($ID = 0)
  {
    return $this->_sendRpcRequest('RpcItems.Lock', array($ID), self::$_rpcMethods['Lock']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.LockList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param array $IDs
   */
  public function LockList(array $IDs = array())
  {
    return $this->_sendRpcRequest('RpcItems.LockList', array($IDs), self::$_rpcMethods['LockList']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.Unlock auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   */
  public function Unlock($ID = 0)
  {
    return $this->_sendRpcRequest('RpcItems.Unlock', array($ID), self::$_rpcMethods['Unlock']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.UnlockList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param array $IDs
   */
  public function UnlockList(array $IDs = array())
  {
    return $this->_sendRpcRequest('RpcItems.UnlockList', array($IDs), self::$_rpcMethods['UnlockList']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.GetLockData auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   *
   * @return GhRpcItemslibRpcLockData
   */
  public function GetLockData($ID = 0)
  {
    return $this->_sendRpcRequest('RpcItems.GetLockData', array($ID), self::$_rpcMethods['GetLockData']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.GetLockDataList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param array $IDs
   *
   * @return array
   */
  public function GetLockDataList(array $IDs = array())
  {
    return $this->_sendRpcRequest('RpcItems.GetLockDataList', array($IDs), self::$_rpcMethods['GetLockDataList']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.GetViewOption auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   *
   * @return GhRpcItemslibRpcViewOptionItem
   */
  public function GetViewOption($ID = 0)
  {
    return $this->_sendRpcRequest('RpcItems.GetViewOption', array($ID), self::$_rpcMethods['GetViewOption']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.GetViewOptionList auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @return array
   */
  public function GetViewOptionList()
  {
    return $this->_sendRpcRequest('RpcItems.GetViewOptionList', array(), self::$_rpcMethods['GetViewOptionList']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.NewViewOption auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param GhRpcItemslibRpcViewOptionItem $ViewOption
   *
   * @return int
   */
  public function NewViewOption(GhRpcItemslibRpcViewOptionItem $ViewOption = null)
  {
    return $this->_sendRpcRequest('RpcItems.NewViewOption', array($ViewOption), self::$_rpcMethods['NewViewOption']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.PutViewOption auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param GhRpcItemslibRpcViewOptionItem $ViewOption
   */
  public function PutViewOption(GhRpcItemslibRpcViewOptionItem $ViewOption = null)
  {
    return $this->_sendRpcRequest('RpcItems.PutViewOption', array($ViewOption), self::$_rpcMethods['PutViewOption']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.DeleteViewOption auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   */
  public function DeleteViewOption($ID = 0)
  {
    return $this->_sendRpcRequest('RpcItems.DeleteViewOption', array($ID), self::$_rpcMethods['DeleteViewOption']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.AddViewOptionFilter auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param int $FilterRef
   */
  public function AddViewOptionFilter($ID = 0, $FilterRef = 0)
  {
    return $this->_sendRpcRequest('RpcItems.AddViewOptionFilter', array($ID, $FilterRef), self::$_rpcMethods['AddViewOptionFilter']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.LockViewOption auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   */
  public function LockViewOption($ID = 0)
  {
    return $this->_sendRpcRequest('RpcItems.LockViewOption', array($ID), self::$_rpcMethods['LockViewOption']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.UnlockViewOption auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   */
  public function UnlockViewOption($ID = 0)
  {
    return $this->_sendRpcRequest('RpcItems.UnlockViewOption', array($ID), self::$_rpcMethods['UnlockViewOption']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.GetViewOptionLockData auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   *
   * @return GhRpcItemslibRpcLockData
   */
  public function GetViewOptionLockData($ID = 0)
  {
    return $this->_sendRpcRequest('RpcItems.GetViewOptionLockData', array($ID), self::$_rpcMethods['GetViewOptionLockData']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.AddMruAddressItem auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $Kind
   * @param string $Text
   */
  public function AddMruAddressItem($Kind = 0, $Text = '')
  {
    return $this->_sendRpcRequest('RpcItems.AddMruAddressItem', array($Kind, $Text), self::$_rpcMethods['AddMruAddressItem']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.AddMruAddressItems auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $Kind
   * @param array $Texts
   */
  public function AddMruAddressItems($Kind = 0, array $Texts = array())
  {
    return $this->_sendRpcRequest('RpcItems.AddMruAddressItems', array($Kind, $Texts), self::$_rpcMethods['AddMruAddressItems']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.DeleteMruAddressItem auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $Kind
   * @param string $Text
   */
  public function DeleteMruAddressItem($Kind = 0, $Text = '')
  {
    return $this->_sendRpcRequest('RpcItems.DeleteMruAddressItem', array($Kind, $Text), self::$_rpcMethods['DeleteMruAddressItem']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.ExtractDocumentData auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param int $Kinds
   *
   * @return GhRpcItemslibRpcAnalyzeDocumentData
   */
  public function ExtractDocumentData($ID = 0, $Kinds = 0)
  {
    return $this->_sendRpcRequest('RpcItems.ExtractDocumentData', array($ID, $Kinds), self::$_rpcMethods['ExtractDocumentData']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.TriggerRules auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param int $Trigger
   * @param boolean $DeleteExistingWorkflowRules
   */
  public function TriggerRules($ID = 0, $Trigger = 0, $DeleteExistingWorkflowRules = false)
  {
    return $this->_sendRpcRequest('RpcItems.TriggerRules', array($ID, $Trigger, $DeleteExistingWorkflowRules), self::$_rpcMethods['TriggerRules']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.SetStateByTaskNumber auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param int $ID
   * @param int $OldState
   * @param int $NewState
   * @param boolean $IncludeReferredItem
   */
  public function SetStateByTaskNumber($ID = 0, $OldState = 0, $NewState = 0, $IncludeReferredItem = false)
  {
    return $this->_sendRpcRequest('RpcItems.SetStateByTaskNumber', array($ID, $OldState, $NewState, $IncludeReferredItem), self::$_rpcMethods['SetStateByTaskNumber']);
  }

  /**
   * Ruft die RPC-Funktion RpcItems.GetLastModifiedForTaskNumber auf.
   *
   * @throws GhRpcConnectionException falls beim Senden der RPC-Anfrage ein Fehler auftrat
   * @throws GhRpcException falls beim Verarbeiten der RPC-Daten oder des Ergebnisses ein Fehler auftrat
   *
   * @param string $Number
   *
   * @return GhRpcDateTime
   */
  public function GetLastModifiedForTaskNumber($Number = '')
  {
    return $this->_sendRpcRequest('RpcItems.GetLastModifiedForTaskNumber', array($Number), self::$_rpcMethods['GetLastModifiedForTaskNumber']);
  }
}
